************************************************************************
* File (nc_ha_1313_42.f) created on Wed Feb  6 20:51:17 CET 2008.
************************************************************************
* This is the FORTRAN module (nc_ha_1313_42) to calculate differential
* hard photon Bremsstrahlung for up + up -> h + z process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ha_1313_42 (s,spr,ph3,costh3,costh5,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 af,vf,sq,sqspr
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph3,sinph3,cosph3,costh3,sinth3,costh5,sinth5

      real*8 sqrtlsupup,isqrtlsupup,sqrtlsprzh,isqrtlsprzh
      complex*16 propzspr,propizspr,propzsprc
      real*8 iz1up,iz2up,iz3h,iz4z

      cmz2 = mz2

      af = aup
      vf = vup

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      sinth3 = dsqrt(1d0-costh3**2)
      sinth5 = dsqrt(1d0-costh5**2)

      propizspr = (cmz2-spr)
      propzspr = 1d0/propizspr
      propzsprc = dconjg(propzspr)
      sqrtlsupup = sqrt(s**2-2d0*s*(rupm2+rupm2)+(rupm2-rupm2)**2)
      isqrtlsupup = 1d0/sqrtlsupup
      sqrtlsprzh = sqrt(spr**2-2d0*spr*(rzm2+rhm2)+(rzm2-rhm2)**2)
      isqrtlsprzh = 1d0/sqrtlsprzh

      iz1up=
     & +1d0/(mup**2/s+1d0/4*sinth5**2-sinth5**2*mup**2/s)/(s-spr)*(1d0/2
     & +1d0/2*costh5*sqrtlsupup/s)

      iz2up=
     & +1d0/(mup**2/s+1d0/4*sinth5**2-sinth5**2*mup**2/s)/(s-spr)*(1d0/2
     & -1d0/2*costh5*sqrtlsupup/s)

      p1p2=
     & -1d0/2*s

      p1p3=
     & +(s-spr)*(1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(-1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh5*(s-spr)*(-1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & -1d0/4*mz**2+1d0/4*mh**2-1d0/4*s

      p1p4=
     & +(s-spr)*(1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(-1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh5*(s-spr)*(-1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & +1d0/4*mz**2-1d0/4*mh**2-1d0/4*s

      p2p3=
     & +(s-spr)*(1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(-1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh5*(s-spr)*(1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & -1d0/4*mz**2+1d0/4*mh**2-1d0/4*s

      p2p4=
     & +(s-spr)*(1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(-1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh5*(s-spr)*(1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & +1d0/4*mz**2-1d0/4*mh**2-1d0/4*s

      p3p4=
     & +(s-spr)*(1d0/2)
     & +1d0/2*mz**2+1d0/2*mh**2-1d0/2*s

      p1p5=
     & +(s-spr)*(-1d0/4)
     & +costh5*(s-spr)*(1d0/4)

      p2p5=
     & +(s-spr)*(-1d0/4)
     & +costh5*(s-spr)*(-1d0/4)

      p3p5=
     & +(s-spr)*(-1d0/4-1d0/4*mz**2/spr+1d0/4*mh**2/spr)
     & +costh3*sqrtlsprzh*(s-spr)*(1d0/4/spr)

      p4p5=
     & +(s-spr)*(-1d0/4+1d0/4*mz**2/spr-1d0/4*mh**2/spr)
     & +costh3*sqrtlsprzh*(s-spr)*(-1d0/4/spr)

      hard=
     & +iz1up**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**4*qup**2*mup**2/s**2/spr*(s-spr)*(1d0/1536*p1p2*mz**2-
     & 1d0/768*p1p3*p2p3+1d0/768*p2p3*p3p5)
     & +iz1up**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**4*qup**2*mup**2/s**2/spr*(s-spr)**2*(1d0/3072*mz**2)
     & +iz1up*iz2up*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*al
     & pha*g**4/ctw**4*qup**2/s**2/spr*(s-spr)*(-1d0/384*p1p2*p1p3*p2p3+
     & 1d0/768*p1p2*p1p3*p3p5+1d0/768*p1p2*p2p3*p3p5+1d0/768*p1p2**2*mz*
     & *2)
     & +iz1up*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**4*qup**2/s**2/spr*(s-spr)*(1d0/1536*p1p2*mz**2-1d0/1536*p
     & 1p3*p2p3+1d0/1536*p1p3**2+1d0/1536*p2p3*p3p5)
     & +iz1up*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**4*qup**2/s**2/spr*(s-spr)**2*(1d0/6144*mz**2)
     & +iz2up**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**4*qup**2*mup**2/s**2/spr*(s-spr)*(1d0/1536*p1p2*mz**2-
     & 1d0/768*p1p3*p2p3+1d0/768*p1p3*p3p5)
     & +iz2up**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**4*qup**2*mup**2/s**2/spr*(s-spr)**2*(1d0/3072*mz**2)
     & +iz2up*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**4*qup**2/s**2/spr*(s-spr)*(1d0/1536*p1p2*mz**2-1d0/1536*p
     & 1p3*p2p3+1d0/1536*p1p3*p3p5+1d0/1536*p2p3**2)
     & +iz2up*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**4*qup**2/s**2/spr*(s-spr)**2*(1d0/6144*mz**2)
     & +propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g**4/ctw
     & **4*qup**2/s**2/spr*(s-spr)*(-1d0/3072*mz**2)

      hard = hard*conhc

      return
      end
