************************************************************************
* File (nc_ff_1313_1616.F) created on Fri Nov  2 10:59:55 CET 2007.
************************************************************************
* This is the FORTRAN module (nc_ff_1313_1616) to calculate 1-loop EW
* form factors for up + up -> mo + mo process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2007.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_1313_1616 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_qed_ll,ff_qed_lq,ff_qed_ql,ff_qed_qq,ff_qed_ld
      complex*16 ff_qed_qd,ff_ew_ll,ff_ew_ld,ff_ew_lq,ff_ew_ql,ff_ew_qq
      complex*16 ff_ew_qd,ff_qed_gg
      real*8 isr,ifi,fsr

      real*8 det3imomoqs
      real*8 a0fmo,a0fup,a0fw,a0fz,a0fh
      real*8 lnlaupm,lnlamom
      complex*16 b0pmozmo,b0pmohmo,b0pmocw
      complex*16 b0fqsmomo,b0fmozmo,b0fmomoc,b0ftsmoc,b0fusmoc,b0fqszc,
     & b0fqscc,b0fmowc,b0fmohmo,b0fqsww,b0fqszh,b0fqszz
      complex*16 c0cmotsczmo,c0cmousczmo,c0upupqszupc,c0upupqscupc,c0mo
     & moqszmoc,c0momoqscmoc,c0irupupqs,c0irupmots,c0irupmous,c0irmomoqs
     & ,c0irmoupts,c0irmoupus,c0momoqswcw,c0momoqszmoh,c0momoqsmozmo,c0m
     & omoqsmohmo,c0momoqscwc,c0momoqszmoz,c0ccqszcz,c0ccqswcw,c0ccqscwc
     & ,c0ccqsczc
      complex*16 b0d1momoz
      complex*16 b0dwmocw
      complex*16 d0ccmomoqstszczmo,d0ccmomoqsuszczmo,d0ccmomoqsuswcwc
      complex*16 jaaqstsupmo,jaaqsusupmo,javqstsupmoz,javqsusupmoz
      real*8 sdet3icmots,sdet3icmous,sdet4imotsus,sdet3imomoqs
      real*8 sdet3cmots,sdet3cmous
      real*8 pxx2zqsc
      complex*16 propzqs,propizqs,prop1zqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      if (iqed.eq.1) then
         isr = 1d0
         ifi = 1d0
         fsr = 1d0
      elseif(iqed.eq.2) then
         isr = 1d0
         ifi = 0d0
         fsr = 0d0
      elseif(iqed.eq.3) then
         isr = 0d0
         ifi = 1d0
         fsr = 0d0
      elseif(iqed.eq.4) then
         isr = 0d0
         ifi = 0d0
         fsr = 1d0
      else
         isr = 0d0
         ifi = 0d0
         fsr = 0d0
      endif

      cmz2 = mz2

      prop1zqs = (cmz2+qs)
      propizqs = (rzm2+qs)
      propzqs = 1d0/propizqs
      det3imomoqs = 1d0/(-1d0/4d0*((-rmom2)**2+(-rmom2)**2+(qs)**2
     & -2d0*(-rmom2)*(-rmom2)-2d0*(-rmom2)*(qs)
     & -2d0*(-rmom2)*(qs)))
      a0fmo = log(rmom2/thmu2) - 1d0
      a0fup = log(rupm2/thmu2) - 1d0
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      lnlaupm = log(rupm2/tlmu2)
      lnlamom = log(rmom2/tlmu2)
      b0pmozmo = b0p(-rmom2,zm2,mom2)
      b0pmohmo = b0p(-rmom2,hm2,mom2)
      b0pmocw = b0p(-rmom2,cm2,wm2)
      b0fqsmomo = b0f(qs,thmu2,mom2,mom2)
      b0fmozmo = b0f(-rmom2,thmu2,zm2,mom2)
      b0fmomoc = b0f(-rmom2,thmu2,mom2,cm2)
      b0ftsmoc = b0f(ts,thmu2,mom2,cm2)
      b0fusmoc = b0f(us,thmu2,mom2,cm2)
      b0fqszc = b0f(qs,thmu2,zm2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      b0fmowc = b0f(-rmom2,thmu2,wm2,cm2)
      b0fmohmo = b0f(-rmom2,thmu2,hm2,mom2)
      b0fqsww = b0f(qs,thmu2,wm2,wm2)
      b0fqszh = b0f(qs,thmu2,zm2,hm2)
      b0fqszz = b0f(qs,thmu2,zm2,zm2)
      c0cmotsczmo = -c0(0d0,rmom2,-ts,0d0,rzm2,rmom2)
      c0cmousczmo = -c0(0d0,rmom2,-us,0d0,rzm2,rmom2)
      c0upupqszupc = -c0(rupm2,rupm2,-qs,rzm2,rupm2,0d0)
      c0upupqscupc = -c0(rupm2,rupm2,-qs,0d0,rupm2,0d0)
      c0momoqszmoc = -c0(rmom2,rmom2,-qs,rzm2,rmom2,0d0)
      c0momoqscmoc = -c0(rmom2,rmom2,-qs,0d0,rmom2,0d0)
      c0irupupqs = c0ir(tlmu2,upm2,upm2,qs)
      c0irupmots = c0ir(tlmu2,upm2,mom2,ts)
      c0irupmous = c0ir(tlmu2,upm2,mom2,us)
      c0irmomoqs = c0ir(tlmu2,mom2,mom2,qs)
      c0irmoupts = c0ir(tlmu2,mom2,upm2,ts)
      c0irmoupus = c0ir(tlmu2,mom2,upm2,us)
      c0momoqswcw = -c0(rmom2,rmom2,-qs,rwm2,0d0,rwm2)
      c0momoqszmoh = -c0(rmom2,rmom2,-qs,rzm2,rmom2,rhm2)
      c0momoqsmozmo = -c0(rmom2,rmom2,-qs,rmom2,rzm2,rmom2)
      c0momoqsmohmo = -c0(rmom2,rmom2,-qs,rmom2,rhm2,rmom2)
      c0momoqscwc = -c0(rmom2,rmom2,-qs,0d0,rwm2,0d0)
      c0momoqszmoz = -c0(rmom2,rmom2,-qs,rzm2,rmom2,rzm2)
      c0ccqszcz = -c0(0d0,0d0,-qs,rzm2,0d0,rzm2)
      c0ccqswcw = -c0(0d0,0d0,-qs,rwm2,0d0,rwm2)
      c0ccqscwc = -c0(0d0,0d0,-qs,0d0,rwm2,0d0)
      c0ccqsczc = -c0(0d0,0d0,-qs,0d0,rzm2,0d0)
      b0d1momoz = b0d1(-rmom2,thmu2,mom2,zm2)
      b0dwmocw = b0dw(-rmom2,thmu2,cm2,wm2)
      d0ccmomoqstszczmo =
     & d0(0d0,0d0,rmom2,rmom2,-qs,-ts,rzm2,0d0,rzm2,rmom2)
      d0ccmomoqsuszczmo =
     & d0(0d0,0d0,rmom2,rmom2,-qs,-us,rzm2,0d0,rzm2,rmom2)
      d0ccmomoqsuswcwc =
     & d0(0d0,0d0,rmom2,rmom2,-qs,-us,rwm2,0d0,rwm2,0d0)
      jaaqstsupmo = jaa(qs,ts,upm2,mom2)
      jaaqsusupmo = jaa(qs,us,upm2,mom2)
      javqstsupmoz = jav(qs,ts,upm2,mom2,cmz2)
      javqsusupmoz = jav(qs,us,upm2,mom2,cmz2)
      sdet3icmots = 1d0/(ts+(mmo)**2)
      sdet3icmous = 1d0/(us+(mmo)**2)
      sdet4imotsus = 1d0/(ts*us-mmo**4)
      sdet3imomoqs = 1d0/(qs+(mmo+mmo)**2)
      sdet3cmots = (ts+mmo**2)
      sdet3cmous = (us+mmo**2)
      pxx2zqsc = (2*mz**2)+(qs)

      ff_qed_gg =
     & +stw**2*piggfer-za1fer

      ff_qed_ll=
     & +isr*(-stw**2*qup**2)
     & +fsr*(-stw**2*qmo**2)
     & +det3imomoqs*fsr*(2*stw**2*qmo**2*qs*mmo**2)
     & +det3imomoqs*a0fmo*fsr*(-2*stw**2*qmo**2*qs*mmo**2)
     & +det3imomoqs*b0fqsmomo*fsr*(-2*stw**2*qmo**2*qs*mmo**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw
     & **2*qup*vpaup*qmo*vpamo*ts*mz**2*mmo**2-4*stw**2*qup*vmaup*qmo*vm
     & amo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*vpamo*ts*mmo**2-4*stw**2*qup*vpaup*qmo*vpamo*mmo**
     & 4-4*stw**2*qup*vmaup*qmo*vmamo*ts*mmo**2-4*stw**2*qup*vmaup*qmo*v
     & mamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*vpamo*ts*mmo**2-4*stw**2*qup*vpaup*qmo*vpamo*mmo**
     & 4-4*stw**2*qup*vmaup*qmo*vmamo*ts*mmo**2-4*stw**2*qup*vmaup*qmo*v
     & mamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(8*stw**2*
     & qup*vpaup*qmo*vpamo*ts*mmo**2+8*stw**2*qup*vpaup*qmo*vpamo*mmo**4
     & +8*stw**2*qup*vmaup*qmo*vmamo*ts*mmo**2+8*stw**2*qup*vmaup*qmo*vm
     & amo*mmo**4)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*vpaup
     & *qmo*vpamo/qs*mz**2*mmo**2-4*stw**2*qup*vmaup*qmo*vmamo/qs*mz**2*
     & mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(-4*stw
     & **2*qup*vpaup*qmo*vmamo*us*mz**2*mmo**2-4*stw**2*qup*vmaup*qmo*vp
     & amo*us*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*vmamo*us*mmo**2-4*stw**2*qup*vpaup*qmo*vmamo*mmo**
     & 4-4*stw**2*qup*vmaup*qmo*vpamo*us*mmo**2-4*stw**2*qup*vmaup*qmo*v
     & pamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*vmamo*us*mmo**2-4*stw**2*qup*vpaup*qmo*vmamo*mmo**
     & 4-4*stw**2*qup*vmaup*qmo*vpamo*us*mmo**2-4*stw**2*qup*vmaup*qmo*v
     & pamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(8*stw**2*
     & qup*vpaup*qmo*vmamo*us*mmo**2+8*stw**2*qup*vpaup*qmo*vmamo*mmo**4
     & +8*stw**2*qup*vmaup*qmo*vpamo*us*mmo**2+8*stw**2*qup*vmaup*qmo*vp
     & amo*mmo**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*vpaup
     & *qmo*vmamo/qs*mz**2*mmo**2-4*stw**2*qup*vmaup*qmo*vpamo/qs*mz**2*
     & mmo**2)
     & +sdet4imotsus**2*jaaqstsupmo*dreal(propizqs)*ifi*cfscheme*(8*sdet
     & 3cmots**3*stw**4*ctw**2*qup**2*qmo**2*ts-8*sdet3cmots**3*stw**4*c
     & tw**2*qup**2*qmo**2*us)
     & +sdet4imotsus**2*jaaqsusupmo*dreal(propizqs)*ifi*cfscheme*(-8*sde
     & t3cmous**3*stw**4*ctw**2*qup**2*qmo**2*ts+8*sdet3cmous**3*stw**4*
     & ctw**2*qup**2*qmo**2*us)
     & +sdet4imotsus**2*javqstsupmoz*dreal(propizqs)*ifi*(-2*sdet3cmots*
     & stw**2*qup*vpaup*qmo*vpamo*qs*ts**2+2*sdet3cmots*stw**2*qup*vpaup
     & *qmo*vpamo*qs*mmo**4-2*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*ts**
     & 2*mz**2+2*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*mz**2*mmo**4-2*sd
     & et3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*ts**2+2*sdet3cmots*stw**2*
     & qup*vmaup*qmo*vmamo*qs*mmo**4-2*sdet3cmots*stw**2*qup*vmaup*qmo*v
     & mamo*ts**2*mz**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*mz**2*mm
     & o**4)
     & +sdet4imotsus**2*javqsusupmoz*dreal(propizqs)*ifi*(-2*sdet3cmous*
     & stw**2*qup*vpaup*qmo*vmamo*qs*us**2+2*sdet3cmous*stw**2*qup*vpaup
     & *qmo*vmamo*qs*mmo**4-2*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*us**
     & 2*mz**2+2*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*mz**2*mmo**4-2*sd
     & et3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us**2+2*sdet3cmous*stw**2*
     & qup*vmaup*qmo*vpamo*qs*mmo**4-2*sdet3cmous*stw**2*qup*vmaup*qmo*v
     & pamo*us**2*mz**2+2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*mz**2*mm
     & o**4)
     & +sdet4imotsus**2*c0upupqszupc*dreal(propizqs)*ifi*(2*sdet3cmots*s
     & tw**2*qup*vpaup*qmo*vpamo*qs*ts*mmo**2-2*sdet3cmots*stw**2*qup*vp
     & aup*qmo*vpamo*qs*us*mmo**2+2*sdet3cmots*stw**2*qup*vpaup*qmo*vpam
     & o*ts*mz**2*mmo**2-2*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*us*mz**
     & 2*mmo**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*ts*mmo**2-2*s
     & det3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*us*mmo**2+2*sdet3cmots*st
     & w**2*qup*vmaup*qmo*vmamo*ts*mz**2*mmo**2-2*sdet3cmots*stw**2*qup*
     & vmaup*qmo*vmamo*us*mz**2*mmo**2+2*sdet3cmots**2*stw**2*qup*vpaup*
     & qmo*vpamo*qs*ts-2*sdet3cmots**2*stw**2*qup*vpaup*qmo*vpamo*qs*mmo
     & **2+2*sdet3cmots**2*stw**2*qup*vpaup*qmo*vpamo*ts*mz**2-2*sdet3cm
     & ots**2*stw**2*qup*vpaup*qmo*vpamo*mz**2*mmo**2+2*sdet3cmots**2*st
     & w**2*qup*vmaup*qmo*vmamo*qs*ts-2*sdet3cmots**2*stw**2*qup*vmaup*q
     & mo*vmamo*qs*mmo**2+2*sdet3cmots**2*stw**2*qup*vmaup*qmo*vmamo*ts*
     & mz**2-2*sdet3cmots**2*stw**2*qup*vmaup*qmo*vmamo*mz**2*mmo**2-2*s
     & det3cmous*stw**2*qup*vpaup*qmo*vmamo*qs*ts*mmo**2+2*sdet3cmous*st
     & w**2*qup*vpaup*qmo*vmamo*qs*us*mmo**2-2*sdet3cmous*stw**2*qup*vpa
     & up*qmo*vmamo*ts*mz**2*mmo**2+2*sdet3cmous*stw**2*qup*vpaup*qmo*vm
     & amo*us*mz**2*mmo**2-2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*ts
     & *mmo**2+2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us*mmo**2-2*sd
     & et3cmous*stw**2*qup*vmaup*qmo*vpamo*ts*mz**2*mmo**2+2*sdet3cmous*
     & stw**2*qup*vmaup*qmo*vpamo*us*mz**2*mmo**2+2*sdet3cmous**2*stw**2
     & *qup*vpaup*qmo*vmamo*qs*us-2*sdet3cmous**2*stw**2*qup*vpaup*qmo*v
     & mamo*qs*mmo**2+2*sdet3cmous**2*stw**2*qup*vpaup*qmo*vmamo*us*mz**
     & 2-2*sdet3cmous**2*stw**2*qup*vpaup*qmo*vmamo*mz**2*mmo**2+2*sdet3
     & cmous**2*stw**2*qup*vmaup*qmo*vpamo*qs*us-2*sdet3cmous**2*stw**2*
     & qup*vmaup*qmo*vpamo*qs*mmo**2+2*sdet3cmous**2*stw**2*qup*vmaup*qm
     & o*vpamo*us*mz**2-2*sdet3cmous**2*stw**2*qup*vmaup*qmo*vpamo*mz**2
     & *mmo**2)
     & +sdet4imotsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(16*st
     & w**4*ctw**2*qup**2*qmo**2*qs**2*ts*us-8*stw**4*ctw**2*qup**2*qmo*
     & *2*qs**2*ts**2-8*stw**4*ctw**2*qup**2*qmo**2*qs**2*us**2)
     & +sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*ifi*(-2*sdet3cmots*
     & stw**2*qup*vpaup*qmo*vpamo*qs*ts*mmo**2+2*sdet3cmots*stw**2*qup*v
     & paup*qmo*vpamo*qs*ts**2+2*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*q
     & s*us*mmo**2-2*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*qs*mmo**4-2*s
     & det3cmots*stw**2*qup*vpaup*qmo*vpamo*ts*mz**2*mmo**2+2*sdet3cmots
     & *stw**2*qup*vpaup*qmo*vpamo*ts**2*mz**2+2*sdet3cmots*stw**2*qup*v
     & paup*qmo*vpamo*us*mz**2*mmo**2-2*sdet3cmots*stw**2*qup*vpaup*qmo*
     & vpamo*mz**2*mmo**4-2*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*ts*
     & mmo**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*ts**2+2*sdet3cm
     & ots*stw**2*qup*vmaup*qmo*vmamo*qs*us*mmo**2-2*sdet3cmots*stw**2*q
     & up*vmaup*qmo*vmamo*qs*mmo**4-2*sdet3cmots*stw**2*qup*vmaup*qmo*vm
     & amo*ts*mz**2*mmo**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*ts**2
     & *mz**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*us*mz**2*mmo**2-2*
     & sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*mz**2*mmo**4+2*sdet3cmous*s
     & tw**2*qup*vpaup*qmo*vmamo*qs*ts*mmo**2-2*sdet3cmous*stw**2*qup*vp
     & aup*qmo*vmamo*qs*us*mmo**2+2*sdet3cmous*stw**2*qup*vpaup*qmo*vmam
     & o*qs*us**2-2*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*qs*mmo**4+2*sd
     & et3cmous*stw**2*qup*vpaup*qmo*vmamo*ts*mz**2*mmo**2-2*sdet3cmous*
     & stw**2*qup*vpaup*qmo*vmamo*us*mz**2*mmo**2+2*sdet3cmous*stw**2*qu
     & p*vpaup*qmo*vmamo*us**2*mz**2-2*sdet3cmous*stw**2*qup*vpaup*qmo*v
     & mamo*mz**2*mmo**4+2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*ts*m
     & mo**2-2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us*mmo**2+2*sdet
     & 3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us**2-2*sdet3cmous*stw**2*qu
     & p*vmaup*qmo*vpamo*qs*mmo**4+2*sdet3cmous*stw**2*qup*vmaup*qmo*vpa
     & mo*ts*mz**2*mmo**2-2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*us*mz*
     & *2*mmo**2+2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*us**2*mz**2-2*s
     & det3cmous*stw**2*qup*vmaup*qmo*vpamo*mz**2*mmo**4)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(64*st
     & w**4*ctw**2*qup**2*qmo**2*qs*ts*us*mmo**2-32*stw**4*ctw**2*qup**2
     & *qmo**2*qs*ts**2*mmo**2-32*stw**4*ctw**2*qup**2*qmo**2*qs*us**2*m
     & mo**2+16*stw**4*ctw**2*qup**2*qmo**2*qs**2*ts*us-8*stw**4*ctw**2*
     & qup**2*qmo**2*qs**2*ts**2-8*stw**4*ctw**2*qup**2*qmo**2*qs**2*us*
     & *2-64*sdet3cmots*stw**4*ctw**2*qup**2*qmo**2*qs*mmo**4-16*sdet3cm
     & ots*stw**4*ctw**2*qup**2*qmo**2*qs**2*mmo**2-64*sdet3cmous*stw**4
     & *ctw**2*qup**2*qmo**2*qs*mmo**4-16*sdet3cmous*stw**4*ctw**2*qup**
     & 2*qmo**2*qs**2*mmo**2)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*ifi*(-4*sdet3cmots*s
     & tw**2*qup*vpaup*qmo*vpamo*qs*ts**2+4*sdet3cmots*stw**2*qup*vpaup*
     & qmo*vpamo*qs*mmo**4-4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*ts**2
     & *mz**2+4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*mz**2*mmo**4-4*sde
     & t3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*ts**2+4*sdet3cmots*stw**2*q
     & up*vmaup*qmo*vmamo*qs*mmo**4-4*sdet3cmots*stw**2*qup*vmaup*qmo*vm
     & amo*ts**2*mz**2+4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*mz**2*mmo
     & **4)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*ifi*(-4*sdet3cmous*s
     & tw**2*qup*vpaup*qmo*vmamo*qs*us**2+4*sdet3cmous*stw**2*qup*vpaup*
     & qmo*vmamo*qs*mmo**4-4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*us**2
     & *mz**2+4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*mz**2*mmo**4-4*sde
     & t3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us**2+4*sdet3cmous*stw**2*q
     & up*vmaup*qmo*vpamo*qs*mmo**4-4*sdet3cmous*stw**2*qup*vmaup*qmo*vp
     & amo*us**2*mz**2+4*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*mz**2*mmo
     & **4)
     & +sdet4imotsus*javqstsupmoz*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*vpamo*ts*mmo**2-2*stw**2*qup*vpaup*qmo*vpamo*mmo**4-2*stw*
     & *2*qup*vpaup*qmo*vmamo*ts*mmo**2-2*stw**2*qup*vpaup*qmo*vmamo*mmo
     & **4-2*stw**2*qup*vmaup*qmo*vpamo*ts*mmo**2-2*stw**2*qup*vmaup*qmo
     & *vpamo*mmo**4-2*stw**2*qup*vmaup*qmo*vmamo*ts*mmo**2-2*stw**2*qup
     & *vmaup*qmo*vmamo*mmo**4-4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*t
     & s-4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*ts)
     & +sdet4imotsus*javqsusupmoz*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*vpamo*us*mmo**2-2*stw**2*qup*vpaup*qmo*vpamo*mmo**4-2*stw*
     & *2*qup*vpaup*qmo*vmamo*us*mmo**2-2*stw**2*qup*vpaup*qmo*vmamo*mmo
     & **4-2*stw**2*qup*vmaup*qmo*vpamo*us*mmo**2-2*stw**2*qup*vmaup*qmo
     & *vpamo*mmo**4-2*stw**2*qup*vmaup*qmo*vmamo*us*mmo**2-2*stw**2*qup
     & *vmaup*qmo*vmamo*mmo**4-4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*u
     & s-4*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*us)
     & +sdet4imotsus*c0upupqszupc*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*vpamo*qs*ts-2*stw**2*qup*vpaup*qmo*vpamo*qs*mmo**2+2*stw**
     & 2*qup*vpaup*qmo*vpamo*ts*mz**2+2*stw**2*qup*vpaup*qmo*vpamo*mz**2
     & *mmo**2-2*stw**2*qup*vpaup*qmo*vmamo*qs*us-2*stw**2*qup*vpaup*qmo
     & *vmamo*qs*mmo**2+2*stw**2*qup*vpaup*qmo*vmamo*us*mz**2+2*stw**2*q
     & up*vpaup*qmo*vmamo*mz**2*mmo**2-2*stw**2*qup*vmaup*qmo*vpamo*qs*u
     & s-2*stw**2*qup*vmaup*qmo*vpamo*qs*mmo**2+2*stw**2*qup*vmaup*qmo*v
     & pamo*us*mz**2+2*stw**2*qup*vmaup*qmo*vpamo*mz**2*mmo**2-2*stw**2*
     & qup*vmaup*qmo*vmamo*qs*ts-2*stw**2*qup*vmaup*qmo*vmamo*qs*mmo**2+
     & 2*stw**2*qup*vmaup*qmo*vmamo*ts*mz**2+2*stw**2*qup*vmaup*qmo*vmam
     & o*mz**2*mmo**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*vpamo/qs*ts*mz**2*mmo**2+2*stw**2*qup*vpaup*qmo*vpamo/qs*u
     & s*mz**2*mmo**2-2*stw**2*qup*vpaup*qmo*vpamo*qs*ts+2*stw**2*qup*vp
     & aup*qmo*vpamo*ts*mz**2-10*stw**2*qup*vpaup*qmo*vpamo*ts*mmo**2+2*
     & stw**2*qup*vpaup*qmo*vpamo*us*mmo**2-8*stw**2*qup*vpaup*qmo*vpamo
     & *mmo**4+2*stw**2*qup*vpaup*qmo*vmamo/qs*ts*mz**2*mmo**2-2*stw**2*
     & qup*vpaup*qmo*vmamo/qs*us*mz**2*mmo**2-2*stw**2*qup*vpaup*qmo*vma
     & mo*qs*us+2*stw**2*qup*vpaup*qmo*vmamo*ts*mmo**2+2*stw**2*qup*vpau
     & p*qmo*vmamo*us*mz**2-10*stw**2*qup*vpaup*qmo*vmamo*us*mmo**2-8*st
     & w**2*qup*vpaup*qmo*vmamo*mmo**4+2*stw**2*qup*vmaup*qmo*vpamo/qs*t
     & s*mz**2*mmo**2-2*stw**2*qup*vmaup*qmo*vpamo/qs*us*mz**2*mmo**2-2*
     & stw**2*qup*vmaup*qmo*vpamo*qs*us+2*stw**2*qup*vmaup*qmo*vpamo*ts*
     & mmo**2+2*stw**2*qup*vmaup*qmo*vpamo*us*mz**2-10*stw**2*qup*vmaup*
     & qmo*vpamo*us*mmo**2-8*stw**2*qup*vmaup*qmo*vpamo*mmo**4-2*stw**2*
     & qup*vmaup*qmo*vmamo/qs*ts*mz**2*mmo**2+2*stw**2*qup*vmaup*qmo*vma
     & mo/qs*us*mz**2*mmo**2-2*stw**2*qup*vmaup*qmo*vmamo*qs*ts+2*stw**2
     & *qup*vmaup*qmo*vmamo*ts*mz**2-10*stw**2*qup*vmaup*qmo*vmamo*ts*mm
     & o**2+2*stw**2*qup*vmaup*qmo*vmamo*us*mmo**2-8*stw**2*qup*vmaup*qm
     & o*vmamo*mmo**4+4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo/qs*mz**2*m
     & mo**2+4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*mmo**2+4*sdet3cmots
     & *stw**2*qup*vmaup*qmo*vmamo/qs*mz**2*mmo**2+4*sdet3cmots*stw**2*q
     & up*vmaup*qmo*vmamo*mmo**2+4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo
     & /qs*mz**2*mmo**2+4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*mmo**2+4
     & *sdet3cmous*stw**2*qup*vmaup*qmo*vpamo/qs*mz**2*mmo**2+4*sdet3cmo
     & us*stw**2*qup*vmaup*qmo*vpamo*mmo**2)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(-32*stw*
     & *4*ctw**2*qup**2*qmo**2*qs*mmo**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*vpau
     & p*qmo*vpamo*ts*mmo**2-4*stw**2*qup*vpaup*qmo*vpamo*mmo**4-4*stw**
     & 2*qup*vpaup*qmo*vmamo*ts*mmo**2-4*stw**2*qup*vpaup*qmo*vmamo*mmo*
     & *4-4*stw**2*qup*vmaup*qmo*vpamo*ts*mmo**2-4*stw**2*qup*vmaup*qmo*
     & vpamo*mmo**4-4*stw**2*qup*vmaup*qmo*vmamo*ts*mmo**2-4*stw**2*qup*
     & vmaup*qmo*vmamo*mmo**4-4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo/qs
     & *mz**2*mmo**2-8*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*ts-4*sdet3c
     & mots*stw**2*qup*vmaup*qmo*vmamo/qs*mz**2*mmo**2-8*sdet3cmots*stw*
     & *2*qup*vmaup*qmo*vmamo*ts)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*vpau
     & p*qmo*vpamo*us*mmo**2-4*stw**2*qup*vpaup*qmo*vpamo*mmo**4-4*stw**
     & 2*qup*vpaup*qmo*vmamo*us*mmo**2-4*stw**2*qup*vpaup*qmo*vmamo*mmo*
     & *4-4*stw**2*qup*vmaup*qmo*vpamo*us*mmo**2-4*stw**2*qup*vmaup*qmo*
     & vpamo*mmo**4-4*stw**2*qup*vmaup*qmo*vmamo*us*mmo**2-4*stw**2*qup*
     & vmaup*qmo*vmamo*mmo**4-4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo/qs
     & *mz**2*mmo**2-8*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*us-4*sdet3c
     & mous*stw**2*qup*vmaup*qmo*vpamo/qs*mz**2*mmo**2-8*sdet3cmous*stw*
     & *2*qup*vmaup*qmo*vpamo*us)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(-64*stw**4*c
     & tw**2*qup**2*qmo**2*mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*ifi*(4*stw**2*qup*vpaup*qmo
     & *vpamo*ts+4*stw**2*qup*vpaup*qmo*vpamo*mmo**2+4*stw**2*qup*vpaup*
     & qmo*vmamo*us+4*stw**2*qup*vpaup*qmo*vmamo*mmo**2+4*stw**2*qup*vma
     & up*qmo*vpamo*us+4*stw**2*qup*vmaup*qmo*vpamo*mmo**2+4*stw**2*qup*
     & vmaup*qmo*vmamo*ts+4*stw**2*qup*vmaup*qmo*vmamo*mmo**2)
     & +sdet4imotsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(16*sdet3cmots
     & *stw**4*ctw**2*qup**2*qmo**2+16*sdet3cmous*stw**4*ctw**2*qup**2*q
     & mo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*cfscheme*(32*stw**4*ct
     & w**2*qup**2*qmo**2*mmo**2-16*sdet3cmots*stw**4*ctw**2*qup**2*qmo*
     & *2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(-4*stw**2*qup*vpaup*q
     & mo*vpamo*ts-4*stw**2*qup*vpaup*qmo*vpamo*mmo**2-4*stw**2*qup*vmau
     & p*qmo*vmamo*ts-4*stw**2*qup*vmaup*qmo*vmamo*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*cfscheme*(32*stw**4*ct
     & w**2*qup**2*qmo**2*mmo**2-16*sdet3cmous*stw**4*ctw**2*qup**2*qmo*
     & *2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(-4*stw**2*qup*vpaup*q
     & mo*vmamo*us-4*stw**2*qup*vpaup*qmo*vmamo*mmo**2-4*stw**2*qup*vmau
     & p*qmo*vpamo*us-4*stw**2*qup*vmaup*qmo*vpamo*mmo**2)
     & +javqstsupmoz*ifi*(-4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo+4*sde
     & t3cmots*stw**2*qup*vpaup*qmo*vmamo+4*sdet3cmots*stw**2*qup*vmaup*
     & qmo*vpamo-4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo)
     & +javqsusupmoz*ifi*(4*sdet3cmous*stw**2*qup*vpaup*qmo*vpamo-4*sdet
     & 3cmous*stw**2*qup*vpaup*qmo*vmamo-4*sdet3cmous*stw**2*qup*vmaup*q
     & mo*vpamo+4*sdet3cmous*stw**2*qup*vmaup*qmo*vmamo)
     & +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     & +c0irupmots*ifi*(4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo-4*sdet3c
     & mots*stw**2*qup*vpaup*qmo*vmamo-4*sdet3cmots*stw**2*qup*vmaup*qmo
     & *vpamo+4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo)
     & +c0irupmous*ifi*(-4*sdet3cmous*stw**2*qup*vpaup*qmo*vpamo+4*sdet3
     & cmous*stw**2*qup*vpaup*qmo*vmamo+4*sdet3cmous*stw**2*qup*vmaup*qm
     & o*vpamo-4*sdet3cmous*stw**2*qup*vmaup*qmo*vmamo)
     & +c0irmomoqs*fsr*(-2*stw**2*qmo**2*qs-4*stw**2*qmo**2*mmo**2)
     & +c0cmotsczmo*ifi*(-4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo+4*sdet
     & 3cmots*stw**2*qup*vpaup*qmo*vmamo+4*sdet3cmots*stw**2*qup*vmaup*q
     & mo*vpamo-4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo)
     & +c0cmousczmo*ifi*(4*sdet3cmous*stw**2*qup*vpaup*qmo*vpamo-4*sdet3
     & cmous*stw**2*qup*vpaup*qmo*vmamo-4*sdet3cmous*stw**2*qup*vmaup*qm
     & o*vpamo+4*sdet3cmous*stw**2*qup*vmaup*qmo*vmamo)
     & +a0fup*isr*(-3*stw**2*qup**2)
     & +a0fmo*fsr*(-3*stw**2*qmo**2)
     & +b0fqsmomo*fsr*(-3*stw**2*qmo**2)
     & +b0fqscc*isr*(-3*stw**2*qup**2)
     & +lnlaupm*isr*(2*stw**2*qup**2)
     & +lnlamom*fsr*(2*stw**2*qmo**2)

      ff_qed_ql =
     & +isr*(-stw**2*qup**2)
     & +fsr*(-stw**2*qmo**2)
     & +det3imomoqs*fsr*(2*stw**2*qmo**2*qs*mmo**2)
     & +det3imomoqs*a0fmo*fsr*(-2*stw**2*qmo**2*qs*mmo**2)
     & +det3imomoqs*b0fqsmomo*fsr*(-2*stw**2*qmo**2*qs*mmo**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(4*stw*
     & *2*qup*qmo*vmamo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*vmamo*ts*mmo**2+4*stw**2*qup*qmo*vmamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*vmamo*ts*mmo**2+4*stw**2*qup*qmo*vmamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(-8*stw**2
     & *qup*qmo*vmamo*ts*mmo**2-8*stw**2*qup*qmo*vmamo*mmo**4)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*vm
     & amo/qs*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(4*stw*
     & *2*qup*qmo*vpamo*us*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*vpamo*us*mmo**2+4*stw**2*qup*qmo*vpamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*vpamo*us*mmo**2+4*stw**2*qup*qmo*vpamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(-8*stw**2
     & *qup*qmo*vpamo*us*mmo**2-8*stw**2*qup*qmo*vpamo*mmo**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*vp
     & amo/qs*mz**2*mmo**2)
     & +sdet4imotsus**2*jaaqstsupmo*dreal(propizqs)*ifi*cfscheme*(2*sdet
     & 3cmots**3*stw**2*ctw**2*qup*qmo**2*ts-2*sdet3cmots**3*stw**2*ctw*
     & *2*qup*qmo**2*us)
     & +sdet4imotsus**2*jaaqsusupmo*dreal(propizqs)*ifi*cfscheme*(-2*sde
     & t3cmous**3*stw**2*ctw**2*qup*qmo**2*ts+2*sdet3cmous**3*stw**2*ctw
     & **2*qup*qmo**2*us)
     & +sdet4imotsus**2*javqstsupmoz*dreal(propizqs)*ifi*(2*sdet3cmots*s
     & tw**2*qup*qmo*vmamo*qs*ts**2-2*sdet3cmots*stw**2*qup*qmo*vmamo*qs
     & *mmo**4+2*sdet3cmots*stw**2*qup*qmo*vmamo*ts**2*mz**2-2*sdet3cmot
     & s*stw**2*qup*qmo*vmamo*mz**2*mmo**4)
     & +sdet4imotsus**2*javqsusupmoz*dreal(propizqs)*ifi*(2*sdet3cmous*s
     & tw**2*qup*qmo*vpamo*qs*us**2-2*sdet3cmous*stw**2*qup*qmo*vpamo*qs
     & *mmo**4+2*sdet3cmous*stw**2*qup*qmo*vpamo*us**2*mz**2-2*sdet3cmou
     & s*stw**2*qup*qmo*vpamo*mz**2*mmo**4)
     & +sdet4imotsus**2*c0upupqszupc*dreal(propizqs)*ifi*(-2*sdet3cmots*
     & stw**2*qup*qmo*vmamo*qs*ts*mmo**2+2*sdet3cmots*stw**2*qup*qmo*vma
     & mo*qs*us*mmo**2-2*sdet3cmots*stw**2*qup*qmo*vmamo*ts*mz**2*mmo**2
     & +2*sdet3cmots*stw**2*qup*qmo*vmamo*us*mz**2*mmo**2-2*sdet3cmots**
     & 2*stw**2*qup*qmo*vmamo*qs*ts+2*sdet3cmots**2*stw**2*qup*qmo*vmamo
     & *qs*mmo**2-2*sdet3cmots**2*stw**2*qup*qmo*vmamo*ts*mz**2+2*sdet3c
     & mots**2*stw**2*qup*qmo*vmamo*mz**2*mmo**2+2*sdet3cmous*stw**2*qup
     & *qmo*vpamo*qs*ts*mmo**2-2*sdet3cmous*stw**2*qup*qmo*vpamo*qs*us*m
     & mo**2+2*sdet3cmous*stw**2*qup*qmo*vpamo*ts*mz**2*mmo**2-2*sdet3cm
     & ous*stw**2*qup*qmo*vpamo*us*mz**2*mmo**2-2*sdet3cmous**2*stw**2*q
     & up*qmo*vpamo*qs*us+2*sdet3cmous**2*stw**2*qup*qmo*vpamo*qs*mmo**2
     & -2*sdet3cmous**2*stw**2*qup*qmo*vpamo*us*mz**2+2*sdet3cmous**2*st
     & w**2*qup*qmo*vpamo*mz**2*mmo**2)
     & +sdet4imotsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(4*stw
     & **2*ctw**2*qup*qmo**2*qs**2*ts*us-2*stw**2*ctw**2*qup*qmo**2*qs**
     & 2*ts**2-2*stw**2*ctw**2*qup*qmo**2*qs**2*us**2)
     & +sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*ifi*(2*sdet3cmots*s
     & tw**2*qup*qmo*vmamo*qs*ts*mmo**2-2*sdet3cmots*stw**2*qup*qmo*vmam
     & o*qs*ts**2-2*sdet3cmots*stw**2*qup*qmo*vmamo*qs*us*mmo**2+2*sdet3
     & cmots*stw**2*qup*qmo*vmamo*qs*mmo**4+2*sdet3cmots*stw**2*qup*qmo*
     & vmamo*ts*mz**2*mmo**2-2*sdet3cmots*stw**2*qup*qmo*vmamo*ts**2*mz*
     & *2-2*sdet3cmots*stw**2*qup*qmo*vmamo*us*mz**2*mmo**2+2*sdet3cmots
     & *stw**2*qup*qmo*vmamo*mz**2*mmo**4-2*sdet3cmous*stw**2*qup*qmo*vp
     & amo*qs*ts*mmo**2+2*sdet3cmous*stw**2*qup*qmo*vpamo*qs*us*mmo**2-2
     & *sdet3cmous*stw**2*qup*qmo*vpamo*qs*us**2+2*sdet3cmous*stw**2*qup
     & *qmo*vpamo*qs*mmo**4-2*sdet3cmous*stw**2*qup*qmo*vpamo*ts*mz**2*m
     & mo**2+2*sdet3cmous*stw**2*qup*qmo*vpamo*us*mz**2*mmo**2-2*sdet3cm
     & ous*stw**2*qup*qmo*vpamo*us**2*mz**2+2*sdet3cmous*stw**2*qup*qmo*
     & vpamo*mz**2*mmo**4)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(16*st
     & w**2*ctw**2*qup*qmo**2*qs*ts*us*mmo**2-8*stw**2*ctw**2*qup*qmo**2
     & *qs*ts**2*mmo**2-8*stw**2*ctw**2*qup*qmo**2*qs*us**2*mmo**2+4*stw
     & **2*ctw**2*qup*qmo**2*qs**2*ts*us-2*stw**2*ctw**2*qup*qmo**2*qs**
     & 2*ts**2-2*stw**2*ctw**2*qup*qmo**2*qs**2*us**2-16*sdet3cmots*stw*
     & *2*ctw**2*qup*qmo**2*qs*mmo**4-4*sdet3cmots*stw**2*ctw**2*qup*qmo
     & **2*qs**2*mmo**2-16*sdet3cmous*stw**2*ctw**2*qup*qmo**2*qs*mmo**4
     & -4*sdet3cmous*stw**2*ctw**2*qup*qmo**2*qs**2*mmo**2)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*ifi*(4*sdet3cmots*st
     & w**2*qup*qmo*vmamo*qs*ts**2-4*sdet3cmots*stw**2*qup*qmo*vmamo*qs*
     & mmo**4+4*sdet3cmots*stw**2*qup*qmo*vmamo*ts**2*mz**2-4*sdet3cmots
     & *stw**2*qup*qmo*vmamo*mz**2*mmo**4)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*ifi*(4*sdet3cmous*st
     & w**2*qup*qmo*vpamo*qs*us**2-4*sdet3cmous*stw**2*qup*qmo*vpamo*qs*
     & mmo**4+4*sdet3cmous*stw**2*qup*qmo*vpamo*us**2*mz**2-4*sdet3cmous
     & *stw**2*qup*qmo*vpamo*mz**2*mmo**4)
     & +sdet4imotsus*javqstsupmoz*dreal(propizqs)*ifi*(2*stw**2*qup*qmo*
     & vpamo*ts*mmo**2+2*stw**2*qup*qmo*vpamo*mmo**4+2*stw**2*qup*qmo*vm
     & amo*ts*mmo**2+2*stw**2*qup*qmo*vmamo*mmo**4+4*sdet3cmots*stw**2*q
     & up*qmo*vmamo*ts)
     & +sdet4imotsus*javqsusupmoz*dreal(propizqs)*ifi*(2*stw**2*qup*qmo*
     & vpamo*us*mmo**2+2*stw**2*qup*qmo*vpamo*mmo**4+2*stw**2*qup*qmo*vm
     & amo*us*mmo**2+2*stw**2*qup*qmo*vmamo*mmo**4+4*sdet3cmous*stw**2*q
     & up*qmo*vpamo*us)
     & +sdet4imotsus*c0upupqszupc*dreal(propizqs)*ifi*(2*stw**2*qup*qmo*
     & vpamo*qs*us+2*stw**2*qup*qmo*vpamo*qs*mmo**2-2*stw**2*qup*qmo*vpa
     & mo*us*mz**2-2*stw**2*qup*qmo*vpamo*mz**2*mmo**2+2*stw**2*qup*qmo*
     & vmamo*qs*ts+2*stw**2*qup*qmo*vmamo*qs*mmo**2-2*stw**2*qup*qmo*vma
     & mo*ts*mz**2-2*stw**2*qup*qmo*vmamo*mz**2*mmo**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(-2*stw**2*qup*qmo
     & *vpamo/qs*ts*mz**2*mmo**2+2*stw**2*qup*qmo*vpamo/qs*us*mz**2*mmo*
     & *2+2*stw**2*qup*qmo*vpamo*qs*us-2*stw**2*qup*qmo*vpamo*ts*mmo**2-
     & 2*stw**2*qup*qmo*vpamo*us*mz**2+10*stw**2*qup*qmo*vpamo*us*mmo**2
     & +8*stw**2*qup*qmo*vpamo*mmo**4+2*stw**2*qup*qmo*vmamo/qs*ts*mz**2
     & *mmo**2-2*stw**2*qup*qmo*vmamo/qs*us*mz**2*mmo**2+2*stw**2*qup*qm
     & o*vmamo*qs*ts-2*stw**2*qup*qmo*vmamo*ts*mz**2+10*stw**2*qup*qmo*v
     & mamo*ts*mmo**2-2*stw**2*qup*qmo*vmamo*us*mmo**2+8*stw**2*qup*qmo*
     & vmamo*mmo**4-4*sdet3cmots*stw**2*qup*qmo*vmamo/qs*mz**2*mmo**2-4*
     & sdet3cmots*stw**2*qup*qmo*vmamo*mmo**2-4*sdet3cmous*stw**2*qup*qm
     & o*vpamo/qs*mz**2*mmo**2-4*sdet3cmous*stw**2*qup*qmo*vpamo*mmo**2)
     & 
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(-8*stw**
     & 2*ctw**2*qup*qmo**2*qs*mmo**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*v
     & pamo*ts*mmo**2+4*stw**2*qup*qmo*vpamo*mmo**4+4*stw**2*qup*qmo*vma
     & mo*ts*mmo**2+4*stw**2*qup*qmo*vmamo*mmo**4+4*sdet3cmots*stw**2*qu
     & p*qmo*vmamo/qs*mz**2*mmo**2+8*sdet3cmots*stw**2*qup*qmo*vmamo*ts)
     & 
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*v
     & pamo*us*mmo**2+4*stw**2*qup*qmo*vpamo*mmo**4+4*stw**2*qup*qmo*vma
     & mo*us*mmo**2+4*stw**2*qup*qmo*vmamo*mmo**4+4*sdet3cmous*stw**2*qu
     & p*qmo*vpamo/qs*mz**2*mmo**2+8*sdet3cmous*stw**2*qup*qmo*vpamo*us)
     & 
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(-16*stw**2*c
     & tw**2*qup*qmo**2*mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*ifi*(-4*stw**2*qup*qmo*vpam
     & o*us-4*stw**2*qup*qmo*vpamo*mmo**2-4*stw**2*qup*qmo*vmamo*ts-4*st
     & w**2*qup*qmo*vmamo*mmo**2)
     & +sdet4imotsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(4*sdet3cmots*
     & stw**2*ctw**2*qup*qmo**2+4*sdet3cmous*stw**2*ctw**2*qup*qmo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*cfscheme*(8*stw**2*ctw
     & **2*qup*qmo**2*mmo**2-4*sdet3cmots*stw**2*ctw**2*qup*qmo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*vmam
     & o*ts+4*stw**2*qup*qmo*vmamo*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*cfscheme*(8*stw**2*ctw
     & **2*qup*qmo**2*mmo**2-4*sdet3cmous*stw**2*ctw**2*qup*qmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*vpam
     & o*us+4*stw**2*qup*qmo*vpamo*mmo**2)
     & +javqstsupmoz*ifi*(-4*sdet3cmots*stw**2*qup*qmo*vpamo+4*sdet3cmot
     & s*stw**2*qup*qmo*vmamo)
     & +javqsusupmoz*ifi*(4*sdet3cmous*stw**2*qup*qmo*vpamo-4*sdet3cmous
     & *stw**2*qup*qmo*vmamo)
     & +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     & +c0irupmots*ifi*(4*sdet3cmots*stw**2*qup*qmo*vpamo-4*sdet3cmots*s
     & tw**2*qup*qmo*vmamo)
     & +c0irupmous*ifi*(-4*sdet3cmous*stw**2*qup*qmo*vpamo+4*sdet3cmous*
     & stw**2*qup*qmo*vmamo)
     & +c0irmomoqs*fsr*(-2*stw**2*qmo**2*qs-4*stw**2*qmo**2*mmo**2)
     & +c0cmotsczmo*ifi*(-4*sdet3cmots*stw**2*qup*qmo*vpamo+4*sdet3cmots
     & *stw**2*qup*qmo*vmamo)
     & +c0cmousczmo*ifi*(4*sdet3cmous*stw**2*qup*qmo*vpamo-4*sdet3cmous*
     & stw**2*qup*qmo*vmamo)
     & +a0fup*isr*(-3*stw**2*qup**2)
     & +a0fmo*fsr*(-3*stw**2*qmo**2)
     & +b0fqsmomo*fsr*(-3*stw**2*qmo**2)
     & +b0fqscc*isr*(-3*stw**2*qup**2)
     & +lnlaupm*isr*(2*stw**2*qup**2)
     & +lnlamom*fsr*(2*stw**2*qmo**2)

      ff_qed_lq =
     & +isr*(-stw**2*qup**2)
     & +fsr*(-stw**2*qmo**2)
     & +det3imomoqs*fsr*(-1d0/2*qmo*qs*mmo**2)
     & +det3imomoqs*a0fmo*fsr*(1d0/2*qmo*qs*mmo**2)
     & +det3imomoqs*b0fqsmomo*fsr*(1d0/2*qmo*qs*mmo**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw
     & **2*qup*vmaup*qmo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vmaup*qmo*ts*mmo**2+2*qup*vpaup*vpamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vmaup*qmo*ts*mmo**2+2*qup*vpaup*vpamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(8*stw**2*
     & qup*vmaup*qmo*ts*mmo**2-4*qup*vpaup*vpamo*mmo**4)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*ifi*(2*qup*vpaup*vpamo/q
     & s*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(-4*stw
     & **2*qup*vpaup*qmo*us*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*us*mmo**2+2*qup*vmaup*vpamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*us*mmo**2+2*qup*vmaup*vpamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(8*stw**2*
     & qup*vpaup*qmo*us*mmo**2-4*qup*vmaup*vpamo*mmo**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*ifi*(2*qup*vmaup*vpamo/q
     & s*mz**2*mmo**2)
     & +sdet4imotsus**2*jaaqstsupmo*dreal(propizqs)*ifi*cfscheme*(-2*sde
     & t3cmots**3*stw**2*ctw**2*qup**2*qmo*ts+2*sdet3cmots**3*stw**2*ctw
     & **2*qup**2*qmo*us)
     & +sdet4imotsus**2*jaaqsusupmo*dreal(propizqs)*ifi*cfscheme*(2*sdet
     & 3cmous**3*stw**2*ctw**2*qup**2*qmo*ts-2*sdet3cmous**3*stw**2*ctw*
     & *2*qup**2*qmo*us)
     & +sdet4imotsus**2*javqstsupmoz*dreal(propizqs)*ifi*(2*sdet3cmots*s
     & tw**2*qup*vmaup*qmo*qs*ts*mmo**2-2*sdet3cmots*stw**2*qup*vmaup*qm
     & o*qs*ts**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*ts*mz**2*mmo**2-2*sd
     & et3cmots*stw**2*qup*vmaup*qmo*ts**2*mz**2+sdet3cmots*qup*vpaup*vp
     & amo*qs*ts*mmo**2-sdet3cmots*qup*vpaup*vpamo*qs*mmo**4+sdet3cmots*
     & qup*vpaup*vpamo*ts*mz**2*mmo**2-sdet3cmots*qup*vpaup*vpamo*mz**2*
     & mmo**4)
     & +sdet4imotsus**2*javqsusupmoz*dreal(propizqs)*ifi*(2*sdet3cmous*s
     & tw**2*qup*vpaup*qmo*qs*us*mmo**2-2*sdet3cmous*stw**2*qup*vpaup*qm
     & o*qs*us**2+2*sdet3cmous*stw**2*qup*vpaup*qmo*us*mz**2*mmo**2-2*sd
     & et3cmous*stw**2*qup*vpaup*qmo*us**2*mz**2+sdet3cmous*qup*vmaup*vp
     & amo*qs*us*mmo**2-sdet3cmous*qup*vmaup*vpamo*qs*mmo**4+sdet3cmous*
     & qup*vmaup*vpamo*us*mz**2*mmo**2-sdet3cmous*qup*vmaup*vpamo*mz**2*
     & mmo**4)
     & +sdet4imotsus**2*c0upupqszupc*dreal(propizqs)*ifi*(-sdet3cmots*qu
     & p*vpaup*vpamo*qs*ts*mmo**2+sdet3cmots*qup*vpaup*vpamo*qs*us*mmo**
     & 2-sdet3cmots*qup*vpaup*vpamo*ts*mz**2*mmo**2+sdet3cmots*qup*vpaup
     & *vpamo*us*mz**2*mmo**2+2*sdet3cmots**2*stw**2*qup*vmaup*qmo*qs*ts
     & -2*sdet3cmots**2*stw**2*qup*vmaup*qmo*qs*mmo**2+2*sdet3cmots**2*s
     & tw**2*qup*vmaup*qmo*ts*mz**2-2*sdet3cmots**2*stw**2*qup*vmaup*qmo
     & *mz**2*mmo**2+sdet3cmous*qup*vmaup*vpamo*qs*ts*mmo**2-sdet3cmous*
     & qup*vmaup*vpamo*qs*us*mmo**2+sdet3cmous*qup*vmaup*vpamo*ts*mz**2*
     & mmo**2-sdet3cmous*qup*vmaup*vpamo*us*mz**2*mmo**2+2*sdet3cmous**2
     & *stw**2*qup*vpaup*qmo*qs*us-2*sdet3cmous**2*stw**2*qup*vpaup*qmo*
     & qs*mmo**2+2*sdet3cmous**2*stw**2*qup*vpaup*qmo*us*mz**2-2*sdet3cm
     & ous**2*stw**2*qup*vpaup*qmo*mz**2*mmo**2)
     & +sdet4imotsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(-4*st
     & w**2*ctw**2*qup**2*qmo*qs**2*ts*us+2*stw**2*ctw**2*qup**2*qmo*qs*
     & *2*ts**2+2*stw**2*ctw**2*qup**2*qmo*qs**2*us**2)
     & +sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*ifi*(-4*sdet3cmots*
     & stw**2*qup*vmaup*qmo*qs*ts*mmo**2+2*sdet3cmots*stw**2*qup*vmaup*q
     & mo*qs*ts**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*qs*mmo**4-4*sdet3cm
     & ots*stw**2*qup*vmaup*qmo*ts*mz**2*mmo**2+2*sdet3cmots*stw**2*qup*
     & vmaup*qmo*ts**2*mz**2+2*sdet3cmots*stw**2*qup*vmaup*qmo*mz**2*mmo
     & **4-sdet3cmots*qup*vpaup*vpamo*qs*ts*mmo**2-sdet3cmots*qup*vpaup*
     & vpamo*qs*us*mmo**2+2*sdet3cmots*qup*vpaup*vpamo*qs*mmo**4-sdet3cm
     & ots*qup*vpaup*vpamo*ts*mz**2*mmo**2-sdet3cmots*qup*vpaup*vpamo*us
     & *mz**2*mmo**2+2*sdet3cmots*qup*vpaup*vpamo*mz**2*mmo**4-4*sdet3cm
     & ous*stw**2*qup*vpaup*qmo*qs*us*mmo**2+2*sdet3cmous*stw**2*qup*vpa
     & up*qmo*qs*us**2+2*sdet3cmous*stw**2*qup*vpaup*qmo*qs*mmo**4-4*sde
     & t3cmous*stw**2*qup*vpaup*qmo*us*mz**2*mmo**2+2*sdet3cmous*stw**2*
     & qup*vpaup*qmo*us**2*mz**2+2*sdet3cmous*stw**2*qup*vpaup*qmo*mz**2
     & *mmo**4-sdet3cmous*qup*vmaup*vpamo*qs*ts*mmo**2-sdet3cmous*qup*vm
     & aup*vpamo*qs*us*mmo**2+2*sdet3cmous*qup*vmaup*vpamo*qs*mmo**4-sde
     & t3cmous*qup*vmaup*vpamo*ts*mz**2*mmo**2-sdet3cmous*qup*vmaup*vpam
     & o*us*mz**2*mmo**2+2*sdet3cmous*qup*vmaup*vpamo*mz**2*mmo**4)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(-16*s
     & tw**2*ctw**2*qup**2*qmo*qs*ts*us*mmo**2+8*stw**2*ctw**2*qup**2*qm
     & o*qs*ts**2*mmo**2+8*stw**2*ctw**2*qup**2*qmo*qs*us**2*mmo**2-4*st
     & w**2*ctw**2*qup**2*qmo*qs**2*ts*us+2*stw**2*ctw**2*qup**2*qmo*qs*
     & *2*ts**2+2*stw**2*ctw**2*qup**2*qmo*qs**2*us**2+16*sdet3cmots*stw
     & **2*ctw**2*qup**2*qmo*qs*mmo**4+4*sdet3cmots*stw**2*ctw**2*qup**2
     & *qmo*qs**2*mmo**2+16*sdet3cmous*stw**2*ctw**2*qup**2*qmo*qs*mmo**
     & 4+4*sdet3cmous*stw**2*ctw**2*qup**2*qmo*qs**2*mmo**2)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*ifi*(4*sdet3cmots*st
     & w**2*qup*vmaup*qmo*qs*ts*mmo**2-4*sdet3cmots*stw**2*qup*vmaup*qmo
     & *qs*ts**2+4*sdet3cmots*stw**2*qup*vmaup*qmo*ts*mz**2*mmo**2-4*sde
     & t3cmots*stw**2*qup*vmaup*qmo*ts**2*mz**2+2*sdet3cmots*qup*vpaup*v
     & pamo*qs*ts*mmo**2-2*sdet3cmots*qup*vpaup*vpamo*qs*mmo**4+2*sdet3c
     & mots*qup*vpaup*vpamo*ts*mz**2*mmo**2-2*sdet3cmots*qup*vpaup*vpamo
     & *mz**2*mmo**4)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*ifi*(4*sdet3cmous*st
     & w**2*qup*vpaup*qmo*qs*us*mmo**2-4*sdet3cmous*stw**2*qup*vpaup*qmo
     & *qs*us**2+4*sdet3cmous*stw**2*qup*vpaup*qmo*us*mz**2*mmo**2-4*sde
     & t3cmous*stw**2*qup*vpaup*qmo*us**2*mz**2+2*sdet3cmous*qup*vmaup*v
     & pamo*qs*us*mmo**2-2*sdet3cmous*qup*vmaup*vpamo*qs*mmo**4+2*sdet3c
     & mous*qup*vmaup*vpamo*us*mz**2*mmo**2-2*sdet3cmous*qup*vmaup*vpamo
     & *mz**2*mmo**4)
     & +sdet4imotsus*javqstsupmoz*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*mmo**4-2*stw**2*qup*vmaup*qmo*mmo**4+qup*vpaup*vpamo*ts*mm
     & o**2+qup*vmaup*vpamo*ts*mmo**2+2*sdet3cmots*stw**2*qup*vmaup*qmo/
     & qs*mz**2*mmo**2-4*sdet3cmots*stw**2*qup*vmaup*qmo*ts+4*sdet3cmots
     & *stw**2*qup*vmaup*qmo*mmo**2+sdet3cmots*qup*vpaup*vpamo/qs*mz**2*
     & mmo**2+2*sdet3cmots*qup*vpaup*vpamo*mmo**2)
     & +sdet4imotsus*javqsusupmoz*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*mmo**4-2*stw**2*qup*vmaup*qmo*mmo**4+qup*vpaup*vpamo*us*mm
     & o**2+qup*vmaup*vpamo*us*mmo**2+2*sdet3cmous*stw**2*qup*vpaup*qmo/
     & qs*mz**2*mmo**2-4*sdet3cmous*stw**2*qup*vpaup*qmo*us+4*sdet3cmous
     & *stw**2*qup*vpaup*qmo*mmo**2+sdet3cmous*qup*vmaup*vpamo/qs*mz**2*
     & mmo**2+2*sdet3cmous*qup*vmaup*vpamo*mmo**2)
     & +sdet4imotsus*c0upupqszupc*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*qs*us+2*stw**2*qup*vpaup*qmo*us*mz**2-2*stw**2*qup*vmaup*q
     & mo*qs*ts+2*stw**2*qup*vmaup*qmo*ts*mz**2+qup*vpaup*vpamo*qs*mmo**
     & 2-qup*vpaup*vpamo*mz**2*mmo**2+qup*vmaup*vpamo*qs*mmo**2-qup*vmau
     & p*vpamo*mz**2*mmo**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(-2*stw**2*qup*vpa
     & up*qmo*qs*us+2*stw**2*qup*vpaup*qmo*us*mz**2-8*stw**2*qup*vpaup*q
     & mo*us*mmo**2-2*stw**2*qup*vmaup*qmo*qs*ts+2*stw**2*qup*vmaup*qmo*
     & ts*mz**2-8*stw**2*qup*vmaup*qmo*ts*mmo**2+qup*vpaup*vpamo/qs*ts*m
     & z**2*mmo**2-qup*vpaup*vpamo/qs*us*mz**2*mmo**2+qup*vpaup*vpamo*ts
     & *mmo**2-qup*vpaup*vpamo*us*mmo**2+4*qup*vpaup*vpamo*mmo**4-qup*vm
     & aup*vpamo/qs*ts*mz**2*mmo**2+qup*vmaup*vpamo/qs*us*mz**2*mmo**2-q
     & up*vmaup*vpamo*ts*mmo**2+qup*vmaup*vpamo*us*mmo**2+4*qup*vmaup*vp
     & amo*mmo**4-4*sdet3cmots*stw**2*qup*vmaup*qmo*mmo**2-2*sdet3cmots*
     & qup*vpaup*vpamo/qs*mz**2*mmo**2-4*sdet3cmots*qup*vpaup*vpamo*mmo*
     & *2-4*sdet3cmous*stw**2*qup*vpaup*qmo*mmo**2-2*sdet3cmous*qup*vmau
     & p*vpamo/qs*mz**2*mmo**2-4*sdet3cmous*qup*vmaup*vpamo*mmo**2)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(8*stw**2
     & *ctw**2*qup**2*qmo*qs*mmo**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*vpau
     & p*qmo*mmo**4-4*stw**2*qup*vmaup*qmo*mmo**4+2*qup*vpaup*vpamo*ts*m
     & mo**2+2*qup*vmaup*vpamo*ts*mmo**2-8*sdet3cmots*stw**2*qup*vmaup*q
     & mo*ts+8*sdet3cmots*stw**2*qup*vmaup*qmo*mmo**2+2*sdet3cmots*qup*v
     & paup*vpamo/qs*mz**2*mmo**2+4*sdet3cmots*qup*vpaup*vpamo*mmo**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*vpau
     & p*qmo*mmo**4-4*stw**2*qup*vmaup*qmo*mmo**4+2*qup*vpaup*vpamo*us*m
     & mo**2+2*qup*vmaup*vpamo*us*mmo**2-8*sdet3cmous*stw**2*qup*vpaup*q
     & mo*us+8*sdet3cmous*stw**2*qup*vpaup*qmo*mmo**2+2*sdet3cmous*qup*v
     & maup*vpamo/qs*mz**2*mmo**2+4*sdet3cmous*qup*vmaup*vpamo*mmo**2)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(16*stw**2*ct
     & w**2*qup**2*qmo*mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*ifi*(4*stw**2*qup*vpaup*qmo
     & *us+4*stw**2*qup*vmaup*qmo*ts-2*qup*vpaup*vpamo*mmo**2-2*qup*vmau
     & p*vpamo*mmo**2)
     & +sdet4imotsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(-4*sdet3cmots
     & *stw**2*ctw**2*qup**2*qmo-4*sdet3cmous*stw**2*ctw**2*qup**2*qmo)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*cfscheme*(-8*stw**2*ct
     & w**2*qup**2*qmo*mmo**2+4*sdet3cmots*stw**2*ctw**2*qup**2*qmo)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(-4*stw**2*qup*vmaup*q
     & mo*ts+2*qup*vpaup*vpamo*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*cfscheme*(-8*stw**2*ct
     & w**2*qup**2*qmo*mmo**2+4*sdet3cmous*stw**2*ctw**2*qup**2*qmo)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(-4*stw**2*qup*vpaup*q
     & mo*us+2*qup*vmaup*vpamo*mmo**2)
     & +javqstsupmoz*ifi*(4*sdet3cmots*stw**2*qup*vpaup*qmo-4*sdet3cmots
     & *stw**2*qup*vmaup*qmo)
     & +javqstsupmoz*dreal(propizqs)*ifi*(2*stw**2*qup*vpaup*qmo/qs*mmo*
     & *2+2*stw**2*qup*vmaup*qmo/qs*mmo**2+qup*vpaup*vpamo/qs*mmo**2+qup
     & *vmaup*vpamo/qs*mmo**2)
     & +javqsusupmoz*ifi*(-4*sdet3cmous*stw**2*qup*vpaup*qmo+4*sdet3cmou
     & s*stw**2*qup*vmaup*qmo)
     & +javqsusupmoz*dreal(propizqs)*ifi*(2*stw**2*qup*vpaup*qmo/qs*mmo*
     & *2+2*stw**2*qup*vmaup*qmo/qs*mmo**2+qup*vpaup*vpamo/qs*mmo**2+qup
     & *vmaup*vpamo/qs*mmo**2)
     & +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     & +c0irupmots*ifi*(-4*sdet3cmots*stw**2*qup*vpaup*qmo+4*sdet3cmots*
     & stw**2*qup*vmaup*qmo)
     & +c0irupmous*ifi*(4*sdet3cmous*stw**2*qup*vpaup*qmo-4*sdet3cmous*s
     & tw**2*qup*vmaup*qmo)
     & +c0irmomoqs*fsr*(-2*stw**2*qmo**2*qs-4*stw**2*qmo**2*mmo**2)
     & +c0cmotsczmo*ifi*(4*sdet3cmots*stw**2*qup*vpaup*qmo-4*sdet3cmots*
     & stw**2*qup*vmaup*qmo)
     & +c0cmousczmo*ifi*(-4*sdet3cmous*stw**2*qup*vpaup*qmo+4*sdet3cmous
     & *stw**2*qup*vmaup*qmo)
     & +a0fup*isr*(-3*stw**2*qup**2)
     & +a0fmo*fsr*(-3*stw**2*qmo**2)
     & +b0fqsmomo*fsr*(-3*stw**2*qmo**2)
     & +b0fqscc*isr*(-3*stw**2*qup**2)
     & +lnlaupm*isr*(2*stw**2*qup**2)
     & +lnlamom*fsr*(2*stw**2*qmo**2)

      ff_qed_qq =
     & +isr*(-stw**2*qup**2)
     & +fsr*(-stw**2*qmo**2)
     & +prop1zqs*c0irupupqs*isr*cfscheme*(2*stw**2*qup**2-2*qup**2)
     & +prop1zqs*c0irmoupts*ifi*cfscheme*(-4*sdet3cmots*ctw**2*qup*qmo/q
     & s)
     & +prop1zqs*c0irmoupus*ifi*cfscheme*(4*sdet3cmous*ctw**2*qup*qmo/qs
     & )
     & +prop1zqs*c0irmomoqs*fsr*cfscheme*(4*stw**2*qmo**2/qs*mmo**2+2*st
     & w**2*qmo**2-4*qmo**2/qs*mmo**2-2*qmo**2)
     & +prop1zqs*lnlaupm*isr*cfscheme*(-2*stw**2*qup**2/qs+2*qup**2/qs)
     & +prop1zqs*lnlamom*fsr*cfscheme*(-2*stw**2*qmo**2/qs+2*qmo**2/qs)
     & +det3imomoqs*fsr*(-1d0/2*qmo*qs*mmo**2)
     & +det3imomoqs*a0fmo*fsr*(1d0/2*qmo*qs*mmo**2)
     & +det3imomoqs*b0fqsmomo*fsr*(1d0/2*qmo*qs*mmo**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(4*stw*
     & *2*qup*qmo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(
     & 4*ctw**2*qup*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*cfscheme*(
     & -4*ctw**2*qup*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(-8*stw**2
     & *qup*qmo*ts*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-2*qup*vp
     & amo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(
     & -4*ctw**2*qup*qmo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-2*qup*vp
     & amo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*cfscheme*(
     & 4*ctw**2*qup*qmo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(4*qup*vpa
     & mo*mmo**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*ifi*(-2*qup*vpamo/qs*mz*
     & *2*mmo**2)
     & +sdet4imotsus**2*jaaqstsupmo*dreal(propizqs)*ifi*cfscheme*(-sdet3
     & cmots**3*ctw**2*qup*qmo*ts+sdet3cmots**3*ctw**2*qup*qmo*mmo**2)
     & +sdet4imotsus**2*jaaqsusupmo*dreal(propizqs)*ifi*cfscheme*(sdet3c
     & mous**3*ctw**2*qup*qmo*ts-sdet3cmous**3*ctw**2*qup*qmo*mmo**2)
     & +sdet4imotsus**2*javqstsupmoz*dreal(propizqs)*ifi*(-2*sdet3cmots*
     & stw**2*qup*qmo*qs*ts*mmo**2+2*sdet3cmots*stw**2*qup*qmo*qs*ts**2-
     & 2*sdet3cmots*stw**2*qup*qmo*ts*mz**2*mmo**2+2*sdet3cmots*stw**2*q
     & up*qmo*ts**2*mz**2)
     & +sdet4imotsus**2*javqsusupmoz*dreal(propizqs)*ifi*(-sdet3cmous*qu
     & p*vpamo*qs*us*mmo**2+sdet3cmous*qup*vpamo*qs*mmo**4-sdet3cmous*qu
     & p*vpamo*us*mz**2*mmo**2+sdet3cmous*qup*vpamo*mz**2*mmo**4)
     & +sdet4imotsus**2*c0upupqszupc*dreal(propizqs)*ifi*(-2*sdet3cmots*
     & *2*stw**2*qup*qmo*qs*ts+2*sdet3cmots**2*stw**2*qup*qmo*qs*mmo**2-
     & 2*sdet3cmots**2*stw**2*qup*qmo*ts*mz**2+2*sdet3cmots**2*stw**2*qu
     & p*qmo*mz**2*mmo**2-sdet3cmous*qup*vpamo*qs*ts*mmo**2+sdet3cmous*q
     & up*vpamo*qs*us*mmo**2-sdet3cmous*qup*vpamo*ts*mz**2*mmo**2+sdet3c
     & mous*qup*vpamo*us*mz**2*mmo**2)
     & +sdet4imotsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(-ctw*
     & *2*qup*qmo*qs**2*ts*us-ctw**2*qup*qmo*qs**2*ts*mmo**2+ctw**2*qup*
     & qmo*qs**2*ts**2+ctw**2*qup*qmo*qs**2*us*mmo**2)
     & +sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*ifi*(4*sdet3cmots*s
     & tw**2*qup*qmo*qs*ts*mmo**2-2*sdet3cmots*stw**2*qup*qmo*qs*ts**2-2
     & *sdet3cmots*stw**2*qup*qmo*qs*mmo**4+4*sdet3cmots*stw**2*qup*qmo*
     & ts*mz**2*mmo**2-2*sdet3cmots*stw**2*qup*qmo*ts**2*mz**2-2*sdet3cm
     & ots*stw**2*qup*qmo*mz**2*mmo**4+sdet3cmous*qup*vpamo*qs*ts*mmo**2
     & +sdet3cmous*qup*vpamo*qs*us*mmo**2-2*sdet3cmous*qup*vpamo*qs*mmo*
     & *4+sdet3cmous*qup*vpamo*ts*mz**2*mmo**2+sdet3cmous*qup*vpamo*us*m
     & z**2*mmo**2-2*sdet3cmous*qup*vpamo*mz**2*mmo**4)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(-4*ct
     & w**2*qup*qmo*qs*ts*us*mmo**2-4*ctw**2*qup*qmo*qs*ts*mmo**4+4*ctw*
     & *2*qup*qmo*qs*ts**2*mmo**2+4*ctw**2*qup*qmo*qs*us*mmo**4-ctw**2*q
     & up*qmo*qs**2*ts*us-ctw**2*qup*qmo*qs**2*ts*mmo**2+ctw**2*qup*qmo*
     & qs**2*ts**2+ctw**2*qup*qmo*qs**2*us*mmo**2+8*sdet3cmots*ctw**2*qu
     & p*qmo*qs*mmo**4+2*sdet3cmots*ctw**2*qup*qmo*qs**2*mmo**2)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*ifi*(-4*sdet3cmots*s
     & tw**2*qup*qmo*qs*ts*mmo**2+4*sdet3cmots*stw**2*qup*qmo*qs*ts**2-4
     & *sdet3cmots*stw**2*qup*qmo*ts*mz**2*mmo**2+4*sdet3cmots*stw**2*qu
     & p*qmo*ts**2*mz**2)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*ifi*(-2*sdet3cmous*q
     & up*vpamo*qs*us*mmo**2+2*sdet3cmous*qup*vpamo*qs*mmo**4-2*sdet3cmo
     & us*qup*vpamo*us*mz**2*mmo**2+2*sdet3cmous*qup*vpamo*mz**2*mmo**4)
     & 
     & +sdet4imotsus*jaaqstsupmo*dreal(propizqs)*ifi*cfscheme*(sdet3cmot
     & s*ctw**2*qup*qmo*ts)
     & +sdet4imotsus*jaaqsusupmo*dreal(propizqs)*ifi*cfscheme*(-sdet3cmo
     & us*ctw**2*qup*qmo*us)
     & +sdet4imotsus*javqstsupmoz*dreal(propizqs)*ifi*(2*stw**2*qup*qmo*
     & mmo**4-qup*vpamo*ts*mmo**2-2*sdet3cmots*stw**2*qup*qmo/qs*mz**2*m
     & mo**2+4*sdet3cmots*stw**2*qup*qmo*ts-4*sdet3cmots*stw**2*qup*qmo*
     & mmo**2)
     & +sdet4imotsus*javqsusupmoz*dreal(propizqs)*ifi*(2*stw**2*qup*qmo*
     & mmo**4-qup*vpamo*us*mmo**2-sdet3cmous*qup*vpamo/qs*mz**2*mmo**2-2
     & *sdet3cmous*qup*vpamo*mmo**2)
     & +sdet4imotsus*c0upupqszupc*dreal(propizqs)*ifi*(2*stw**2*qup*qmo*
     & qs*ts-2*stw**2*qup*qmo*ts*mz**2-qup*vpamo*qs*mmo**2+qup*vpamo*mz*
     & *2*mmo**2)
     & +sdet4imotsus*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(ctw**2*q
     & up*qmo*qs*ts-ctw**2*qup*qmo*qs*us)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(2*stw**2*qup*qmo*
     & qs*ts-2*stw**2*qup*qmo*ts*mz**2+8*stw**2*qup*qmo*ts*mmo**2+qup*vp
     & amo/qs*ts*mz**2*mmo**2-qup*vpamo/qs*us*mz**2*mmo**2+qup*vpamo*ts*
     & mmo**2-qup*vpamo*us*mmo**2-4*qup*vpamo*mmo**4+4*sdet3cmots*stw**2
     & *qup*qmo*mmo**2+2*sdet3cmous*qup*vpamo/qs*mz**2*mmo**2+4*sdet3cmo
     & us*qup*vpamo*mmo**2)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(ctw**2*q
     & up*qmo*qs*ts-ctw**2*qup*qmo*qs*us+2*ctw**2*qup*qmo*qs*mmo**2+4*ct
     & w**2*qup*qmo*ts*mmo**2-4*ctw**2*qup*qmo*us*mmo**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*m
     & mo**4-2*qup*vpamo*ts*mmo**2+8*sdet3cmots*stw**2*qup*qmo*ts-8*sdet
     & 3cmots*stw**2*qup*qmo*mmo**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*m
     & mo**4-2*qup*vpamo*us*mmo**2-2*sdet3cmous*qup*vpamo/qs*mz**2*mmo**
     & 2-4*sdet3cmous*qup*vpamo*mmo**2)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(4*ctw**2*qup
     & *qmo*mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*ifi*(-4*stw**2*qup*qmo*ts+2
     & *qup*vpamo*mmo**2)
     & +sdet4imotsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(-2*sdet3cmots
     & *ctw**2*qup*qmo)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*cfscheme*(-2*ctw**2*qu
     & p*qmo*mmo**2+2*sdet3cmots*ctw**2*qup*qmo)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(4*stw**2*qup*qmo*ts)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*cfscheme*(-2*ctw**2*qu
     & p*qmo*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(-2*qup*vpamo*mmo**2)
     & +jaaqstsupmo*dreal(propizqs)*ifi*cfscheme*(2*sdet3cmots*ctw**2*qu
     & p*qmo/qs)
     & +jaaqsusupmo*dreal(propizqs)*ifi*cfscheme*(-2*sdet3cmous*ctw**2*q
     & up*qmo/qs)
     & +javqstsupmoz*ifi*(4*sdet3cmots*stw**2*qup*qmo)
     & +javqstsupmoz*dreal(propizqs)*ifi*(-2*stw**2*qup*qmo/qs*mmo**2-qu
     & p*vpamo/qs*mmo**2)
     & +javqsusupmoz*ifi*(-4*sdet3cmous*stw**2*qup*qmo)
     & +javqsusupmoz*dreal(propizqs)*ifi*(-2*stw**2*qup*qmo/qs*mmo**2-qu
     & p*vpamo/qs*mmo**2)
     & +c0irupupqs*isr*(-2*stw**2*qup**2*qs)
     & +c0irupmots*ifi*(-4*sdet3cmots*stw**2*qup*qmo)
     & +c0irupmous*ifi*(4*sdet3cmous*stw**2*qup*qmo)
     & +c0irmomoqs*fsr*(-2*stw**2*qmo**2*qs-4*stw**2*qmo**2*mmo**2)
     & +c0cmotsczmo*ifi*(4*sdet3cmots*stw**2*qup*qmo)
     & +c0cmousczmo*ifi*(-4*sdet3cmous*stw**2*qup*qmo)
     & +a0fup*isr*(-3*stw**2*qup**2)
     & +a0fup*dreal(propizqs)*isr*cfscheme*(3*stw**2*qup**2/qs-3*qup**2/
     & qs)
     & +a0fmo*fsr*(-3*stw**2*qmo**2)
     & +a0fmo*dreal(propizqs)*fsr*cfscheme*(3*stw**2*qmo**2/qs-3*qmo**2/
     & qs)
     & +b0fqsmomo*fsr*(-3*stw**2*qmo**2)
     & +b0fqsmomo*dreal(propizqs)*fsr*cfscheme*(3*stw**2*qmo**2/qs-3*qmo
     & **2/qs)
     & +b0fqscc*isr*(-3*stw**2*qup**2)
     & +b0fqscc*dreal(propizqs)*isr*cfscheme*(3*stw**2*qup**2/qs-3*qup**
     & 2/qs)
     & +lnlaupm*isr*(2*stw**2*qup**2)
     & +lnlamom*fsr*(2*stw**2*qmo**2)
     & +dreal(propizqs)*isr*cfscheme*(stw**2*qup**2/qs-qup**2/qs)
     & +dreal(propizqs)*fsr*cfscheme*(stw**2*qmo**2/qs-qmo**2/qs)

      ff_qed_ld=
     & +det3imomoqs*fsr*(stw**2*qmo**2*vpamo*qs+1d0/2*stw**2*qmo**2*qs)
     & +det3imomoqs*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(-stw*
     & *2*qup*vpaup*qmo*vpamo*qs*ts*mz**2+4*stw**2*qup*vpaup*qmo*vpamo*q
     & s*ts*mmo**2+stw**2*qup*vpaup*qmo*vpamo*qs*mz**2*mmo**2-4*stw**2*q
     & up*vpaup*qmo*vpamo*qs*mmo**4+stw**2*qup*vpaup*qmo*vmamo*qs*us*mz*
     & *2-4*stw**2*qup*vpaup*qmo*vmamo*qs*us*mmo**2-stw**2*qup*vpaup*qmo
     & *vmamo*qs*mz**2*mmo**2+4*stw**2*qup*vpaup*qmo*vmamo*qs*mmo**4-stw
     & **2*qup*vmaup*qmo*vpamo*qs*us*mz**2+4*stw**2*qup*vmaup*qmo*vpamo*
     & qs*us*mmo**2+stw**2*qup*vmaup*qmo*vpamo*qs*mz**2*mmo**2-4*stw**2*
     & qup*vmaup*qmo*vpamo*qs*mmo**4+stw**2*qup*vmaup*qmo*vmamo*qs*ts*mz
     & **2-4*stw**2*qup*vmaup*qmo*vmamo*qs*ts*mmo**2-stw**2*qup*vmaup*qm
     & o*vmamo*qs*mz**2*mmo**2+4*stw**2*qup*vmaup*qmo*vmamo*qs*mmo**4)
     & +det3imomoqs*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(stw**2*qu
     & p*vpaup*qmo*vpamo*qs*ts-stw**2*qup*vpaup*qmo*vpamo*qs*mmo**2-stw*
     & *2*qup*vpaup*qmo*vmamo*qs*us+stw**2*qup*vpaup*qmo*vmamo*qs*mmo**2
     & +stw**2*qup*vmaup*qmo*vpamo*qs*us-stw**2*qup*vmaup*qmo*vpamo*qs*m
     & mo**2-stw**2*qup*vmaup*qmo*vmamo*qs*ts+stw**2*qup*vmaup*qmo*vmamo
     & *qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(stw**2*qu
     & p*vpaup*qmo*vpamo*qs*ts-stw**2*qup*vpaup*qmo*vpamo*qs*mmo**2-stw*
     & *2*qup*vpaup*qmo*vmamo*qs*us+stw**2*qup*vpaup*qmo*vmamo*qs*mmo**2
     & +stw**2*qup*vmaup*qmo*vpamo*qs*us-stw**2*qup*vmaup*qmo*vpamo*qs*m
     & mo**2-stw**2*qup*vmaup*qmo*vmamo*qs*ts+stw**2*qup*vmaup*qmo*vmamo
     & *qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fqszc*dreal(propizqs)*ifi*(-2*stw**2*
     & qup*vpaup*qmo*vpamo*qs*ts+2*stw**2*qup*vpaup*qmo*vpamo*qs*mmo**2+
     & 2*stw**2*qup*vpaup*qmo*vmamo*qs*us-2*stw**2*qup*vpaup*qmo*vmamo*q
     & s*mmo**2-2*stw**2*qup*vmaup*qmo*vpamo*qs*us+2*stw**2*qup*vmaup*qm
     & o*vpamo*qs*mmo**2+2*stw**2*qup*vmaup*qmo*vmamo*qs*ts-2*stw**2*qup
     & *vmaup*qmo*vmamo*qs*mmo**2)
     & +det3imomoqs*a0fmo*fsr*(-stw**2*qmo**2*vpamo*qs-1d0/2*stw**2*qmo*
     & *2*qs)
     & +det3imomoqs*b0fqsmomo*fsr*(-stw**2*qmo**2*vpamo*qs-1d0/2*stw**2*
     & qmo**2*qs)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw
     & **2*qup*vpaup*qmo*vpamo*ts*mz**2+4*stw**2*qup*vmaup*qmo*vmamo*ts*
     & mz**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*vpamo*ts+4*stw**2*qup*vmaup*qmo*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*vpaup*qmo*vpamo*ts+4*stw**2*qup*vmaup*qmo*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(8*stw**2*
     & qup*vpaup*qmo*vpamo*ts-8*stw**2*qup*vmaup*qmo*vmamo*ts)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(4*stw*
     & *2*qup*vpaup*qmo*vmamo*us*mz**2-4*stw**2*qup*vmaup*qmo*vpamo*us*m
     & z**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(4*stw**2*
     & qup*vpaup*qmo*vmamo*us-4*stw**2*qup*vmaup*qmo*vpamo*us)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(4*stw**2*
     & qup*vpaup*qmo*vmamo*us-4*stw**2*qup*vmaup*qmo*vpamo*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(-8*stw**2
     & *qup*vpaup*qmo*vmamo*us+8*stw**2*qup*vmaup*qmo*vpamo*us)
     & +sdet4imotsus**2*javqstsupmoz*dreal(propizqs)*ifi*(4*sdet3cmots*s
     & tw**2*qup*vpaup*qmo*vpamo*qs*ts+4*sdet3cmots*stw**2*qup*vpaup*qmo
     & *vpamo*ts*mz**2-4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*ts-4*s
     & det3cmots*stw**2*qup*vmaup*qmo*vmamo*ts*mz**2)
     & +sdet4imotsus**2*javqsusupmoz*dreal(propizqs)*ifi*(-4*sdet3cmous*
     & stw**2*qup*vpaup*qmo*vmamo*qs*us-4*sdet3cmous*stw**2*qup*vpaup*qm
     & o*vmamo*us*mz**2+4*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us+4*
     & sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*us*mz**2)
     & +sdet4imotsus**2*c0upupqszupc*dreal(propizqs)*ifi*(-4*sdet3cmots*
     & *2*stw**2*qup*vpaup*qmo*vpamo*qs-4*sdet3cmots**2*stw**2*qup*vpaup
     & *qmo*vpamo*mz**2+4*sdet3cmots**2*stw**2*qup*vmaup*qmo*vmamo*qs+4*
     & sdet3cmots**2*stw**2*qup*vmaup*qmo*vmamo*mz**2+4*sdet3cmous**2*st
     & w**2*qup*vpaup*qmo*vmamo*qs+4*sdet3cmous**2*stw**2*qup*vpaup*qmo*
     & vmamo*mz**2-4*sdet3cmous**2*stw**2*qup*vmaup*qmo*vpamo*qs-4*sdet3
     & cmous**2*stw**2*qup*vmaup*qmo*vpamo*mz**2)
     & +sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*ifi*(-4*sdet3cmots*
     & stw**2*qup*vpaup*qmo*vpamo*qs*ts+4*sdet3cmots*stw**2*qup*vpaup*qm
     & o*vpamo*qs*mmo**2-4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*ts*mz**
     & 2+4*sdet3cmots*stw**2*qup*vpaup*qmo*vpamo*mz**2*mmo**2+4*sdet3cmo
     & ts*stw**2*qup*vmaup*qmo*vmamo*qs*ts-4*sdet3cmots*stw**2*qup*vmaup
     & *qmo*vmamo*qs*mmo**2+4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*ts*m
     & z**2-4*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*mz**2*mmo**2+4*sdet3
     & cmous*stw**2*qup*vpaup*qmo*vmamo*qs*us-4*sdet3cmous*stw**2*qup*vp
     & aup*qmo*vmamo*qs*mmo**2+4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*u
     & s*mz**2-4*sdet3cmous*stw**2*qup*vpaup*qmo*vmamo*mz**2*mmo**2-4*sd
     & et3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us+4*sdet3cmous*stw**2*qup
     & *vmaup*qmo*vpamo*qs*mmo**2-4*sdet3cmous*stw**2*qup*vmaup*qmo*vpam
     & o*us*mz**2+4*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*mz**2*mmo**2)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*ifi*(8*sdet3cmots*st
     & w**2*qup*vpaup*qmo*vpamo*qs*ts+8*sdet3cmots*stw**2*qup*vpaup*qmo*
     & vpamo*ts*mz**2-8*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo*qs*ts-8*sd
     & et3cmots*stw**2*qup*vmaup*qmo*vmamo*ts*mz**2)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*ifi*(-8*sdet3cmous*s
     & tw**2*qup*vpaup*qmo*vmamo*qs*us-8*sdet3cmous*stw**2*qup*vpaup*qmo
     & *vmamo*us*mz**2+8*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo*qs*us+8*s
     & det3cmous*stw**2*qup*vmaup*qmo*vpamo*us*mz**2)
     & +sdet4imotsus*javqstsupmoz*dreal(propizqs)*ifi*(2*sdet3cmots*stw*
     & *2*qup*vpaup*qmo*vpamo/qs*mz**2+4*sdet3cmots*stw**2*qup*vpaup*qmo
     & *vpamo-2*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo/qs*mz**2-4*sdet3cm
     & ots*stw**2*qup*vmaup*qmo*vmamo-2*sdet3cmots**2*stw**2*qup*vpaup*q
     & mo*vpamo/qs+2*sdet3cmots**2*stw**2*qup*vpaup*qmo*vmamo/qs-2*sdet3
     & cmots**2*stw**2*qup*vmaup*qmo*vpamo/qs+2*sdet3cmots**2*stw**2*qup
     & *vmaup*qmo*vmamo/qs)
     & +sdet4imotsus*javqsusupmoz*dreal(propizqs)*ifi*(-2*sdet3cmous*stw
     & **2*qup*vpaup*qmo*vmamo/qs*mz**2-4*sdet3cmous*stw**2*qup*vpaup*qm
     & o*vmamo+2*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo/qs*mz**2+4*sdet3c
     & mous*stw**2*qup*vmaup*qmo*vpamo-2*sdet3cmous**2*stw**2*qup*vpaup*
     & qmo*vpamo/qs+2*sdet3cmous**2*stw**2*qup*vpaup*qmo*vmamo/qs-2*sdet
     & 3cmous**2*stw**2*qup*vmaup*qmo*vpamo/qs+2*sdet3cmous**2*stw**2*qu
     & p*vmaup*qmo*vmamo/qs)
     & +sdet4imotsus*c0upupqszupc*dreal(propizqs)*ifi*(2*stw**2*qup*vpau
     & p*qmo*vpamo*qs-2*stw**2*qup*vpaup*qmo*vpamo*mz**2-2*stw**2*qup*vp
     & aup*qmo*vmamo*qs+2*stw**2*qup*vpaup*qmo*vmamo*mz**2+2*stw**2*qup*
     & vmaup*qmo*vpamo*qs-2*stw**2*qup*vmaup*qmo*vpamo*mz**2-2*stw**2*qu
     & p*vmaup*qmo*vmamo*qs+2*stw**2*qup*vmaup*qmo*vmamo*mz**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(2*stw**2*qup*vpau
     & p*qmo*vpamo*qs+2*stw**2*qup*vpaup*qmo*vpamo*mz**2-2*stw**2*qup*vp
     & aup*qmo*vmamo*qs-2*stw**2*qup*vpaup*qmo*vmamo*mz**2+2*stw**2*qup*
     & vmaup*qmo*vpamo*qs+2*stw**2*qup*vmaup*qmo*vpamo*mz**2-2*stw**2*qu
     & p*vmaup*qmo*vmamo*qs-2*stw**2*qup*vmaup*qmo*vmamo*mz**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(4*stw**2*qup*vpaup
     & *qmo*vpamo*ts-4*stw**2*qup*vpaup*qmo*vmamo*ts+4*stw**2*qup*vmaup*
     & qmo*vpamo*ts-4*stw**2*qup*vmaup*qmo*vmamo*ts+8*sdet3cmots*stw**2*
     & qup*vpaup*qmo*vpamo-8*sdet3cmots*stw**2*qup*vmaup*qmo*vmamo)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(4*stw**2*qup*vpaup
     & *qmo*vpamo*us-4*stw**2*qup*vpaup*qmo*vmamo*us+4*stw**2*qup*vmaup*
     & qmo*vpamo*us-4*stw**2*qup*vmaup*qmo*vmamo*us-8*sdet3cmous*stw**2*
     & qup*vpaup*qmo*vmamo+8*sdet3cmous*stw**2*qup*vmaup*qmo*vpamo)

      ff_qed_qd =
     & +det3imomoqs*fsr*(stw**2*qmo**2*vpamo*qs+1d0/2*stw**2*qmo**2*qs)
     & +det3imomoqs*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(stw**
     & 2*qup*qmo*vpamo*qs*us*mz**2-4*stw**2*qup*qmo*vpamo*qs*us*mmo**2-s
     & tw**2*qup*qmo*vpamo*qs*mz**2*mmo**2+4*stw**2*qup*qmo*vpamo*qs*mmo
     & **4-stw**2*qup*qmo*vmamo*qs*ts*mz**2+4*stw**2*qup*qmo*vmamo*qs*ts
     & *mmo**2+stw**2*qup*qmo*vmamo*qs*mz**2*mmo**2-4*stw**2*qup*qmo*vma
     & mo*qs*mmo**4)
     & +det3imomoqs*sdet4imotsus*c0momoqscmoc*dreal(propizqs)*ifi*cfsche
     & me*(-4*stw**2*ctw**2*qup*qmo**2*qs*ts*mmo**2+4*stw**2*ctw**2*qup*
     & qmo**2*qs*us*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-stw**2*q
     & up*qmo*vpamo*qs*us+stw**2*qup*qmo*vpamo*qs*mmo**2+stw**2*qup*qmo*
     & vmamo*qs*ts-stw**2*qup*qmo*vmamo*qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(
     & -2*stw**2*ctw**2*qup*qmo**2*qs*ts+2*stw**2*ctw**2*qup*qmo**2*qs*u
     & s)
     & +det3imomoqs*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-stw**2*q
     & up*qmo*vpamo*qs*us+stw**2*qup*qmo*vpamo*qs*mmo**2+stw**2*qup*qmo*
     & vmamo*qs*ts-stw**2*qup*qmo*vmamo*qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fqszc*dreal(propizqs)*ifi*(2*stw**2*q
     & up*qmo*vpamo*qs*us-2*stw**2*qup*qmo*vpamo*qs*mmo**2-2*stw**2*qup*
     & qmo*vmamo*qs*ts+2*stw**2*qup*qmo*vmamo*qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fqscc*dreal(propizqs)*ifi*cfscheme*(2
     & *stw**2*ctw**2*qup*qmo**2*qs*ts-2*stw**2*ctw**2*qup*qmo**2*qs*us)
     & 
     & +det3imomoqs*a0fmo*fsr*(-stw**2*qmo**2*vpamo*qs-1d0/2*stw**2*qmo*
     & *2*qs)
     & +det3imomoqs*a0fmo*dreal(propizqs)*fsr*cfscheme*(2*stw**2*ctw**2*
     & qmo**3)
     & +det3imomoqs*b0fqsmomo*fsr*(-stw**2*qmo**2*vpamo*qs-1d0/2*stw**2*
     & qmo**2*qs)
     & +det3imomoqs*b0fqsmomo*dreal(propizqs)*fsr*cfscheme*(2*stw**2*ctw
     & **2*qmo**3)
     & +det3imomoqs*dreal(propizqs)*fsr*cfscheme*(-2*stw**2*ctw**2*qmo**
     & 3)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw
     & **2*qup*qmo*vmamo*ts*mz**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*qmo*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(
     & 8*stw**2*ctw**2*qup*qmo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(-4*stw**2
     & *qup*qmo*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*cfscheme*(
     & -8*stw**2*ctw**2*qup*qmo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*ifi*(8*stw**2*
     & qup*qmo*vmamo*ts)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(4*stw*
     & *2*qup*qmo*vpamo*us*mz**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*vpamo*us)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*cfscheme*(
     & -8*stw**2*ctw**2*qup*qmo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*ifi*(4*stw**2*
     & qup*qmo*vpamo*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*cfscheme*(
     & 8*stw**2*ctw**2*qup*qmo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*ifi*(-8*stw**2
     & *qup*qmo*vpamo*us)
     & +sdet4imotsus**2*jaaqstsupmo*dreal(propizqs)*ifi*cfscheme*(4*sdet
     & 3cmots**3*stw**2*ctw**2*qup*qmo**2)
     & +sdet4imotsus**2*jaaqsusupmo*dreal(propizqs)*ifi*cfscheme*(-4*sde
     & t3cmous**3*stw**2*ctw**2*qup*qmo**2)
     & +sdet4imotsus**2*javqstsupmoz*dreal(propizqs)*ifi*(4*sdet3cmots*s
     & tw**2*qup*qmo*vmamo*qs*ts+4*sdet3cmots*stw**2*qup*qmo*vmamo*ts*mz
     & **2)
     & +sdet4imotsus**2*javqsusupmoz*dreal(propizqs)*ifi*(-4*sdet3cmous*
     & stw**2*qup*qmo*vpamo*qs*us-4*sdet3cmous*stw**2*qup*qmo*vpamo*us*m
     & z**2)
     & +sdet4imotsus**2*c0upupqszupc*dreal(propizqs)*ifi*(-4*sdet3cmots*
     & *2*stw**2*qup*qmo*vmamo*qs-4*sdet3cmots**2*stw**2*qup*qmo*vmamo*m
     & z**2+4*sdet3cmous**2*stw**2*qup*qmo*vpamo*qs+4*sdet3cmous**2*stw*
     & *2*qup*qmo*vpamo*mz**2)
     & +sdet4imotsus**2*c0upupqscupc*dreal(propizqs)*ifi*cfscheme*(-4*st
     & w**2*ctw**2*qup*qmo**2*qs**2*ts+4*stw**2*ctw**2*qup*qmo**2*qs**2*
     & us)
     & +sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*ifi*(-4*sdet3cmots*
     & stw**2*qup*qmo*vmamo*qs*ts+4*sdet3cmots*stw**2*qup*qmo*vmamo*qs*m
     & mo**2-4*sdet3cmots*stw**2*qup*qmo*vmamo*ts*mz**2+4*sdet3cmots*stw
     & **2*qup*qmo*vmamo*mz**2*mmo**2+4*sdet3cmous*stw**2*qup*qmo*vpamo*
     & qs*us-4*sdet3cmous*stw**2*qup*qmo*vpamo*qs*mmo**2+4*sdet3cmous*st
     & w**2*qup*qmo*vpamo*us*mz**2-4*sdet3cmous*stw**2*qup*qmo*vpamo*mz*
     & *2*mmo**2)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*ifi*cfscheme*(-8*st
     & w**2*ctw**2*qup*qmo**2*qs*ts*mmo**2+8*stw**2*ctw**2*qup*qmo**2*qs
     & *us*mmo**2-4*stw**2*ctw**2*qup*qmo**2*qs**2*ts+4*stw**2*ctw**2*qu
     & p*qmo**2*qs**2*us)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*ifi*(8*sdet3cmots*st
     & w**2*qup*qmo*vmamo*qs*ts+8*sdet3cmots*stw**2*qup*qmo*vmamo*ts*mz*
     & *2)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*ifi*(-8*sdet3cmous*s
     & tw**2*qup*qmo*vpamo*qs*us-8*sdet3cmous*stw**2*qup*qmo*vpamo*us*mz
     & **2)
     & +sdet4imotsus*javqstsupmoz*dreal(propizqs)*ifi*(2*sdet3cmots*stw*
     & *2*qup*qmo*vmamo/qs*mz**2+4*sdet3cmots*stw**2*qup*qmo*vmamo+2*sde
     & t3cmots**2*stw**2*qup*qmo*vpamo/qs-2*sdet3cmots**2*stw**2*qup*qmo
     & *vmamo/qs)
     & +sdet4imotsus*javqsusupmoz*dreal(propizqs)*ifi*(-2*sdet3cmous*stw
     & **2*qup*qmo*vpamo/qs*mz**2-4*sdet3cmous*stw**2*qup*qmo*vpamo+2*sd
     & et3cmous**2*stw**2*qup*qmo*vpamo/qs-2*sdet3cmous**2*stw**2*qup*qm
     & o*vmamo/qs)
     & +sdet4imotsus*c0upupqszupc*dreal(propizqs)*ifi*(-2*stw**2*qup*qmo
     & *vpamo*qs+2*stw**2*qup*qmo*vpamo*mz**2+2*stw**2*qup*qmo*vmamo*qs-
     & 2*stw**2*qup*qmo*vmamo*mz**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*ifi*(-2*stw**2*qup*qmo
     & *vpamo*qs-2*stw**2*qup*qmo*vpamo*mz**2+2*stw**2*qup*qmo*vmamo*qs+
     & 2*stw**2*qup*qmo*vmamo*mz**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*qmo*
     & vpamo*ts+4*stw**2*qup*qmo*vmamo*ts+8*sdet3cmots*stw**2*qup*qmo*vm
     & amo)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*ifi*(-4*stw**2*qup*qmo*
     & vpamo*us+4*stw**2*qup*qmo*vmamo*us-8*sdet3cmous*stw**2*qup*qmo*vp
     & amo)

      ff_ew_ll=
     & +sdet3imomoqs*c0momoqswcw*dreal(propizqs)*(-7d0/2*mw**2*rmow*rwz+
     & 3*mw**2*rmow**2*rwz+1d0/2*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*c0momoqswcw*(11*mw**4*rmow*rwz-26*mw**4*rmow**2*rwz
     & +11*mw**4*rmow**3*rwz+2*mw**4*rmow**4*rwz+2*mw**4*rwz)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/4*mw**4*rmow/rwz**2-1d0/2*mw**4*
     & rmow/rwz*rhw+1d0/4*mw**4*rmow*rhw**2+2*mw**4*rmow**2/rwz-2*mw**4*
     & rmow**2*rhw+4*mw**4*rmow**3)
     & +sdet3imomoqs*c0momoqsmozmo*(-55d0/4*mw**4*rmow/rwz**2+36*mw**4*r
     & mow/rwz-24*mw**4*rmow-7d0/2*mw**4/rwz**3+9*mw**4/rwz**2-6*mw**4/r
     & wz)
     & +sdet3imomoqs*c0momoqsmohmo*(1d0/4*mw**4*rmow*rhw**2-2*mw**4*rmow
     & **2*rhw)
     & +sdet3imomoqs*c0momoqscwc*(11d0/2*mw**4*rmow+6*mw**4*rmow**2+3d0/
     & 2*mw**4*rmow**3+mw**4)
     & +sdet3imomoqs*b0fmowc*dreal(propizqs)*(2*rmow*rwz)
     & +sdet3imomoqs*b0fmowc*(-13*mw**2*rmow*rwz+6*mw**2*rmow+7*mw**2*rm
     & ow**2*rwz+2*mw**2*rmow**2-2*mw**2*rwz+mw**2)
     & +sdet3imomoqs*b0fmozmo*(-13*mw**2*rmow/rwz-24*mw**2*rmow*rwz-1d0/
     & 4*mw**2*rmow*rhw+36*mw**2*rmow+mw**2*rmow**2-7d0/2*mw**2/rwz**2+9
     & *mw**2/rwz-6*mw**2)
     & +sdet3imomoqs*b0fmohmo*(3d0/4*mw**2*rmow/rwz-mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsww*dreal(propizqs)*(-7d0/2*rmow*rwz-1d0/2*rmow
     & **2*rwz)
     & +sdet3imomoqs*b0fqsww*(13*mw**2*rmow*rwz-13*mw**2*rmow**2*rwz-2*m
     & w**2*rmow**3*rwz+2*mw**2*rwz)
     & +sdet3imomoqs*b0fqszh*(-3d0/2*mw**2*rmow/rwz+1d0/2*mw**2*rmow*rhw
     & -2*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo*(55d0/4*mw**2*rmow/rwz+24*mw**2*rmow*rwz-
     & 1d0/4*mw**2*rmow*rhw-36*mw**2*rmow+2*mw**2*rmow**2+7d0/2*mw**2/rw
     & z**2-9*mw**2/rwz+6*mw**2)
     & +sdet3imomoqs*b0fqscc*(-9d0/2*mw**2*rmow-3d0/2*mw**2*rmow**2-mw**
     & 2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & paup**2*vpamo**2*ts*mmo**2-1d0/ctw**2*vpaup**2*vpamo**2*mmo**4-1d
     & 0/ctw**2*vmaup**2*vmamo**2*ts*mmo**2-1d0/ctw**2*vmaup**2*vmamo**2
     & *mmo**4)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/ctw**2*vp
     & aup**2*vpamo**2*ts*mmo**2+1d0/ctw**2*vpaup**2*vpamo**2*mmo**4+1d0
     & /ctw**2*vmaup**2*vmamo**2*ts*mmo**2+1d0/ctw**2*vmaup**2*vmamo**2*
     & mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & paup**2*vmamo**2*us*mmo**2-1d0/ctw**2*vpaup**2*vmamo**2*mmo**4-1d
     & 0/ctw**2*vmaup**2*vpamo**2*us*mmo**2-1d0/ctw**2*vmaup**2*vpamo**2
     & *mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/ctw**2*vp
     & aup**2*vmamo**2*us*mmo**2+1d0/ctw**2*vpaup**2*vmamo**2*mmo**4+1d0
     & /ctw**2*vmaup**2*vpamo**2*us*mmo**2+1d0/ctw**2*vmaup**2*vpamo**2*
     & mmo**4)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(1
     & d0/4/ctw**2*vpaup**2*vpamo**2*ts*mmo**4-1d0/4/ctw**2*vpaup**2*vpa
     & mo**2*us*mmo**4+1d0/4/ctw**2*vmaup**2*vmamo**2*ts*mmo**4-1d0/4/ct
     & w**2*vmaup**2*vmamo**2*us*mmo**4+1d0/4*sdet3cmots/ctw**2*vpaup**2
     & *vpamo**2*ts*mmo**2-1d0/4*sdet3cmots/ctw**2*vpaup**2*vpamo**2*mmo
     & **4+1d0/4*sdet3cmots/ctw**2*vmaup**2*vmamo**2*ts*mmo**2-1d0/4*sde
     & t3cmots/ctw**2*vmaup**2*vmamo**2*mmo**4-1d0/4*sdet3cmots**2/ctw**
     & 2*vpaup**2*vpamo**2*qs-sdet3cmots**2/ctw**2*vpaup**2*vpamo**2*mmo
     & **2-1d0/4*sdet3cmots**2/ctw**2*vmaup**2*vmamo**2*qs-sdet3cmots**2
     & /ctw**2*vmaup**2*vmamo**2*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(-
     & 1d0/4/ctw**2*vpaup**2*vmamo**2*ts*mmo**4+1d0/4/ctw**2*vpaup**2*vm
     & amo**2*us*mmo**4-1d0/4/ctw**2*vmaup**2*vpamo**2*ts*mmo**4+1d0/4/c
     & tw**2*vmaup**2*vpamo**2*us*mmo**4+1d0/4*sdet3cmous/ctw**2*vpaup**
     & 2*vmamo**2*us*mmo**2-1d0/4*sdet3cmous/ctw**2*vpaup**2*vmamo**2*mm
     & o**4+1d0/4*sdet3cmous/ctw**2*vmaup**2*vpamo**2*us*mmo**2-1d0/4*sd
     & et3cmous/ctw**2*vmaup**2*vpamo**2*mmo**4-1d0/4*sdet3cmous**2/ctw*
     & *2*vpaup**2*vmamo**2*qs-sdet3cmous**2/ctw**2*vpaup**2*vmamo**2*mm
     & o**2-1d0/4*sdet3cmous**2/ctw**2*vmaup**2*vpamo**2*qs-sdet3cmous**
     & 2/ctw**2*vmaup**2*vpamo**2*mmo**2)
     & +sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(-1d0/4*sd
     & et3cmots/ctw**2*vpaup**2*vpamo**2*qs*ts-1d0/4*sdet3cmots/ctw**2*v
     & paup**2*vpamo**2*qs*mmo**2-sdet3cmots/ctw**2*vpaup**2*vpamo**2*ts
     & *mmo**2-sdet3cmots/ctw**2*vpaup**2*vpamo**2*mmo**4-1d0/4*sdet3cmo
     & ts/ctw**2*vmaup**2*vmamo**2*qs*ts-1d0/4*sdet3cmots/ctw**2*vmaup**
     & 2*vmamo**2*qs*mmo**2-sdet3cmots/ctw**2*vmaup**2*vmamo**2*ts*mmo**
     & 2-sdet3cmots/ctw**2*vmaup**2*vmamo**2*mmo**4-1d0/4*sdet3cmous/ctw
     & **2*vpaup**2*vmamo**2*qs*us-1d0/4*sdet3cmous/ctw**2*vpaup**2*vmam
     & o**2*qs*mmo**2-sdet3cmous/ctw**2*vpaup**2*vmamo**2*us*mmo**2-sdet
     & 3cmous/ctw**2*vpaup**2*vmamo**2*mmo**4-1d0/4*sdet3cmous/ctw**2*vm
     & aup**2*vpamo**2*qs*us-1d0/4*sdet3cmous/ctw**2*vmaup**2*vpamo**2*q
     & s*mmo**2-sdet3cmous/ctw**2*vmaup**2*vpamo**2*us*mmo**2-sdet3cmous
     & /ctw**2*vmaup**2*vpamo**2*mmo**4)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     & t3cmots/ctw**2*vpaup**2*vpamo**2*ts**2+1d0/2*sdet3cmots/ctw**2*vp
     & aup**2*vpamo**2*mmo**4-1d0/2*sdet3cmots/ctw**2*vmaup**2*vmamo**2*
     & ts**2+1d0/2*sdet3cmots/ctw**2*vmaup**2*vmamo**2*mmo**4)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     & t3cmous/ctw**2*vpaup**2*vmamo**2*us**2+1d0/2*sdet3cmous/ctw**2*vp
     & aup**2*vmamo**2*mmo**4-1d0/2*sdet3cmous/ctw**2*vmaup**2*vpamo**2*
     & us**2+1d0/2*sdet3cmous/ctw**2*vmaup**2*vpamo**2*mmo**4)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     & 2*vpaup**2*vpamo**2*qs*ts*mmo**2+1d0/4/ctw**2*vpaup**2*vpamo**2*q
     & s*mmo**4-1d0/4/ctw**2*vpaup**2*vmamo**2*qs*us*mmo**2+1d0/4/ctw**2
     & *vpaup**2*vmamo**2*qs*mmo**4-1d0/4/ctw**2*vmaup**2*vpamo**2*qs*us
     & *mmo**2+1d0/4/ctw**2*vmaup**2*vpamo**2*qs*mmo**4-1d0/4/ctw**2*vma
     & up**2*vmamo**2*qs*ts*mmo**2+1d0/4/ctw**2*vmaup**2*vmamo**2*qs*mmo
     & **4+1d0/4*sdet3cmots**2/ctw**2*vpaup**2*vpamo**2*ts-1d0/4*sdet3cm
     & ots**2/ctw**2*vpaup**2*vpamo**2*mmo**2+1d0/4*sdet3cmots**2/ctw**2
     & *vmaup**2*vmamo**2*ts-1d0/4*sdet3cmots**2/ctw**2*vmaup**2*vmamo**
     & 2*mmo**2+1d0/4*sdet3cmous**2/ctw**2*vpaup**2*vmamo**2*us-1d0/4*sd
     & et3cmous**2/ctw**2*vpaup**2*vmamo**2*mmo**2+1d0/4*sdet3cmous**2/c
     & tw**2*vmaup**2*vpamo**2*us-1d0/4*sdet3cmous**2/ctw**2*vmaup**2*vp
     & amo**2*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(-1d0
     & /2/ctw**2*vpaup**2*vpamo**2*mmo**2-1d0/2/ctw**2*vmaup**2*vmamo**2
     & *mmo**2-1d0/8*sdet3cmots/ctw**2*vpaup**2*vpamo**2-1d0/8*sdet3cmot
     & s/ctw**2*vmaup**2*vmamo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     & tw**2*vpaup**2*vpamo*vmamo*ts*mmo**2+1d0/2/ctw**2*vpaup**2*vpamo*
     & vmamo*mmo**4+1d0/4/ctw**2*vpaup**2*vpamo**2*qs*mmo**2+3d0/4/ctw**
     & 2*vpaup**2*vpamo**2*ts**2-3d0/4/ctw**2*vpaup**2*vpamo**2*mmo**4+1
     & d0/2/ctw**2*vmaup**2*vpamo*vmamo*ts*mmo**2+1d0/2/ctw**2*vmaup**2*
     & vpamo*vmamo*mmo**4+1d0/4/ctw**2*vmaup**2*vmamo**2*qs*mmo**2+3d0/4
     & /ctw**2*vmaup**2*vmamo**2*ts**2-3d0/4/ctw**2*vmaup**2*vmamo**2*mm
     & o**4+sdet3cmots/ctw**2*vpaup**2*vpamo**2*mmo**2+sdet3cmots/ctw**2
     & *vmaup**2*vmamo**2*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/8/ctw**2*vp
     & aup**2*vpamo**2*qs*ts*mmo**2+1d0/8/ctw**2*vpaup**2*vpamo**2*qs*us
     & *mmo**2-1d0/8/ctw**2*vmaup**2*vmamo**2*qs*ts*mmo**2+1d0/8/ctw**2*
     & vmaup**2*vmamo**2*qs*us*mmo**2-1d0/8*sdet3cmots/ctw**2*vpaup**2*v
     & pamo**2*qs*ts+1d0/8*sdet3cmots/ctw**2*vpaup**2*vpamo**2*qs*mmo**2
     & -1d0/8*sdet3cmots/ctw**2*vmaup**2*vmamo**2*qs*ts+1d0/8*sdet3cmots
     & /ctw**2*vmaup**2*vmamo**2*qs*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(-1d0
     & /2/ctw**2*vpaup**2*vmamo**2*mmo**2-1d0/2/ctw**2*vmaup**2*vpamo**2
     & *mmo**2-1d0/8*sdet3cmous/ctw**2*vpaup**2*vmamo**2-1d0/8*sdet3cmou
     & s/ctw**2*vmaup**2*vpamo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     & tw**2*vpaup**2*vpamo*vmamo*us*mmo**2+1d0/2/ctw**2*vpaup**2*vpamo*
     & vmamo*mmo**4+1d0/4/ctw**2*vpaup**2*vmamo**2*qs*mmo**2+3d0/4/ctw**
     & 2*vpaup**2*vmamo**2*us**2-3d0/4/ctw**2*vpaup**2*vmamo**2*mmo**4+1
     & d0/2/ctw**2*vmaup**2*vpamo*vmamo*us*mmo**2+1d0/2/ctw**2*vmaup**2*
     & vpamo*vmamo*mmo**4+1d0/4/ctw**2*vmaup**2*vpamo**2*qs*mmo**2+3d0/4
     & /ctw**2*vmaup**2*vpamo**2*us**2-3d0/4/ctw**2*vmaup**2*vpamo**2*mm
     & o**4+sdet3cmous/ctw**2*vpaup**2*vmamo**2*mmo**2+sdet3cmous/ctw**2
     & *vmaup**2*vpamo**2*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/8/ctw**2*vpa
     & up**2*vmamo**2*qs*ts*mmo**2-1d0/8/ctw**2*vpaup**2*vmamo**2*qs*us*
     & mmo**2+1d0/8/ctw**2*vmaup**2*vpamo**2*qs*ts*mmo**2-1d0/8/ctw**2*v
     & maup**2*vpamo**2*qs*us*mmo**2-1d0/8*sdet3cmous/ctw**2*vpaup**2*vm
     & amo**2*qs*us+1d0/8*sdet3cmous/ctw**2*vpaup**2*vmamo**2*qs*mmo**2-
     & 1d0/8*sdet3cmous/ctw**2*vmaup**2*vpamo**2*qs*us+1d0/8*sdet3cmous/
     & ctw**2*vmaup**2*vpamo**2*qs*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(-1d0/2/ctw**
     & 2*vpaup**2*vpamo**2*mmo**2-1d0/2/ctw**2*vpaup**2*vmamo**2*mmo**2-
     & 1d0/2/ctw**2*vmaup**2*vpamo**2*mmo**2-1d0/2/ctw**2*vmaup**2*vmamo
     & **2*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2
     & *vpamo**2*ts**2-1d0/2/ctw**2*vpaup**2*vpamo**2*mmo**4+1d0/2/ctw**
     & 2*vpaup**2*vmamo**2*us**2-1d0/2/ctw**2*vpaup**2*vmamo**2*mmo**4+1
     & d0/2/ctw**2*vmaup**2*vpamo**2*us**2-1d0/2/ctw**2*vmaup**2*vpamo**
     & 2*mmo**4+1d0/2/ctw**2*vmaup**2*vmamo**2*ts**2-1d0/2/ctw**2*vmaup*
     & *2*vmamo**2*mmo**4)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/ctw**2*vpaup**2*v
     & pamo*vmamo*ts*mmo**2-1d0/ctw**2*vpaup**2*vpamo*vmamo*mmo**4-1d0/c
     & tw**2*vpaup**2*vpamo**2*ts*mmo**2-1d0/ctw**2*vpaup**2*vpamo**2*ts
     & **2-1d0/ctw**2*vmaup**2*vpamo*vmamo*ts*mmo**2-1d0/ctw**2*vmaup**2
     & *vpamo*vmamo*mmo**4-1d0/ctw**2*vmaup**2*vmamo**2*ts*mmo**2-1d0/ct
     & w**2*vmaup**2*vmamo**2*ts**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-1d0/ctw**2*vpaup**2*v
     & pamo*vmamo*us*mmo**2-1d0/ctw**2*vpaup**2*vpamo*vmamo*mmo**4-1d0/c
     & tw**2*vpaup**2*vmamo**2*us*mmo**2-1d0/ctw**2*vpaup**2*vmamo**2*us
     & **2-1d0/ctw**2*vmaup**2*vpamo*vmamo*us*mmo**2-1d0/ctw**2*vmaup**2
     & *vpamo*vmamo*mmo**4-1d0/ctw**2*vmaup**2*vpamo**2*us*mmo**2-1d0/ct
     & w**2*vmaup**2*vpamo**2*us**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vp
     & aup**2*vpamo**2*ts-1d0/4/ctw**2*vpaup**2*vpamo**2*mmo**2+1d0/4/ct
     & w**2*vpaup**2*vmamo**2*us-1d0/4/ctw**2*vpaup**2*vmamo**2*mmo**2+1
     & d0/4/ctw**2*vmaup**2*vpamo**2*us-1d0/4/ctw**2*vmaup**2*vpamo**2*m
     & mo**2+1d0/4/ctw**2*vmaup**2*vmamo**2*ts-1d0/4/ctw**2*vmaup**2*vma
     & mo**2*mmo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(sdet3cmots/ctw**2*vpaup*
     & *2*vpamo*vmamo*mmo**2+1d0/2*sdet3cmots/ctw**2*vpaup**2*vpamo**2*t
     & s+1d0/2*sdet3cmots/ctw**2*vpaup**2*vpamo**2*mmo**2+sdet3cmots/ctw
     & **2*vmaup**2*vpamo*vmamo*mmo**2+1d0/2*sdet3cmots/ctw**2*vmaup**2*
     & vmamo**2*ts+1d0/2*sdet3cmots/ctw**2*vmaup**2*vmamo**2*mmo**2+sdet
     & 3cmous/ctw**2*vpaup**2*vpamo*vmamo*mmo**2+1d0/2*sdet3cmous/ctw**2
     & *vpaup**2*vmamo**2*us+1d0/2*sdet3cmous/ctw**2*vpaup**2*vmamo**2*m
     & mo**2+sdet3cmous/ctw**2*vmaup**2*vpamo*vmamo*mmo**2+1d0/2*sdet3cm
     & ous/ctw**2*vmaup**2*vpamo**2*us+1d0/2*sdet3cmous/ctw**2*vmaup**2*
     & vpamo**2*mmo**2)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vpam
     & o**2*ts+1d0/2/ctw**2*vpaup**2*vpamo**2*mmo**2+1d0/2/ctw**2*vpaup*
     & *2*vmamo**2*us+1d0/2/ctw**2*vpaup**2*vmamo**2*mmo**2+1d0/2/ctw**2
     & *vmaup**2*vpamo**2*us+1d0/2/ctw**2*vmaup**2*vpamo**2*mmo**2+1d0/2
     & /ctw**2*vmaup**2*vmamo**2*ts+1d0/2/ctw**2*vmaup**2*vmamo**2*mmo**
     & 2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*vp
     & amo**2*ts-1d0/2/ctw**2*vpaup**2*vpamo**2*mmo**2-1d0/2/ctw**2*vmau
     & p**2*vmamo**2*ts-1d0/2/ctw**2*vmaup**2*vmamo**2*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*vm
     & amo**2*us-1d0/2/ctw**2*vpaup**2*vmamo**2*mmo**2-1d0/2/ctw**2*vmau
     & p**2*vpamo**2*us-1d0/2/ctw**2*vmaup**2*vpamo**2*mmo**2)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(1d0/8/ctw**2*vpaup**2*vpamo**
     & 2*qs+1d0/2/ctw**2*vpaup**2*vpamo**2*ts+1d0/2/ctw**2*vpaup**2*vpam
     & o**2*mz**2+1d0/2/ctw**2*vpaup**2*vpamo**2*mmo**2+1d0/8/ctw**2*vma
     & up**2*vmamo**2*qs+1d0/2/ctw**2*vmaup**2*vmamo**2*ts+1d0/2/ctw**2*
     & vmaup**2*vmamo**2*mz**2+1d0/2/ctw**2*vmaup**2*vmamo**2*mmo**2-1d0
     & /2*sdet3cmots/ctw**2*vpaup**2*vmamo**2-1d0/2*sdet3cmots/ctw**2*vm
     & aup**2*vpamo**2)
     & +d0ccmomoqsuswcwc*dreal(propizqs)*(-2*us*rwz)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vpaup**
     & 2*vmamo**2+1d0/4/ctw**2*vmaup**2*vpamo**2)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/8/ctw**2*vpaup**2*vmamo*
     & *2*qs+1d0/2/ctw**2*vpaup**2*vmamo**2*us+1d0/2/ctw**2*vpaup**2*vma
     & mo**2*mmo**2-1d0/8/ctw**2*vmaup**2*vpamo**2*qs+1d0/2/ctw**2*vmaup
     & **2*vpamo**2*us+1d0/2/ctw**2*vmaup**2*vpamo**2*mmo**2-1d0/2*sdet3
     & cmous/ctw**2*vpaup**2*vpamo**2-1d0/2*sdet3cmous/ctw**2*vmaup**2*v
     & mamo**2)
     & +c0momoqswcw*dreal(propizqs)*(2*rwz)
     & +c0momoqswcw*(15d0/2*mw**2*rmow*rwz-3*mw**2*rmow**2*rwz-1d0/2*mw*
     & *2*rmow**3*rwz-4*mw**2*rwz)
     & +c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vpamo**2+1d0
     & /2/ctw**2*vpaup**2*vmamo**2+1d0/2/ctw**2*vmaup**2*vpamo**2+1d0/2/
     & ctw**2*vmaup**2*vmamo**2)
     & +c0momoqszmoh*(-1d0/4/qs*mw**4*rmow/rwz**2+1d0/2/qs*mw**4*rmow/rw
     & z*rhw-1d0/4/qs*mw**4*rmow*rhw**2+mw**2*rmow/rwz-mw**2*rmow**2)
     & +c0momoqsmozmo*(-7d0/2*qs/rwz-6*qs*rwz+9*qs-5d0/2*mw**2*rmow/rwz-
     & 4*mw**2*rmow*rwz+6*mw**2*rmow+7*mw**2/rwz**2-18*mw**2/rwz+12*mw**
     & 2)
     & +c0momoqsmohmo*(mw**2*rmow**2)
     & +c0momoqscwc*(qs-mw**2*rmow-1d0/2*mw**2*rmow**2-2*mw**2)
     & +c0ccqswcw*dreal(propizqs)*(2*rwz)
     & +c0ccqswcw*(2/qs*mw**4*rwz-4*mw**2*rwz)
     & +c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vpamo**2+1d0/2/
     & ctw**2*vpaup**2*vmamo**2+1d0/2/ctw**2*vmaup**2*vpamo**2+1d0/2/ctw
     & **2*vmaup**2*vmamo**2)
     & +c0ccqscwc*(-vpadn/qs*mw**4-vpadn*qs+2*vpadn*mw**2)
     & +c0ccqsczc*(3d0/2*vpaup/qs*mw**4/rwz**3+3d0/2*vpaup*qs/rwz-3*vpau
     & p*mw**2/rwz**2-3d0/2*vpaup**2/qs*mw**4/rwz**3-3d0/2*vpaup**2*qs/r
     & wz+3*vpaup**2*mw**2/rwz**2-1d0/2/qs*mw**4/rwz**3-1d0/2*qs/rwz+mw*
     & *2/rwz**2)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-4*mw**2*rwz
     & -8d0/3*mw**2)
     & +a0fw*(1d0/4+vpadn/qs*mw**2-3d0/2*vpadn+2/qs*mw**2*rwz+1d0/2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(-3d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+3d0/2*vpaup**
     & 2/qs*mw**2/rwz**2-9d0/4*vpaup**2/rwz+5d0/12/qs*mw**2/rwz**2+1d0/1
     & 2/qs*mw**2/rwz*rhw-7d0/8/rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fmo*(3d0/2+1d0/4*rmow-1d0/2/rwz-rwz)
     & +b0fmowc*(-5d0/4-3d0/2*rmow*rwz-1d0/2*rmow+5d0/2*rwz)
     & +b0fmozmo*(-12-1d0/4/qs*mw**2*rmow/rwz+1d0/4/qs*mw**2*rmow*rhw+37
     & d0/8/rwz+8*rwz)
     & +b0fmohmo*(1d0/4/qs*mw**2*rmow/rwz-1d0/4/qs*mw**2*rmow*rhw-1d0/8*
     & rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-4*mw
     & **2*rwz-17d0/3*mw**2)
     & +b0fqsww*dreal(propizqs)*(-1d0/12*qs/mw**4*rwz+1d0/4/mw**2*rmow*r
     & wz+5d0/3/mw**2*rwz)
     & +b0fqsww*(-4d0/3+2/qs*mw**2*rwz-1d0/4*qs/mw**2*rmow*rwz-5d0/3*qs/
     & mw**2*rwz+1d0/12*qs/mw**2+1d0/12*qs**2/mw**4*rwz+3*rmow*rwz+1d0/2
     & *rmow**2*rwz-1d0/12/rwz+rwz)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2+1d0/2*rmow-1d0/12/rwz)
     & +b0fqsmomo*(27d0/2-1d0/4*rmow-21d0/4/rwz-9*rwz)
     & +b0fqscc*(3d0/2-3d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+3d0/2
     & *vpaup**2/qs*mw**2/rwz**2-9d0/4*vpaup**2/rwz+vpadn/qs*mw**2-3d0/2
     & *vpadn+1d0/2/qs*mw**2/rwz**2+1d0/4*rmow-3d0/4/rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-1d0/6*mw**2/rwz*rhw-mw**2/rwz*zmzzzbos-5d0/9*mw**2/rwz-4*mw*
     & *2*rwz-8d0/3*mw**2)
     & +dreal(b0pmozmo)*(-7d0/4*mw**2*rmow/rwz-4*mw**2*rmow*rwz+6*mw**2*
     & rmow-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2)
     & +dreal(b0pmohmo)*(-1d0/4*mw**2*rmow*rhw+mw**2*rmow**2)
     & +dreal(b0pmocw)*(1d0/4*mw**2*rmow+1d0/4*mw**2*rmow**2-1d0/2*mw**2
     & )
     & +b0dwmocw*(-1+rwz)
     & +b0d1momoz*(-3d0/2+1d0/2/rwz+rwz)
     & +47d0/9+1d0/stw**2*deltarhobos+1d0/stw**2*deltarhofer+3d0/8*vpaup
     & /rwz+3d0/4*vpaup-3d0/8*vpaup**2/rwz-vpadn-1d0/2*rmow*rwz+3d0/4*rm
     & ow-143d0/72/rwz+2*rwz-za1bos-2*deltarhobos-za1fer-2*deltarhofer+c
     & aldzfer

      ff_ew_ql =
     & +sdet3imomoqs*c0momoqswcw*(-2/qs*mw**6-13d0/2*mw**4*rmow+11d0/4*m
     & w**4*rmow**2+1d0/2*mw**4*rmow**3+11d0/4*mw**4)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/4*mw**4*rmow/rwz**2-1d0/2*mw**4*
     & rmow/rwz*rhw+1d0/4*mw**4*rmow*rhw**2+2*mw**4*rmow**2/rwz-2*mw**4*
     & rmow**2*rhw+4*mw**4*rmow**3)
     & +sdet3imomoqs*c0momoqsmozmo*(-3/qs*mw**6/rwz**3+4/qs*mw**6/rwz**2
     & -55d0/4*mw**4*rmow/rwz**2+24*mw**4*rmow/rwz-8*mw**4*rmow-7d0/2*mw
     & **4/rwz**3+9*mw**4/rwz**2-6*mw**4/rwz)
     & +sdet3imomoqs*c0momoqsmohmo*(1d0/4*mw**4*rmow*rhw**2-2*mw**4*rmow
     & **2*rhw)
     & +sdet3imomoqs*c0momoqscwc*(11d0/2*mw**4*rmow+6*mw**4*rmow**2+3d0/
     & 2*mw**4*rmow**3+mw**4)
     & +sdet3imomoqs*b0fmowc*(2/qs*mw**4+31d0/4*mw**2*rmow+2*mw**2*rmow*
     & *2-9d0/4*mw**2)
     & +sdet3imomoqs*b0fmozmo*(-3/qs*mw**4/rwz**2+4/qs*mw**4/rwz-13*mw**
     & 2*rmow/rwz-8*mw**2*rmow*rwz-1d0/4*mw**2*rmow*rhw+24*mw**2*rmow+mw
     & **2*rmow**2-7d0/2*mw**2/rwz**2+9*mw**2/rwz-6*mw**2)
     & +sdet3imomoqs*b0fmohmo*(3d0/4*mw**2*rmow/rwz-mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsww*(-2/qs*mw**4-13d0/4*mw**2*rmow-1d0/2*mw**2*
     & rmow**2+13d0/4*mw**2)
     & +sdet3imomoqs*b0fqszh*(-3d0/2*mw**2*rmow/rwz+1d0/2*mw**2*rmow*rhw
     & -2*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz+55d0/4*
     & mw**2*rmow/rwz+8*mw**2*rmow*rwz-1d0/4*mw**2*rmow*rhw-24*mw**2*rmo
     & w+2*mw**2*rmow**2+7d0/2*mw**2/rwz**2-9*mw**2/rwz+6*mw**2)
     & +sdet3imomoqs*b0fqscc*(-9d0/2*mw**2*rmow-3d0/2*mw**2*rmow**2-mw**
     & 2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & aup*vmamo**2*ts*mmo**2+1d0/ctw**2*vmaup*vmamo**2*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & maup*vmamo**2*ts*mmo**2-1d0/ctw**2*vmaup*vmamo**2*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & aup*vpamo**2*us*mmo**2+1d0/ctw**2*vmaup*vpamo**2*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & maup*vpamo**2*us*mmo**2-1d0/ctw**2*vmaup*vpamo**2*mmo**4)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(-
     & 1d0/4/ctw**2*vmaup*vmamo**2*ts*mmo**4+1d0/4/ctw**2*vmaup*vmamo**2
     & *us*mmo**4-1d0/4*sdet3cmots/ctw**2*vmaup*vmamo**2*ts*mmo**2+1d0/4
     & *sdet3cmots/ctw**2*vmaup*vmamo**2*mmo**4+1d0/4*sdet3cmots**2/ctw*
     & *2*vmaup*vmamo**2*qs+sdet3cmots**2/ctw**2*vmaup*vmamo**2*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(1
     & d0/4/ctw**2*vmaup*vpamo**2*ts*mmo**4-1d0/4/ctw**2*vmaup*vpamo**2*
     & us*mmo**4-1d0/4*sdet3cmous/ctw**2*vmaup*vpamo**2*us*mmo**2+1d0/4*
     & sdet3cmous/ctw**2*vmaup*vpamo**2*mmo**4+1d0/4*sdet3cmous**2/ctw**
     & 2*vmaup*vpamo**2*qs+sdet3cmous**2/ctw**2*vmaup*vpamo**2*mmo**2)
     & +sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(1d0/4*sde
     & t3cmots/ctw**2*vmaup*vmamo**2*qs*ts+1d0/4*sdet3cmots/ctw**2*vmaup
     & *vmamo**2*qs*mmo**2+sdet3cmots/ctw**2*vmaup*vmamo**2*ts*mmo**2+sd
     & et3cmots/ctw**2*vmaup*vmamo**2*mmo**4+1d0/4*sdet3cmous/ctw**2*vma
     & up*vpamo**2*qs*us+1d0/4*sdet3cmous/ctw**2*vmaup*vpamo**2*qs*mmo**
     & 2+sdet3cmous/ctw**2*vmaup*vpamo**2*us*mmo**2+sdet3cmous/ctw**2*vm
     & aup*vpamo**2*mmo**4)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     & 3cmots/ctw**2*vmaup*vmamo**2*ts**2-1d0/2*sdet3cmots/ctw**2*vmaup*
     & vmamo**2*mmo**4)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     & 3cmous/ctw**2*vmaup*vpamo**2*us**2-1d0/2*sdet3cmous/ctw**2*vmaup*
     & vpamo**2*mmo**4)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     & *vmaup*vpamo**2*qs*us*mmo**2-1d0/4/ctw**2*vmaup*vpamo**2*qs*mmo**
     & 4+1d0/4/ctw**2*vmaup*vmamo**2*qs*ts*mmo**2-1d0/4/ctw**2*vmaup*vma
     & mo**2*qs*mmo**4-1d0/4*sdet3cmots**2/ctw**2*vmaup*vmamo**2*ts+1d0/
     & 4*sdet3cmots**2/ctw**2*vmaup*vmamo**2*mmo**2-1d0/4*sdet3cmous**2/
     & ctw**2*vmaup*vpamo**2*us+1d0/4*sdet3cmous**2/ctw**2*vmaup*vpamo**
     & 2*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(1d0/
     & 2/ctw**2*vmaup*vmamo**2*mmo**2+1d0/8*sdet3cmots/ctw**2*vmaup*vmam
     & o**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     & ctw**2*vmaup*vpamo*vmamo*ts*mmo**2-1d0/2/ctw**2*vmaup*vpamo*vmamo
     & *mmo**4-1d0/4/ctw**2*vmaup*vmamo**2*qs*mmo**2-3d0/4/ctw**2*vmaup*
     & vmamo**2*ts**2+3d0/4/ctw**2*vmaup*vmamo**2*mmo**4-sdet3cmots/ctw*
     & *2*vmaup*vmamo**2*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/8/ctw**2*vma
     & up*vmamo**2*qs*ts*mmo**2-1d0/8/ctw**2*vmaup*vmamo**2*qs*us*mmo**2
     & +1d0/8*sdet3cmots/ctw**2*vmaup*vmamo**2*qs*ts-1d0/8*sdet3cmots/ct
     & w**2*vmaup*vmamo**2*qs*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(1d0/
     & 2/ctw**2*vmaup*vpamo**2*mmo**2+1d0/8*sdet3cmous/ctw**2*vmaup*vpam
     & o**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     & ctw**2*vmaup*vpamo*vmamo*us*mmo**2-1d0/2/ctw**2*vmaup*vpamo*vmamo
     & *mmo**4-1d0/4/ctw**2*vmaup*vpamo**2*qs*mmo**2-3d0/4/ctw**2*vmaup*
     & vpamo**2*us**2+3d0/4/ctw**2*vmaup*vpamo**2*mmo**4-sdet3cmous/ctw*
     & *2*vmaup*vpamo**2*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/8/ctw**2*vm
     & aup*vpamo**2*qs*ts*mmo**2+1d0/8/ctw**2*vmaup*vpamo**2*qs*us*mmo**
     & 2+1d0/8*sdet3cmous/ctw**2*vmaup*vpamo**2*qs*us-1d0/8*sdet3cmous/c
     & tw**2*vmaup*vpamo**2*qs*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(1d0/2/ctw**2
     & *vmaup*vpamo**2*mmo**2+1d0/2/ctw**2*vmaup*vmamo**2*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*v
     & pamo**2*us**2+1d0/2/ctw**2*vmaup*vpamo**2*mmo**4-1d0/2/ctw**2*vma
     & up*vmamo**2*ts**2+1d0/2/ctw**2*vmaup*vmamo**2*mmo**4)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(1d0/ctw**2*vmaup*vpamo
     & *vmamo*ts*mmo**2+1d0/ctw**2*vmaup*vpamo*vmamo*mmo**4+1d0/ctw**2*v
     & maup*vmamo**2*ts*mmo**2+1d0/ctw**2*vmaup*vmamo**2*ts**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/ctw**2*vmaup*vpamo
     & *vmamo*us*mmo**2+1d0/ctw**2*vmaup*vpamo*vmamo*mmo**4+1d0/ctw**2*v
     & maup*vpamo**2*us*mmo**2+1d0/ctw**2*vmaup*vpamo**2*us**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*v
     & maup*vpamo**2*us+1d0/4/ctw**2*vmaup*vpamo**2*mmo**2-1d0/4/ctw**2*
     & vmaup*vmamo**2*ts+1d0/4/ctw**2*vmaup*vmamo**2*mmo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-sdet3cmots/ctw**2*vmaup
     & *vpamo*vmamo*mmo**2-1d0/2*sdet3cmots/ctw**2*vmaup*vmamo**2*ts-1d0
     & /2*sdet3cmots/ctw**2*vmaup*vmamo**2*mmo**2-sdet3cmous/ctw**2*vmau
     & p*vpamo*vmamo*mmo**2-1d0/2*sdet3cmous/ctw**2*vmaup*vpamo**2*us-1d
     & 0/2*sdet3cmous/ctw**2*vmaup*vpamo**2*mmo**2)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpamo*
     & *2*us-1d0/2/ctw**2*vmaup*vpamo**2*mmo**2-1d0/2/ctw**2*vmaup*vmamo
     & **2*ts-1d0/2/ctw**2*vmaup*vmamo**2*mmo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vmamo*
     & *2*ts+1d0/2/ctw**2*vmaup*vmamo**2*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpamo*
     & *2*us+1d0/2/ctw**2*vmaup*vpamo**2*mmo**2)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/8/ctw**2*vmaup*vmamo**2*
     & qs-1d0/2/ctw**2*vmaup*vmamo**2*ts-1d0/2/ctw**2*vmaup*vmamo**2*mz*
     & *2-1d0/2/ctw**2*vmaup*vmamo**2*mmo**2+1d0/2*sdet3cmots/ctw**2*vma
     & up*vpamo**2)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*vmaup*
     & vpamo**2)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/8/ctw**2*vmaup*vpamo**2*q
     & s-1d0/2/ctw**2*vmaup*vpamo**2*us-1d0/2/ctw**2*vmaup*vpamo**2*mmo*
     & *2+1d0/2*sdet3cmous/ctw**2*vmaup*vmamo**2)
     & +c0momoqswcw*(-1d0/qs*mw**4*rmow+1d0/4/qs*mw**4*rmow**2+5d0/4/qs*
     & mw**4)
     & +c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpamo**2-1d0/2
     & /ctw**2*vmaup*vmamo**2)
     & +c0momoqszmoh*(-1d0/4/qs*mw**4*rmow/rwz**2+1d0/2/qs*mw**4*rmow/rw
     & z*rhw-1d0/4/qs*mw**4*rmow*rhw**2+mw**2*rmow/rwz-mw**2*rmow**2)
     & +c0momoqsmozmo*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz-7d0/2*qs/rwz-2*q
     & s*rwz+6*qs-5d0/2*mw**2*rmow/rwz-4*mw**2*rmow*rwz+6*mw**2*rmow+7*m
     & w**2/rwz**2-15*mw**2/rwz+8*mw**2)
     & +c0momoqsmohmo*(mw**2*rmow**2)
     & +c0momoqscwc*(qs-mw**2*rmow-1d0/2*mw**2*rmow**2-2*mw**2)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpamo**2-1d0/2/ct
     & w**2*vmaup*vmamo**2)
     & +c0ccqsczc*(vpaup/qs*mw**4/rwz**3+vpaup*qs/rwz-2*vpaup*mw**2/rwz*
     & *2-1d0/2*vpaup**2/qs*mw**4/rwz**3-1d0/2*vpaup**2*qs/rwz+vpaup**2*
     & mw**2/rwz**2-1d0/2/qs*mw**4/rwz**3-1d0/2*qs/rwz+mw**2/rwz**2)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-4*mw**2*rwz
     & -8d0/3*mw**2)
     & +a0fw*(1d0/4+4/qs*mw**2*rwz-1d0/6/qs*mw**2)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(-vpaup/qs*mw**2/rwz**2+3d0/2*vpaup/rwz+1d0/2*vpaup**2/qs*m
     & w**2/rwz**2-3d0/4*vpaup**2/rwz+5d0/12/qs*mw**2/rwz**2+1d0/12/qs*m
     & w**2/rwz*rhw-7d0/8/rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fmo*(-3d0/2/qs*mw**2/rwz+2/qs*mw**2+1d0/4*rmow-1d0/2/rwz+rwz)
     & +b0fmowc*(-5d0/4-1d0/4/qs*mw**2*rmow+3d0/4/qs*mw**2-1d0/2*rmow)
     & +b0fmozmo*(-9-1d0/4/qs*mw**2*rmow/rwz+1d0/4/qs*mw**2*rmow*rhw+37d
     & 0/8/rwz+4*rwz)
     & +b0fmohmo*(1d0/4/qs*mw**2*rmow/rwz-1d0/4/qs*mw**2*rmow*rhw-1d0/8*
     & rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-4*mw
     & **2*rwz-17d0/3*mw**2)
     & +b0fqsww*(1d0/6+1d0/4/qs*mw**2*rmow+4/qs*mw**2*rwz-11d0/12/qs*mw*
     & *2+1d0/4*rmow-1d0/12/rwz)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2+1d0/2*rmow-1d0/12/rwz)
     & +b0fqsmomo*(9-3d0/2/qs*mw**2/rwz+2/qs*mw**2-1d0/4*rmow-21d0/4/rwz
     & -3*rwz)
     & +b0fqscc*(3d0/2-vpaup/qs*mw**2/rwz**2+3d0/2*vpaup/rwz+1d0/2*vpaup
     & **2/qs*mw**2/rwz**2-3d0/4*vpaup**2/rwz+1d0/2/qs*mw**2/rwz**2+1d0/
     & 4*rmow-3d0/4/rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-1d0/6*mw**2/rwz*rhw-mw**2/rwz*zmzzzbos-5d0/9*mw**2/rwz-4*mw*
     & *2*rwz-8d0/3*mw**2)
     & +dreal(b0pmozmo)*(-7d0/4*mw**2*rmow/rwz-4*mw**2*rmow*rwz+6*mw**2*
     & rmow-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2)
     & +dreal(b0pmohmo)*(-1d0/4*mw**2*rmow*rhw+mw**2*rmow**2)
     & +dreal(b0pmocw)*(1d0/4*mw**2*rmow+1d0/4*mw**2*rmow**2-1d0/2*mw**2
     & )
     & +b0dwmocw*(-1-1d0/qs*mw**2)
     & +b0d1momoz*(3d0/2/qs*mw**2/rwz-2/qs*mw**2+1d0/2/rwz-rwz)
     & +65d0/18+1d0/4*vpaup/rwz-1d0/8*vpaup**2/rwz+1d0/2/qs*mw**2*rmow-3
     & d0/2/qs*mw**2/rwz+4/qs*mw**2*rwz+1d0/3/qs*mw**2+3d0/4*rmow-143d0/
     & 72/rwz-rwz-za1bos-deltarhobos-za1fer-deltarhofer+caldzfer-pizgfer
     & 

      ff_ew_lq =
     & +sdet3imomoqs*c0momoqswcw*dreal(propizqs)*(-3d0/2/vmamo*mw**2*rmo
     & w*rwz+1d0/vmamo*mw**2*rmow**2*rwz+1d0/2/vmamo*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*c0momoqswcw*(7/vmamo*mw**4*rmow*rwz-12/vmamo*mw**4*
     & rmow**2*rwz+3/vmamo*mw**4*rmow**3*rwz+2/vmamo*mw**4*rmow**4*rwz)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/8/vmamo*mw**4*rmow/rwz**2-1d0/4/
     & vmamo*mw**4*rmow/rwz*rhw+1d0/8/vmamo*mw**4*rmow*rhw**2+1d0/vmamo*
     & mw**4*rmow**2/rwz-1d0/vmamo*mw**4*rmow**2*rhw+2/vmamo*mw**4*rmow*
     & *3)
     & +sdet3imomoqs*c0momoqsmozmo*(-3d0/4/vmamo*mw**4*rmow/rwz**2-13d0/
     & 4*mw**4*rmow/rwz**2+6*mw**4*rmow/rwz-2*mw**4/rwz**3+4*mw**4/rwz**
     & 2-2*mw**4/rwz)
     & +sdet3imomoqs*c0momoqsmohmo*(1d0/4/vmamo*mw**4*rmow*rhw**2-1d0/vm
     & amo*mw**4*rmow**2*rhw-1d0/4*mw**4*rmow*rhw**2)
     & +sdet3imomoqs*c0momoqscwc*(3d0/2/vmamo*mw**4*rmow+2/vmamo*mw**4*r
     & mow**2+1d0/2/vmamo*mw**4*rmow**3)
     & +sdet3imomoqs*b0fmowc*dreal(propizqs)*(1d0/vmamo*rmow*rwz)
     & +sdet3imomoqs*b0fmowc*(-7/vmamo*mw**2*rmow*rwz+2/vmamo*mw**2*rmow
     & +3/vmamo*mw**2*rmow**2*rwz+1d0/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fmozmo*(-3d0/8/vmamo*mw**2*rmow/rwz-1d0/8/vmamo*m
     & w**2*rmow*rhw+1d0/2/vmamo*mw**2*rmow**2-13d0/4*mw**2*rmow/rwz+6*m
     & w**2*rmow-2*mw**2/rwz**2+4*mw**2/rwz-2*mw**2)
     & +sdet3imomoqs*b0fmohmo*(3d0/8/vmamo*mw**2*rmow/rwz+1d0/8/vmamo*mw
     & **2*rmow*rhw-1d0/2/vmamo*mw**2*rmow**2-1d0/4*mw**2*rmow*rhw)
     & +sdet3imomoqs*b0fqsww*dreal(propizqs)*(-3d0/2/vmamo*rmow*rwz-1d0/
     & 2/vmamo*rmow**2*rwz)
     & +sdet3imomoqs*b0fqsww*(7/vmamo*mw**2*rmow*rwz-5/vmamo*mw**2*rmow*
     & *2*rwz-2/vmamo*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*b0fqszh*(-3d0/4/vmamo*mw**2*rmow/rwz+1d0/4/vmamo*mw
     & **2*rmow*rhw-1d0/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo*(3d0/4/vmamo*mw**2*rmow/rwz-1d0/4/vmamo*m
     & w**2*rmow*rhw+1d0/vmamo*mw**2*rmow**2+13d0/4*mw**2*rmow/rwz+1d0/4
     & *mw**2*rmow*rhw-6*mw**2*rmow+2*mw**2/rwz**2-4*mw**2/rwz+2*mw**2)
     & +sdet3imomoqs*b0fqscc*(-3d0/2/vmamo*mw**2*rmow-1d0/2/vmamo*mw**2*
     & rmow**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(1
     & d0/2/ctw**2*vpaup**2*vpamo**2/vmamo*ts*mmo**2-1d0/2/ctw**2*vmaup*
     & *2*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & paup**2*vpamo**2/vmamo*mmo**4-1d0/ctw**2*vmaup**2*vmamo*ts*mmo**2
     & )
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/ctw**2*vp
     & aup**2*vpamo**2/vmamo*mmo**4+1d0/ctw**2*vmaup**2*vmamo*ts*mmo**2)
     & 
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*v
     & pamo**2/vmamo*mmo**2-1d0/2/ctw**2*vmaup**2*vmamo*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(-
     & 1d0/2/ctw**2*vpaup**2*vmamo*us*mmo**2+1d0/2/ctw**2*vmaup**2*vpamo
     & **2/vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & paup**2*vmamo*us*mmo**2-1d0/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**4
     & )
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/ctw**2*vp
     & aup**2*vmamo*us*mmo**2+1d0/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**4)
     & 
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*
     & vmamo*mmo**2+1d0/2/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(1
     & d0/4/ctw**2*vmaup**2*vmamo*ts*mmo**4-1d0/4/ctw**2*vmaup**2*vmamo*
     & us*mmo**4+1d0/4*sdet3cmots/ctw**2*vpaup**2*vpamo**2/vmamo*ts*mmo*
     & *2-1d0/4*sdet3cmots/ctw**2*vpaup**2*vpamo**2/vmamo*mmo**4-1d0/4*s
     & det3cmots**2/ctw**2*vmaup**2*vmamo*qs-sdet3cmots**2/ctw**2*vmaup*
     & *2*vmamo*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(-
     & 1d0/4/ctw**2*vpaup**2*vmamo*ts*mmo**4+1d0/4/ctw**2*vpaup**2*vmamo
     & *us*mmo**4+1d0/4*sdet3cmous/ctw**2*vmaup**2*vpamo**2/vmamo*us*mmo
     & **2-1d0/4*sdet3cmous/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**4-1d0/4*
     & sdet3cmous**2/ctw**2*vpaup**2*vmamo*qs-sdet3cmous**2/ctw**2*vpaup
     & **2*vmamo*mmo**2)
     & +sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(-1d0/4*sd
     & et3cmots/ctw**2*vpaup**2*vpamo**2/vmamo*qs*mmo**2-sdet3cmots/ctw*
     & *2*vpaup**2*vpamo**2/vmamo*mmo**4-1d0/4*sdet3cmots/ctw**2*vmaup**
     & 2*vmamo*qs*ts-sdet3cmots/ctw**2*vmaup**2*vmamo*ts*mmo**2-1d0/4*sd
     & et3cmous/ctw**2*vpaup**2*vmamo*qs*us-sdet3cmous/ctw**2*vpaup**2*v
     & mamo*us*mmo**2-1d0/4*sdet3cmous/ctw**2*vmaup**2*vpamo**2/vmamo*qs
     & *mmo**2-sdet3cmous/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**4)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     & t3cmots/ctw**2*vpaup**2*vpamo**2/vmamo*ts*mmo**2+1d0/2*sdet3cmots
     & /ctw**2*vpaup**2*vpamo**2/vmamo*mmo**4+1d0/2*sdet3cmots/ctw**2*vm
     & aup**2*vmamo*ts*mmo**2-1d0/2*sdet3cmots/ctw**2*vmaup**2*vmamo*ts*
     & *2)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     & 3cmous/ctw**2*vpaup**2*vmamo*us*mmo**2-1d0/2*sdet3cmous/ctw**2*vp
     & aup**2*vmamo*us**2-1d0/2*sdet3cmous/ctw**2*vmaup**2*vpamo**2/vmam
     & o*us*mmo**2+1d0/2*sdet3cmous/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**
     & 4)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     & 2*vpaup**2*vpamo**2/vmamo*qs*ts*mmo**2+1d0/4/ctw**2*vpaup**2*vpam
     & o**2/vmamo*qs*mmo**4-1d0/4/ctw**2*vmaup**2*vpamo**2/vmamo*qs*us*m
     & mo**2+1d0/4/ctw**2*vmaup**2*vpamo**2/vmamo*qs*mmo**4+1d0/4*sdet3c
     & mots**2/ctw**2*vmaup**2*vmamo*ts-1d0/4*sdet3cmots**2/ctw**2*vmaup
     & **2*vmamo*mmo**2+1d0/4*sdet3cmous**2/ctw**2*vpaup**2*vmamo*us-1d0
     & /4*sdet3cmous**2/ctw**2*vpaup**2*vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(-1d0
     & /8/ctw**2*vpaup**2*vpamo**2/vmamo*mmo**2-3d0/8/ctw**2*vmaup**2*vm
     & amo*mmo**2-1d0/8*sdet3cmots/ctw**2*vmaup**2*vmamo)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     & tw**2*vpaup**2*vpamo*mmo**4+1d0/4/ctw**2*vpaup**2*vpamo**2/vmamo*
     & qs*mmo**2-1d0/2/ctw**2*vpaup**2*vpamo**2/vmamo*mmo**4+1d0/2/ctw**
     & 2*vmaup**2*vpamo*ts*mmo**2+3d0/4/ctw**2*vmaup**2*vmamo*ts**2-1d0/
     & 4/ctw**2*vmaup**2*vmamo*mmo**4+sdet3cmots/ctw**2*vpaup**2*vpamo**
     & 2/vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/8/ctw**2*vp
     & aup**2*vpamo**2/vmamo*qs*ts*mmo**2+1d0/8/ctw**2*vpaup**2*vpamo**2
     & /vmamo*qs*us*mmo**2-1d0/8*sdet3cmots/ctw**2*vmaup**2*vmamo*qs*ts+
     & 1d0/8*sdet3cmots/ctw**2*vmaup**2*vmamo*qs*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(-3d0
     & /8/ctw**2*vpaup**2*vmamo*mmo**2-1d0/8/ctw**2*vmaup**2*vpamo**2/vm
     & amo*mmo**2-1d0/8*sdet3cmous/ctw**2*vpaup**2*vmamo)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     & tw**2*vpaup**2*vpamo*us*mmo**2+3d0/4/ctw**2*vpaup**2*vmamo*us**2-
     & 1d0/4/ctw**2*vpaup**2*vmamo*mmo**4+1d0/2/ctw**2*vmaup**2*vpamo*mm
     & o**4+1d0/4/ctw**2*vmaup**2*vpamo**2/vmamo*qs*mmo**2-1d0/2/ctw**2*
     & vmaup**2*vpamo**2/vmamo*mmo**4+sdet3cmous/ctw**2*vmaup**2*vpamo**
     & 2/vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/8/ctw**2*vma
     & up**2*vpamo**2/vmamo*qs*ts*mmo**2-1d0/8/ctw**2*vmaup**2*vpamo**2/
     & vmamo*qs*us*mmo**2-1d0/8*sdet3cmous/ctw**2*vpaup**2*vmamo*qs*us+1
     & d0/8*sdet3cmous/ctw**2*vpaup**2*vmamo*qs*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     & 2*vpaup**2*vpamo**2/vmamo*mmo**2-1d0/4/ctw**2*vpaup**2*vmamo*mmo*
     & *2-1d0/4/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**2-1d0/4/ctw**2*vmaup
     & **2*vmamo*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2
     & *vpamo**2/vmamo*ts*mmo**2-1d0/2/ctw**2*vpaup**2*vpamo**2/vmamo*mm
     & o**4-1d0/2/ctw**2*vpaup**2*vmamo*us*mmo**2+1d0/2/ctw**2*vpaup**2*
     & vmamo*us**2+1d0/2/ctw**2*vmaup**2*vpamo**2/vmamo*us*mmo**2-1d0/2/
     & ctw**2*vmaup**2*vpamo**2/vmamo*mmo**4-1d0/2/ctw**2*vmaup**2*vmamo
     & *ts*mmo**2+1d0/2/ctw**2*vmaup**2*vmamo*ts**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/ctw**2*vpaup**2*v
     & pamo*mmo**4-1d0/ctw**2*vpaup**2*vpamo**2/vmamo*ts*mmo**2-1d0/ctw*
     & *2*vmaup**2*vpamo*ts*mmo**2-1d0/ctw**2*vmaup**2*vmamo*ts**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-1d0/ctw**2*vpaup**2*v
     & pamo*us*mmo**2-1d0/ctw**2*vpaup**2*vmamo*us**2-1d0/ctw**2*vmaup**
     & 2*vpamo*mmo**4-1d0/ctw**2*vmaup**2*vpamo**2/vmamo*us*mmo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*v
     & paup**2*vpamo**2/vmamo*mmo**2+1d0/4/ctw**2*vpaup**2*vmamo*us-1d0/
     & 4/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**2+1d0/4/ctw**2*vmaup**2*vma
     & mo*ts)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/2*sdet3cmots/ctw**2*
     & vpaup**2*vpamo**2/vmamo*mmo**2+sdet3cmots/ctw**2*vmaup**2*vpamo*m
     & mo**2+1d0/2*sdet3cmots/ctw**2*vmaup**2*vmamo*ts+sdet3cmous/ctw**2
     & *vpaup**2*vpamo*mmo**2+1d0/2*sdet3cmous/ctw**2*vpaup**2*vmamo*us+
     & 1d0/2*sdet3cmous/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**2)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vpam
     & o**2/vmamo*mmo**2+1d0/2/ctw**2*vpaup**2*vmamo*us+1d0/2/ctw**2*vma
     & up**2*vpamo**2/vmamo*mmo**2+1d0/2/ctw**2*vmaup**2*vmamo*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*vp
     & amo**2/vmamo*mmo**2-1d0/2/ctw**2*vmaup**2*vmamo*ts)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*vm
     & amo*us-1d0/2/ctw**2*vmaup**2*vpamo**2/vmamo*mmo**2)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*vpamo*
     & mmo**2+1d0/2/ctw**2*vpaup**2*vpamo**2/vmamo*mmo**2+1d0/2/ctw**2*v
     & maup**2*vpamo*mmo**2+1d0/8/ctw**2*vmaup**2*vmamo*qs+1d0/2/ctw**2*
     & vmaup**2*vmamo*ts+1d0/2/ctw**2*vmaup**2*vmamo*mz**2-1d0/2*sdet3cm
     & ots/ctw**2*vpaup**2*vmamo)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vpaup**
     & 2*vmamo)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vpamo*m
     & mo**2-1d0/8/ctw**2*vpaup**2*vmamo*qs+1d0/2/ctw**2*vpaup**2*vmamo*
     & us-1d0/2/ctw**2*vmaup**2*vpamo*mmo**2+1d0/2/ctw**2*vmaup**2*vpamo
     & **2/vmamo*mmo**2-1d0/2*sdet3cmous/ctw**2*vmaup**2*vmamo)
     & +c0momoqswcw*(3d0/2/vmamo*mw**2*rmow*rwz-1d0/vmamo*mw**2*rmow**2*
     & rwz-1d0/2/vmamo*mw**2*rmow**3*rwz)
     & +c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vmamo+1d0/2/
     & ctw**2*vmaup**2*vmamo)
     & +c0momoqszmoh*(3d0/8/vmamo/qs*mw**4*rmow/rwz**2-1d0/4/vmamo/qs*mw
     & **4*rmow/rwz*rhw-1d0/8/vmamo/qs*mw**4*rmow*rhw**2-1d0/2/vmamo*mw*
     & *2*rmow**2-1d0/qs*mw**4*rmow/rwz**2+1d0/qs*mw**4*rmow/rwz*rhw+mw*
     & *2*rmow/rwz)
     & +c0momoqsmozmo*(1d0/2/vmamo*mw**2*rmow/rwz-2*qs/rwz-2*qs*rwz+4*qs
     & -7d0/2*mw**2*rmow/rwz-4*mw**2*rmow*rwz+6*mw**2*rmow+4*mw**2/rwz**
     & 2-8*mw**2/rwz+4*mw**2)
     & +c0momoqsmohmo*(mw**2*rmow**2)
     & +c0momoqscwc*(-1d0/vmamo*mw**2*rmow)
     & +c0ccqswcw*(-2/qs**2*mw**6+4/qs*mw**4)
     & +c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vmamo+1d0/2/ctw
     & **2*vmaup**2*vmamo)
     & +c0ccqscwc*(2*qdn/qs**2*mw**6+2*qdn/qs*mw**4*rwz-4*qdn/qs*mw**4+2
     & *qdn*qs*rwz-4*qdn*mw**2*rwz+2*qdn*mw**2-vpadn/qs*mw**4-vpadn*qs+2
     & *vpadn*mw**2)
     & +c0ccqsczc*(2*qup*vpaup/qs**2*mw**6/rwz**3-2*qup*vpaup/qs*mw**4/r
     & wz**2+2*qup*vpaup*qs-2*qup*vpaup*mw**2/rwz-qup/qs**2*mw**6/rwz**3
     & +qup/qs*mw**4/rwz**2-qup*qs+qup*mw**2/rwz+3d0/2*vpaup/qs*mw**4/rw
     & z**3+3d0/2*vpaup*qs/rwz-3*vpaup*mw**2/rwz**2-3d0/2*vpaup**2/qs*mw
     & **4/rwz**3-3d0/2*vpaup**2*qs/rwz+3*vpaup**2*mw**2/rwz**2-1d0/2/qs
     & *mw**4/rwz**3-1d0/2*qs/rwz+mw**2/rwz**2)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-4*mw**2*rwz
     & -8d0/3*mw**2)
     & +a0fw*(-2*qdn/qs**2*mw**4-2*qdn/qs*mw**2*rwz+3*qdn/qs*mw**2+3*qdn
     & *rwz+vpadn/qs*mw**2-3d0/2*vpadn-2/qs**2*mw**4+4/qs*mw**2*rwz+7d0/
     & 3/qs*mw**2)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(-2*qup*vpaup/qs**2*mw**4/rwz**2+qup*vpaup/qs*mw**2/rwz+3*q
     & up*vpaup+qup/qs**2*mw**4/rwz**2-1d0/2*qup/qs*mw**2/rwz-3d0/2*qup-
     & 3d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+3d0/2*vpaup**2/qs*mw*
     & *2/rwz**2-9d0/4*vpaup**2/rwz+5d0/12/qs*mw**2/rwz**2+1d0/12/qs*mw*
     & *2/rwz*rhw-7d0/8/rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fmo*(-1+1d0/4*rmow+1d0/4/rwz+rwz)
     & +b0fmowc*(-1d0/vmamo*rmow*rwz-1d0/4*rmow)
     & +b0fmozmo*(-7+3d0/8/vmamo/qs*mw**2*rmow/rwz+1d0/8/vmamo/qs*mw**2*
     & rmow*rhw-1d0/qs*mw**2*rmow/rwz+25d0/8/rwz+4*rwz)
     & +b0fmohmo*(-3d0/8/vmamo/qs*mw**2*rmow/rwz-1d0/8/vmamo/qs*mw**2*rm
     & ow*rhw+1d0/qs*mw**2*rmow/rwz-1d0/8*rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-4*mw
     & **2*rwz-17d0/3*mw**2)
     & +b0fqsww*dreal(propizqs)*(1d0/4/vmamo/mw**2*rmow*rwz)
     & +b0fqsww*(1d0/6-1d0/4/vmamo*qs/mw**2*rmow*rwz+1d0/vmamo*rmow*rwz+
     & 1d0/2/vmamo*rmow**2*rwz-2/qs**2*mw**4+4/qs*mw**2*rwz+7d0/3/qs*mw*
     & *2-1d0/12/rwz)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(1d0/4/vmamo*rmow-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     & rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqsmomo*(6-1d0/4/vmamo*rmow+1d0/4*rmow-3/rwz-3*rwz)
     & +b0fqscc*(-2*qup*vpaup/qs**2*mw**4/rwz**2+qup*vpaup/qs*mw**2/rwz+
     & 3*qup*vpaup+qup/qs**2*mw**4/rwz**2-1d0/2*qup/qs*mw**2/rwz-3d0/2*q
     & up-2*qdn/qs**2*mw**4-2*qdn/qs*mw**2*rwz+3*qdn/qs*mw**2+3*qdn*rwz-
     & 3d0/2*vpaup/qs*mw**2/rwz**2+9d0/4*vpaup/rwz+3d0/2*vpaup**2/qs*mw*
     & *2/rwz**2-9d0/4*vpaup**2/rwz+vpadn/qs*mw**2-3d0/2*vpadn+1d0/4/vma
     & mo*rmow+1d0/2/qs*mw**2/rwz**2-3d0/4/rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-1d0/6*mw**2/rwz*rhw-mw**2/rwz*zmzzzbos-5d0/9*mw**2/rwz-4*mw*
     & *2*rwz-8d0/3*mw**2)
     & +dreal(b0pmozmo)*(-7d0/4*mw**2*rmow/rwz-4*mw**2*rmow*rwz+6*mw**2*
     & rmow-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2)
     & +dreal(b0pmohmo)*(-1d0/4*mw**2*rmow*rhw+mw**2*rmow**2)
     & +dreal(b0pmocw)*(1d0/4*mw**2*rmow+1d0/4*mw**2*rmow**2-1d0/2*mw**2
     & )
     & +b0dwmocw*(-1d0/2)
     & +b0d1momoz*(1-1d0/4/rwz-rwz)
     & +19d0/9+1d0/2*qup*vpaup/qs*mw**2/rwz+1d0/2*qup*vpaup-1d0/4*qup/qs
     & *mw**2/rwz-3d0/2*qup/qs*mw**2-3d0/2*qup*rwz-1d0/4*qup+2*qdn/qs*mw
     & **2+2*qdn*rwz+3d0/8*vpaup/rwz+3d0/4*vpaup-3d0/8*vpaup**2/rwz-vpad
     & n-1d0/2/vmamo*rmow*rwz+1d0/2/vmamo*rmow+4/qs*mw**2*rwz-2d0/3/qs*m
     & w**2-1d0/4*rmow-89d0/72/rwz-rwz-za1bos-deltarhobos-za1fer-deltarh
     & ofer+caldzfer-pizgfer

      ff_ew_qq =
     & +sdet3imomoqs*c0momoqswcw*(-3/vmamo*mw**4*rmow+3d0/4/vmamo*mw**4*
     & rmow**2+1d0/2/vmamo*mw**4*rmow**3+7d0/4/vmamo*mw**4)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/8/vmamo*mw**4*rmow/rwz**2-1d0/4/
     & vmamo*mw**4*rmow/rwz*rhw+1d0/8/vmamo*mw**4*rmow*rhw**2+1d0/vmamo*
     & mw**4*rmow**2/rwz-1d0/vmamo*mw**4*rmow**2*rhw+2/vmamo*mw**4*rmow*
     & *3)
     & +sdet3imomoqs*c0momoqsmozmo*(3d0/4/stw**2*mw**4*rmow-3d0/16/stw**
     & 2*mw**4-3d0/4/vmamo*mw**4*rmow/rwz**2-2/qs*mw**6/rwz**3+2/qs*mw**
     & 6/rwz**2-13d0/4*mw**4*rmow/rwz**2+11d0/4*mw**4*rmow/rwz-2*mw**4/r
     & wz**3+45d0/16*mw**4/rwz**2-3d0/16*mw**4/rwz)
     & +sdet3imomoqs*c0momoqsmohmo*(-1d0/4/stw**2*mw**4*rmow*rhw**2+1d0/
     & 16/stw**2*mw**4*rhw**2+1d0/4/vmamo*mw**4*rmow*rhw**2-1d0/vmamo*mw
     & **4*rmow**2*rhw)
     & +sdet3imomoqs*c0momoqscwc*(3d0/2/vmamo*mw**4*rmow+2/vmamo*mw**4*r
     & mow**2+1d0/2/vmamo*mw**4*rmow**3)
     & +sdet3imomoqs*b0fmowc*(11d0/4/vmamo*mw**2*rmow+1d0/vmamo*mw**2*rm
     & ow**2-7d0/4/vmamo*mw**2)
     & +sdet3imomoqs*b0fmozmo*(3d0/4/stw**2*mw**2*rmow-3d0/16/stw**2*mw*
     & *2-3d0/8/vmamo*mw**2*rmow/rwz-1d0/8/vmamo*mw**2*rmow*rhw+1d0/2/vm
     & amo*mw**2*rmow**2-2/qs*mw**4/rwz**2+2/qs*mw**4/rwz-13d0/4*mw**2*r
     & mow/rwz+2*mw**2*rmow-2*mw**2/rwz**2+45d0/16*mw**2/rwz)
     & +sdet3imomoqs*b0fmohmo*(-1d0/4/stw**2*mw**2*rmow*rhw+1d0/16/stw**
     & 2*mw**2*rhw+3d0/8/vmamo*mw**2*rmow/rwz+1d0/8/vmamo*mw**2*rmow*rhw
     & -1d0/2/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsww*(-5d0/4/vmamo*mw**2*rmow-1d0/2/vmamo*mw**2*
     & rmow**2+7d0/4/vmamo*mw**2)
     & +sdet3imomoqs*b0fqszh*(-3d0/4/vmamo*mw**2*rmow/rwz+1d0/4/vmamo*mw
     & **2*rmow*rhw-1d0/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo*(1d0/4/stw**2*mw**2*rmow*rhw-3d0/4/stw**2
     & *mw**2*rmow-1d0/16/stw**2*mw**2*rhw+3d0/16/stw**2*mw**2+3d0/4/vma
     & mo*mw**2*rmow/rwz-1d0/4/vmamo*mw**2*rmow*rhw+1d0/vmamo*mw**2*rmow
     & **2+2/qs*mw**4/rwz**2-2/qs*mw**4/rwz+13d0/4*mw**2*rmow/rwz-2*mw**
     & 2*rmow+2*mw**2/rwz**2-45d0/16*mw**2/rwz)
     & +sdet3imomoqs*b0fqscc*(-3d0/2/vmamo*mw**2*rmow-1d0/2/vmamo*mw**2*
     & rmow**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(1
     & d0/2/ctw**2*vmaup*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & aup*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & maup*vmamo*ts*mmo**2)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vmam
     & o*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(-
     & 1d0/2/ctw**2*vmaup*vpamo**2/vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & aup*vpamo**2/vmamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & maup*vpamo**2/vmamo*mmo**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpa
     & mo**2/vmamo*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(-
     & 1d0/4/ctw**2*vmaup*vmamo*ts*mmo**4+1d0/4/ctw**2*vmaup*vmamo*us*mm
     & o**4+1d0/4*sdet3cmots**2/ctw**2*vmaup*vmamo*qs+sdet3cmots**2/ctw*
     & *2*vmaup*vmamo*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(-
     & 1d0/4*sdet3cmous/ctw**2*vmaup*vpamo**2/vmamo*us*mmo**2+1d0/4*sdet
     & 3cmous/ctw**2*vmaup*vpamo**2/vmamo*mmo**4)
     & +sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(1d0/4*sde
     & t3cmots/ctw**2*vmaup*vmamo*qs*ts+sdet3cmots/ctw**2*vmaup*vmamo*ts
     & *mmo**2+1d0/4*sdet3cmous/ctw**2*vmaup*vpamo**2/vmamo*qs*mmo**2+sd
     & et3cmous/ctw**2*vmaup*vpamo**2/vmamo*mmo**4)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2*sde
     & t3cmots/ctw**2*vmaup*vmamo*ts*mmo**2+1d0/2*sdet3cmots/ctw**2*vmau
     & p*vmamo*ts**2)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(1d0/2*sdet
     & 3cmous/ctw**2*vmaup*vpamo**2/vmamo*us*mmo**2-1d0/2*sdet3cmous/ctw
     & **2*vmaup*vpamo**2/vmamo*mmo**4)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     & *vmaup*vpamo**2/vmamo*qs*us*mmo**2-1d0/4/ctw**2*vmaup*vpamo**2/vm
     & amo*qs*mmo**4-1d0/4*sdet3cmots**2/ctw**2*vmaup*vmamo*ts+1d0/4*sde
     & t3cmots**2/ctw**2*vmaup*vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(3d0/
     & 8/ctw**2*vmaup*vmamo*mmo**2+1d0/8*sdet3cmots/ctw**2*vmaup*vmamo)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     & ctw**2*vmaup*vpamo*ts*mmo**2-3d0/4/ctw**2*vmaup*vmamo*ts**2+1d0/4
     & /ctw**2*vmaup*vmamo*mmo**4)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/8*sdet3cmots
     & /ctw**2*vmaup*vmamo*qs*ts-1d0/8*sdet3cmots/ctw**2*vmaup*vmamo*qs*
     & mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(1d0/
     & 8/ctw**2*vmaup*vpamo**2/vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     & ctw**2*vmaup*vpamo*mmo**4-1d0/4/ctw**2*vmaup*vpamo**2/vmamo*qs*mm
     & o**2+1d0/2/ctw**2*vmaup*vpamo**2/vmamo*mmo**4-sdet3cmous/ctw**2*v
     & maup*vpamo**2/vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/8/ctw**2*vm
     & aup*vpamo**2/vmamo*qs*ts*mmo**2+1d0/8/ctw**2*vmaup*vpamo**2/vmamo
     & *qs*us*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     & *vmaup*vpamo**2/vmamo*mmo**2+1d0/4/ctw**2*vmaup*vmamo*mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*v
     & pamo**2/vmamo*us*mmo**2+1d0/2/ctw**2*vmaup*vpamo**2/vmamo*mmo**4+
     & 1d0/2/ctw**2*vmaup*vmamo*ts*mmo**2-1d0/2/ctw**2*vmaup*vmamo*ts**2
     & )
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(1d0/ctw**2*vmaup*vpamo
     & *ts*mmo**2+1d0/ctw**2*vmaup*vmamo*ts**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/ctw**2*vmaup*vpamo
     & *mmo**4+1d0/ctw**2*vmaup*vpamo**2/vmamo*us*mmo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vm
     & aup*vpamo**2/vmamo*mmo**2-1d0/4/ctw**2*vmaup*vmamo*ts)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-sdet3cmots/ctw**2*vmaup
     & *vpamo*mmo**2-1d0/2*sdet3cmots/ctw**2*vmaup*vmamo*ts-1d0/2*sdet3c
     & mous/ctw**2*vmaup*vpamo**2/vmamo*mmo**2)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpamo*
     & *2/vmamo*mmo**2-1d0/2/ctw**2*vmaup*vmamo*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vmamo*
     & ts)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpamo*
     & *2/vmamo*mmo**2)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpamo*mmo
     & **2-1d0/8/ctw**2*vmaup*vmamo*qs-1d0/2/ctw**2*vmaup*vmamo*ts-1d0/2
     & /ctw**2*vmaup*vmamo*mz**2)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpamo*mmo*
     & *2-1d0/2/ctw**2*vmaup*vpamo**2/vmamo*mmo**2+1d0/2*sdet3cmous/ctw*
     & *2*vmaup*vmamo)
     & +c0momoqswcw*(3d0/2/vmamo/qs*mw**4*rmow+1d0/4/vmamo/qs*mw**4*rmow
     & **2-7d0/4/vmamo/qs*mw**4)
     & +c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmamo)
     & +c0momoqszmoh*(3d0/8/vmamo/qs*mw**4*rmow/rwz**2-1d0/4/vmamo/qs*mw
     & **4*rmow/rwz*rhw-1d0/8/vmamo/qs*mw**4*rmow*rhw**2-1d0/2/vmamo*mw*
     & *2*rmow**2-1d0/qs*mw**4*rmow/rwz**2+1d0/qs*mw**4*rmow/rwz*rhw+mw*
     & *2*rmow/rwz)
     & +c0momoqsmozmo*(-1d0/2/stw**2/qs*mw**4*rmow+3d0/16/stw**2/qs*mw**
     & 4-1d0/2/stw**2*mw**2*rmow+1d0/2/vmamo*mw**2*rmow/rwz-5d0/2/qs*mw*
     & *4*rmow/rwz+4/qs*mw**4*rmow+51d0/16/qs*mw**4/rwz**2-61d0/16/qs*mw
     & **4/rwz-2*qs/rwz+2*qs-7d0/2*mw**2*rmow/rwz+4*mw**2*rmow+4*mw**2/r
     & wz**2-6*mw**2/rwz+2*mw**2)
     & +c0momoqsmohmo*(1d0/stw**2/qs*mw**4*rmow**2-1d0/16/stw**2/qs*mw**
     & 4*rhw**2+1d0/stw**2*mw**2*rmow**2)
     & +c0momoqscwc*(-1d0/vmamo*mw**2*rmow)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vmamo)
     & +c0ccqsczc*(1d0/stw**2*vpaup/qs**2*mw**6-1d0/stw**2*vpaup/qs*mw**
     & 4+1d0/stw**2*vpaup*qs-1d0/stw**2*vpaup*mw**2-1d0/2/stw**2*vpaup**
     & 2/qs**2*mw**6+1d0/2/stw**2*vpaup**2/qs*mw**4-1d0/2/stw**2*vpaup**
     & 2*qs+1d0/2/stw**2*vpaup**2*mw**2-1d0/2/stw**2/qs**2*mw**6+1d0/2/s
     & tw**2/qs*mw**4-1d0/2/stw**2*qs+1d0/2/stw**2*mw**2+vpaup/qs**2*mw*
     & *6/rwz**3+vpaup/qs**2*mw**6/rwz**2+vpaup/qs**2*mw**6/rwz+vpaup/qs
     & *mw**4/rwz**3-vpaup/qs*mw**4/rwz**2-vpaup/qs*mw**4/rwz+vpaup*qs/r
     & wz-2*vpaup*mw**2/rwz**2-vpaup*mw**2/rwz-1d0/2*vpaup**2/qs**2*mw**
     & 6/rwz**3-1d0/2*vpaup**2/qs**2*mw**6/rwz**2-1d0/2*vpaup**2/qs**2*m
     & w**6/rwz-1d0/2*vpaup**2/qs*mw**4/rwz**3+1d0/2*vpaup**2/qs*mw**4/r
     & wz**2+1d0/2*vpaup**2/qs*mw**4/rwz-1d0/2*vpaup**2*qs/rwz+vpaup**2*
     & mw**2/rwz**2+1d0/2*vpaup**2*mw**2/rwz-1d0/2/qs**2*mw**6/rwz**3-1d
     & 0/2/qs**2*mw**6/rwz**2-1d0/2/qs**2*mw**6/rwz-1d0/2/qs*mw**4/rwz**
     & 3+1d0/2/qs*mw**4/rwz**2+1d0/2/qs*mw**4/rwz-1d0/2*qs/rwz+mw**2/rwz
     & **2+1d0/2*mw**2/rwz)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-4*mw**2*rwz
     & -8d0/3*mw**2)
     & +a0fw*(-4/qs**2*mw**4+4/qs*mw**2*rwz+8d0/3/qs*mw**2)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(-1d0/stw**2*vpaup/qs**2*mw**4+1d0/2/stw**2*vpaup/qs*mw**2+
     & 3d0/2/stw**2*vpaup+1d0/2/stw**2*vpaup**2/qs**2*mw**4-1d0/4/stw**2
     & *vpaup**2/qs*mw**2-3d0/4/stw**2*vpaup**2+1d0/2/stw**2/qs**2*mw**4
     & -3d0/8/stw**2/qs*mw**2-7d0/8/stw**2-vpaup/qs**2*mw**4/rwz**2-vpau
     & p/qs**2*mw**4/rwz-vpaup/qs*mw**2/rwz**2+1d0/2*vpaup/qs*mw**2/rwz+
     & 3d0/2*vpaup/rwz+1d0/2*vpaup**2/qs**2*mw**4/rwz**2+1d0/2*vpaup**2/
     & qs**2*mw**4/rwz+1d0/2*vpaup**2/qs*mw**2/rwz**2-1d0/4*vpaup**2/qs*
     & mw**2/rwz-3d0/4*vpaup**2/rwz+1d0/2/qs**2*mw**4/rwz**2+1d0/2/qs**2
     & *mw**4/rwz+5d0/12/qs*mw**2/rwz**2+1d0/12/qs*mw**2/rwz*rhw-3d0/8/q
     & s*mw**2/rwz-7d0/8/rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(-1d0/8/stw**2/qs*mw**2*rhw-1d0/8/stw**2*rhw+1d0/12/qs*mw**
     & 2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     & +a0fmo*(-1+1d0/4/stw**2/qs*mw**2*rmow+1d0/4/stw**2/qs*mw**2+1d0/4
     & /stw**2*rmow+1d0/4/stw**2+1d0/4/qs*mw**2/rwz-1d0/qs*mw**2+1d0/4/r
     & wz)
     & +b0fmowc*(-1d0/4/stw**2/qs*mw**2*rmow-1d0/4/stw**2*rmow+1d0/4/vma
     & mo/qs*mw**2*rmow+7d0/4/vmamo/qs*mw**2)
     & +b0fmozmo*(-4+5d0/16/stw**2/qs*mw**2+1d0/8/stw**2+3d0/8/vmamo/qs*
     & mw**2*rmow/rwz+1d0/8/vmamo/qs*mw**2*rmow*rhw-1d0/qs*mw**2*rmow/rw
     & z+37d0/16/qs*mw**2/rwz-4/qs*mw**2+25d0/8/rwz)
     & +b0fmohmo*(-3d0/16/stw**2/qs*mw**2*rhw-1d0/8/stw**2*rhw-3d0/8/vma
     & mo/qs*mw**2*rmow/rwz-1d0/8/vmamo/qs*mw**2*rmow*rhw+1d0/qs*mw**2*r
     & mow/rwz)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-4*mw
     & **2*rwz-17d0/3*mw**2)
     & +b0fqsww*(1d0/4/vmamo/qs*mw**2*rmow-7d0/4/vmamo/qs*mw**2+1d0/4/vm
     & amo*rmow-4/qs**2*mw**4+4/qs*mw**2*rwz+17d0/3/qs*mw**2-1d0/12/rwz)
     & 
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(1d0/4/vmamo*rmow-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     & rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqsmomo*(3+1d0/4/stw**2/qs*mw**2*rmow+1d0/16/stw**2/qs*mw**2*r
     & hw-3d0/16/stw**2/qs*mw**2+1d0/4/stw**2*rmow-1d0/4/vmamo*rmow-35d0
     & /16/qs*mw**2/rwz+3/qs*mw**2-3/rwz)
     & +b0fqscc*(-1d0/stw**2*vpaup/qs**2*mw**4+1d0/2/stw**2*vpaup/qs*mw*
     & *2+3d0/2/stw**2*vpaup+1d0/2/stw**2*vpaup**2/qs**2*mw**4-1d0/4/stw
     & **2*vpaup**2/qs*mw**2-3d0/4/stw**2*vpaup**2+1d0/2/stw**2/qs**2*mw
     & **4-1d0/4/stw**2/qs*mw**2-3d0/4/stw**2-vpaup/qs**2*mw**4/rwz**2-v
     & paup/qs**2*mw**4/rwz-vpaup/qs*mw**2/rwz**2+1d0/2*vpaup/qs*mw**2/r
     & wz+3d0/2*vpaup/rwz+1d0/2*vpaup**2/qs**2*mw**4/rwz**2+1d0/2*vpaup*
     & *2/qs**2*mw**4/rwz+1d0/2*vpaup**2/qs*mw**2/rwz**2-1d0/4*vpaup**2/
     & qs*mw**2/rwz-3d0/4*vpaup**2/rwz+1d0/4/vmamo*rmow+1d0/2/qs**2*mw**
     & 4/rwz**2+1d0/2/qs**2*mw**4/rwz+1d0/2/qs*mw**2/rwz**2-1d0/4/qs*mw*
     & *2/rwz-3d0/4/rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-1d0/6*mw**2/rwz*rhw-mw**2/rwz*zmzzzbos-5d0/9*mw**2/rwz-4*mw*
     & *2*rwz-8d0/3*mw**2)
     & +dreal(b0pmozmo)*(1d0/4/stw**2/qs*mw**4*rmow-1d0/4/stw**2/qs*mw**
     & 4+1d0/4/stw**2*mw**2*rmow-1d0/4/stw**2*mw**2-7d0/4/qs*mw**4*rmow/
     & rwz+4/qs*mw**4*rmow-5d0/4/qs*mw**4/rwz**2+7d0/4/qs*mw**4/rwz-7d0/
     & 4*mw**2*rmow/rwz+4*mw**2*rmow-5d0/4*mw**2/rwz**2+7d0/4*mw**2/rwz)
     & 
     & +dreal(b0pmohmo)*(-1d0/4/stw**2/qs*mw**4*rmow*rhw+1d0/stw**2/qs*m
     & w**4*rmow**2-1d0/4/stw**2*mw**2*rmow*rhw+1d0/stw**2*mw**2*rmow**2
     & )
     & +dreal(b0pmocw)*(1d0/4/stw**2/qs*mw**4*rmow+1d0/4/stw**2/qs*mw**4
     & *rmow**2-1d0/2/stw**2/qs*mw**4+1d0/4/stw**2*mw**2*rmow+1d0/4/stw*
     & *2*mw**2*rmow**2-1d0/2/stw**2*mw**2)
     & +b0dwmocw*(-1d0/2/stw**2/qs*mw**2-1d0/2/stw**2)
     & +b0d1momoz*(1-1d0/4/stw**2/qs*mw**2-1d0/4/stw**2-1d0/4/qs*mw**2/r
     & wz+1d0/qs*mw**2-1d0/4/rwz)
     & +1+1d0/4/stw**2*vpaup/qs*mw**2+1d0/4/stw**2*vpaup-1d0/8/stw**2*vp
     & aup**2/qs*mw**2-1d0/8/stw**2*vpaup**2-1d0/4/stw**2/qs*mw**2*rmow-
     & 1d0/stw**2/qs*mw**2*za1bos-1d0/8/stw**2/qs*mw**2-1d0/4/stw**2*rmo
     & w-1d0/stw**2*za1bos-1d0/stw**2*deltarhobos-1d0/stw**2*deltarhofer
     & -1d0/8/stw**2+1d0/4*vpaup/qs*mw**2/rwz+1d0/4*vpaup/rwz-1d0/8*vpau
     & p**2/qs*mw**2/rwz-1d0/8*vpaup**2/rwz+1d0/2/vmamo/qs*mw**2*rmow+1d
     & 0/2/vmamo*rmow-4/qs**2*mw**4-9d0/8/qs*mw**2/rwz+4/qs*mw**2*rwz+11
     & d0/3/qs*mw**2-89d0/72/rwz-za1fer+caldzfer-2*pizgfer

      ff_ew_ld=
     & +det3imomoqs*sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(
     & -1d0/8/ctw**2*vpaup**2*vpamo**2*qs*ts+1d0/8/ctw**2*vpaup**2*vpamo
     & **2*qs*mmo**2+1d0/8/ctw**2*vpaup**2*vmamo**2*qs*us-1d0/8/ctw**2*v
     & paup**2*vmamo**2*qs*mmo**2-1d0/8/ctw**2*vmaup**2*vpamo**2*qs*us+1
     & d0/8/ctw**2*vmaup**2*vpamo**2*qs*mmo**2+1d0/8/ctw**2*vmaup**2*vma
     & mo**2*qs*ts-1d0/8/ctw**2*vmaup**2*vmamo**2*qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/4/ctw**2*
     & vpaup**2*vpamo**2*qs*ts-1d0/4/ctw**2*vpaup**2*vpamo**2*qs*mmo**2-
     & 1d0/4/ctw**2*vpaup**2*vmamo**2*qs*us+1d0/4/ctw**2*vpaup**2*vmamo*
     & *2*qs*mmo**2+1d0/4/ctw**2*vmaup**2*vpamo**2*qs*us-1d0/4/ctw**2*vm
     & aup**2*vpamo**2*qs*mmo**2-1d0/4/ctw**2*vmaup**2*vmamo**2*qs*ts+1d
     & 0/4/ctw**2*vmaup**2*vmamo**2*qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/4/ctw**2*
     & vpaup**2*vpamo**2*qs*ts+1d0/4/ctw**2*vpaup**2*vpamo**2*qs*mmo**2+
     & 1d0/4/ctw**2*vpaup**2*vmamo**2*qs*us-1d0/4/ctw**2*vpaup**2*vmamo*
     & *2*qs*mmo**2-1d0/4/ctw**2*vmaup**2*vpamo**2*qs*us+1d0/4/ctw**2*vm
     & aup**2*vpamo**2*qs*mmo**2+1d0/4/ctw**2*vmaup**2*vmamo**2*qs*ts-1d
     & 0/4/ctw**2*vmaup**2*vmamo**2*qs*mmo**2)
     & +sdet3imomoqs**2*c0momoqswcw*dreal(propizqs)*(-3*mw**2*rmow*rwz+6
     & *mw**2*rmow**2*rwz-3*mw**2*rmow**3*rwz)
     & +sdet3imomoqs**2*c0momoqswcw*(-18*mw**4*rmow*rwz-12*mw**4*rmow**2
     & *rwz+30*mw**4*rmow**3*rwz-12*mw**4*rmow**4*rwz+12*mw**4*rwz)
     & +sdet3imomoqs**2*c0momoqsmozmo*(9d0/2*mw**4*rmow/rwz**2-6*mw**4*r
     & mow/rwz+27*mw**4/rwz**3-90*mw**4/rwz**2+108*mw**4/rwz-48*mw**4)
     & +sdet3imomoqs**2*c0momoqsmohmo*(-6*mw**4*rmow*rwz*rhw**2+9d0/2*mw
     & **4*rmow*rhw**2)
     & +sdet3imomoqs**2*c0momoqscwc*(15*mw**4*rmow+12*mw**4*rmow**2+3*mw
     & **4*rmow**3+6*mw**4)
     & +sdet3imomoqs**2*b0fmowc*(6*mw**2*rmow*rwz+12*mw**2*rmow+6*mw**2*
     & rmow**2*rwz-12*mw**2*rwz+6*mw**2)
     & +sdet3imomoqs**2*b0fmozmo*(9d0/2*mw**2*rmow/rwz-6*mw**2*rmow+27*m
     & w**2/rwz**2-90*mw**2/rwz-48*mw**2*rwz+108*mw**2)
     & +sdet3imomoqs**2*b0fmohmo*(-6*mw**2*rmow*rwz*rhw+9d0/2*mw**2*rmow
     & *rhw)
     & +sdet3imomoqs**2*b0fqsww*dreal(propizqs)*(-3*rmow*rwz+3*rmow**2*r
     & wz)
     & +sdet3imomoqs**2*b0fqsww*(-6*mw**2*rmow*rwz-18*mw**2*rmow**2*rwz+
     & 12*mw**2*rmow**3*rwz+12*mw**2*rwz)
     & +sdet3imomoqs**2*b0fqsmomo*(-9d0/2*mw**2*rmow/rwz+6*mw**2*rmow*rw
     & z*rhw-9d0/2*mw**2*rmow*rhw+6*mw**2*rmow-27*mw**2/rwz**2+90*mw**2/
     & rwz+48*mw**2*rwz-108*mw**2)
     & +sdet3imomoqs**2*b0fqscc*(-9*mw**2*rmow-3*mw**2*rmow**2-6*mw**2)
     & +sdet3imomoqs*c0momoqswcw*dreal(propizqs)*(-3*rmow*rwz+rmow**2*rw
     & z+2*rwz)
     & +sdet3imomoqs*c0momoqswcw*(17*mw**2*rmow*rwz-20*mw**2*rmow**2*rwz
     & +7*mw**2*rmow**3*rwz-4*mw**2*rwz)
     & +sdet3imomoqs*c0momoqszmoh*(6*mw**2*rmow/rwz-8*mw**2*rmow-3d0/2*m
     & w**2/rwz**2-3d0/2*mw**2/rwz*rhw+2*mw**2/rwz+2*mw**2*rhw)
     & +sdet3imomoqs*c0momoqsmozmo*(-3d0/2*mw**2*rmow/rwz+2*mw**2*rmow-2
     & 4*mw**2/rwz**2+68*mw**2/rwz+32*mw**2*rwz-72*mw**2)
     & +sdet3imomoqs*c0momoqsmohmo*(6*mw**2*rmow*rwz*rhw-9d0/2*mw**2*rmo
     & w*rhw)
     & +sdet3imomoqs*c0momoqscwc*(-8*mw**2*rmow-mw**2*rmow**2-8*mw**2)
     & +sdet3imomoqs*a0fw*(1+8/qs*mw**2*rwz-4/qs*mw**2-rwz)
     & +sdet3imomoqs*a0fz*(-1-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz+32/qs*m
     & w**2*rwz-72/qs*mw**2+3d0/4/rwz)
     & +sdet3imomoqs*a0fh*(-rwz*rhw+3d0/4*rhw)
     & +sdet3imomoqs*a0fmo*(15+2*rmow*rwz-3d0/2*rmow-9d0/2/rwz-18*rwz+8*
     & rwz**2)
     & +sdet3imomoqs*b0fmowc*dreal(propizqs)*(-1d0/mw**2*rwz)
     & +sdet3imomoqs*b0fmowc*(-5+8/qs*mw**2*rwz-4/qs*mw**2-5*rmow*rwz+5*
     & rwz)
     & +sdet3imomoqs*b0fmozmo*(35-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz+32/
     & qs*mw**2*rwz-72/qs*mw**2-51d0/4/rwz-36*rwz+16*rwz**2)
     & +sdet3imomoqs*b0fmohmo*(-2+4*rmow*rwz-3*rmow+3d0/2/rwz-rwz*rhw+3d
     & 0/4*rhw)
     & +sdet3imomoqs*b0fqsww*dreal(propizqs)*(-1d0/2/mw**2*rmow*rwz+2/mw
     & **2*rwz)
     & +sdet3imomoqs*b0fqsww*(12*rmow*rwz-5*rmow**2*rwz-6*rwz)
     & +sdet3imomoqs*b0fqszh*(4-3/rwz)
     & +sdet3imomoqs*b0fqsmomo*(-23-2*rmow*rwz+3d0/2*rmow+21d0/2/rwz+18*
     & rwz-8*rwz**2)
     & +sdet3imomoqs*b0fqscc*(5+1d0/2*rmow)
     & +sdet3imomoqs*(-14-rmow*rwz+3d0/2*rmow+9d0/2/rwz+20*rwz-8*rwz**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(-
     & 1d0/2/ctw**2*vpaup**2*vpamo**2*ts+1d0/2/ctw**2*vmaup**2*vmamo**2*
     & ts)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & paup**2*vpamo**2*ts+1d0/ctw**2*vmaup**2*vmamo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/ctw**2*vp
     & aup**2*vpamo**2*ts-1d0/ctw**2*vmaup**2*vmamo**2*ts)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*
     & vpamo**2+1d0/2/ctw**2*vmaup**2*vmamo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(1
     & d0/2/ctw**2*vpaup**2*vmamo**2*us-1d0/2/ctw**2*vmaup**2*vpamo**2*u
     & s)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vp
     & aup**2*vmamo**2*us-1d0/ctw**2*vmaup**2*vpamo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & paup**2*vmamo**2*us+1d0/ctw**2*vmaup**2*vpamo**2*us)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*v
     & mamo**2-1d0/2/ctw**2*vmaup**2*vpamo**2)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(-
     & 1d0/2*sdet3cmots/ctw**2*vpaup**2*vpamo**2*ts+1d0/2*sdet3cmots/ctw
     & **2*vmaup**2*vmamo**2*ts)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(1
     & d0/2*sdet3cmous/ctw**2*vpaup**2*vmamo**2*us-1d0/2*sdet3cmous/ctw*
     & *2*vmaup**2*vpamo**2*us)
     & +sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(-1d0/2*sd
     & et3cmots/ctw**2*vpaup**2*vpamo**2*ts+1d0/2*sdet3cmots/ctw**2*vpau
     & p**2*vpamo**2*mmo**2+1d0/2*sdet3cmots/ctw**2*vmaup**2*vmamo**2*ts
     & -1d0/2*sdet3cmots/ctw**2*vmaup**2*vmamo**2*mmo**2+1d0/2*sdet3cmou
     & s/ctw**2*vpaup**2*vmamo**2*us-1d0/2*sdet3cmous/ctw**2*vpaup**2*vm
     & amo**2*mmo**2-1d0/2*sdet3cmous/ctw**2*vmaup**2*vpamo**2*us+1d0/2*
     & sdet3cmous/ctw**2*vmaup**2*vpamo**2*mmo**2)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(sdet3cmots
     & /ctw**2*vpaup**2*vpamo**2*ts-sdet3cmots/ctw**2*vmaup**2*vmamo**2*
     & ts)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(-sdet3cmou
     & s/ctw**2*vpaup**2*vmamo**2*us+sdet3cmous/ctw**2*vmaup**2*vpamo**2
     & *us)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/2/ctw**2
     & *vpaup**2*vpamo**2*qs*ts-1d0/2/ctw**2*vpaup**2*vmamo**2*qs*us+1d0
     & /2/ctw**2*vmaup**2*vpamo**2*qs*us-1d0/2/ctw**2*vmaup**2*vmamo**2*
     & qs*ts)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     & tw**2*vpaup**2*vpamo*vmamo*ts+1d0/2/ctw**2*vpaup**2*vpamo**2*mmo*
     & *2-1d0/2/ctw**2*vmaup**2*vpamo*vmamo*ts-1d0/2/ctw**2*vmaup**2*vma
     & mo**2*mmo**2-5d0/4*sdet3cmots/ctw**2*vpaup**2*vpamo**2+5d0/4*sdet
     & 3cmots/ctw**2*vmaup**2*vmamo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/4*sdet3cmots
     & /ctw**2*vpaup**2*vpamo**2*qs-1d0/4*sdet3cmots/ctw**2*vmaup**2*vma
     & mo**2*qs)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     & ctw**2*vpaup**2*vpamo*vmamo*us-1d0/2/ctw**2*vpaup**2*vmamo**2*mmo
     & **2+1d0/2/ctw**2*vmaup**2*vpamo*vmamo*us+1d0/2/ctw**2*vmaup**2*vp
     & amo**2*mmo**2+5d0/4*sdet3cmous/ctw**2*vpaup**2*vmamo**2-5d0/4*sde
     & t3cmous/ctw**2*vmaup**2*vpamo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/4*sdet3cmou
     & s/ctw**2*vpaup**2*vmamo**2*qs+1d0/4*sdet3cmous/ctw**2*vmaup**2*vp
     & amo**2*qs)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2
     & *vpaup**2*vpamo**2-1d0/4/ctw**2*vpaup**2*vmamo**2+1d0/4/ctw**2*vm
     & aup**2*vpamo**2-1d0/4/ctw**2*vmaup**2*vmamo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2
     & *vpamo*vmamo*ts-1d0/2/ctw**2*vpaup**2*vpamo*vmamo*us-1d0/4/ctw**2
     & *vpaup**2*vpamo**2*qs-1d0/ctw**2*vpaup**2*vpamo**2*ts+1d0/4/ctw**
     & 2*vpaup**2*vmamo**2*qs+1d0/ctw**2*vpaup**2*vmamo**2*us-1d0/2/ctw*
     & *2*vmaup**2*vpamo*vmamo*ts+1d0/2/ctw**2*vmaup**2*vpamo*vmamo*us-1
     & d0/4/ctw**2*vmaup**2*vpamo**2*qs-1d0/ctw**2*vmaup**2*vpamo**2*us+
     & 1d0/4/ctw**2*vmaup**2*vmamo**2*qs+1d0/ctw**2*vmaup**2*vmamo**2*ts
     & )
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/ctw**2*vpaup**2*v
     & pamo*vmamo*ts+3d0/2/ctw**2*vpaup**2*vpamo**2*ts+1d0/2/ctw**2*vpau
     & p**2*vpamo**2*mmo**2+1d0/ctw**2*vmaup**2*vpamo*vmamo*ts-3d0/2/ctw
     & **2*vmaup**2*vmamo**2*ts-1d0/2/ctw**2*vmaup**2*vmamo**2*mmo**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/ctw**2*vpaup**2*vp
     & amo*vmamo*us-3d0/2/ctw**2*vpaup**2*vmamo**2*us-1d0/2/ctw**2*vpaup
     & **2*vmamo**2*mmo**2-1d0/ctw**2*vmaup**2*vpamo*vmamo*us+3d0/2/ctw*
     & *2*vmaup**2*vpamo**2*us+1d0/2/ctw**2*vmaup**2*vpamo**2*mmo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(1d0/4/ctw**2*vp
     & aup**2*vpamo**2-1d0/4/ctw**2*vpaup**2*vmamo**2+1d0/4/ctw**2*vmaup
     & **2*vpamo**2-1d0/4/ctw**2*vmaup**2*vmamo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vp
     & amo*vmamo*ts-1d0/2/ctw**2*vpaup**2*vpamo*vmamo*us+1d0/4/ctw**2*vp
     & aup**2*vpamo**2*qs-1d0/4/ctw**2*vpaup**2*vmamo**2*qs-1d0/2/ctw**2
     & *vmaup**2*vpamo*vmamo*ts+1d0/2/ctw**2*vmaup**2*vpamo*vmamo*us+1d0
     & /4/ctw**2*vmaup**2*vpamo**2*qs-1d0/4/ctw**2*vmaup**2*vmamo**2*qs-
     & 1d0/2*sdet3cmots/ctw**2*vpaup**2*vpamo**2+1d0/2*sdet3cmots/ctw**2
     & *vmaup**2*vmamo**2+1d0/2*sdet3cmous/ctw**2*vpaup**2*vmamo**2-1d0/
     & 2*sdet3cmous/ctw**2*vmaup**2*vpamo**2)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2/ctw**2*vpaup**2*vpamo*v
     & mamo-1d0/2/ctw**2*vpaup**2*vpamo**2-1d0/2/ctw**2*vmaup**2*vpamo*v
     & mamo+1d0/2/ctw**2*vmaup**2*vmamo**2)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vpaup**2*vpamo*
     & vmamo+1d0/2/ctw**2*vpaup**2*vmamo**2+1d0/2/ctw**2*vmaup**2*vpamo*
     & vmamo-1d0/2/ctw**2*vmaup**2*vpamo**2)
     & +c0momoqswcw*(3*rmow*rwz-rmow**2*rwz-2*rwz)
     & +c0momoqszmoh*(3d0/2/qs*mw**2/rwz**2-3d0/2/qs*mw**2/rwz*rhw-2/qs*
     & mw**2/rwz+2/qs*mw**2*rhw)
     & +c0momoqsmozmo*(-4+3/rwz)
     & +c0momoqscwc*(2)
     & +b0fmowc*(1d0/mw**2*rwz)
     & +b0fmozmo*(3d0/2/qs/rwz-2/qs)
     & +b0fmohmo*(-3d0/2/qs/rwz+2/qs)
     & +b0fqsww*(1d0/2/mw**2*rmow*rwz-2/mw**2*rwz)
     & +b0dwmocw*(-2/qs*rwz+1d0/qs)
     & +b0d1momoz*(9d0/2/qs/rwz+18/qs*rwz-8/qs*rwz**2-15/qs)

      ff_ew_qd =
     & +det3imomoqs*sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(
     & 1d0/8/ctw**2*vmaup*vpamo**2*qs*us-1d0/8/ctw**2*vmaup*vpamo**2*qs*
     & mmo**2-1d0/8/ctw**2*vmaup*vmamo**2*qs*ts+1d0/8/ctw**2*vmaup*vmamo
     & **2*qs*mmo**2)
     & +det3imomoqs*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/4/ctw**2
     & *vmaup*vpamo**2*qs*us+1d0/4/ctw**2*vmaup*vpamo**2*qs*mmo**2+1d0/4
     & /ctw**2*vmaup*vmamo**2*qs*ts-1d0/4/ctw**2*vmaup*vmamo**2*qs*mmo**
     & 2)
     & +det3imomoqs*sdet4imotsus*b0fqszz*dreal(propizqs)*(1d0/4/ctw**2*v
     & maup*vpamo**2*qs*us-1d0/4/ctw**2*vmaup*vpamo**2*qs*mmo**2-1d0/4/c
     & tw**2*vmaup*vmamo**2*qs*ts+1d0/4/ctw**2*vmaup*vmamo**2*qs*mmo**2)
     & 
     & +sdet3imomoqs**2*c0momoqswcw*(-12/qs*mw**6-3*mw**4*rmow+15d0/2*mw
     & **4*rmow**2-3*mw**4*rmow**3-9d0/2*mw**4)
     & +sdet3imomoqs**2*c0momoqsmozmo*(30/qs*mw**6/rwz**3-72/qs*mw**6/rw
     & z**2+48/qs*mw**6/rwz+9d0/2*mw**4*rmow/rwz**2+27*mw**4/rwz**3-123d
     & 0/2*mw**4/rwz**2+36*mw**4/rwz)
     & +sdet3imomoqs**2*c0momoqsmohmo*(9d0/2*mw**4*rmow*rhw**2-3d0/2*mw*
     & *4*rhw**2)
     & +sdet3imomoqs**2*c0momoqscwc*(15*mw**4*rmow+12*mw**4*rmow**2+3*mw
     & **4*rmow**3+6*mw**4)
     & +sdet3imomoqs**2*b0fmowc*(12/qs*mw**4+27d0/2*mw**2*rmow+15d0/2*mw
     & **2)
     & +sdet3imomoqs**2*b0fmozmo*(30/qs*mw**4/rwz**2-72/qs*mw**4/rwz+48/
     & qs*mw**4+9d0/2*mw**2*rmow/rwz+27*mw**2/rwz**2-123d0/2*mw**2/rwz+3
     & 6*mw**2)
     & +sdet3imomoqs**2*b0fmohmo*(9d0/2*mw**2*rmow*rhw-3d0/2*mw**2*rhw)
     & +sdet3imomoqs**2*b0fqsww*(-12/qs*mw**4-9d0/2*mw**2*rmow+3*mw**2*r
     & mow**2-3d0/2*mw**2)
     & +sdet3imomoqs**2*b0fqsmomo*(-30/qs*mw**4/rwz**2+72/qs*mw**4/rwz-4
     & 8/qs*mw**4-9d0/2*mw**2*rmow/rwz-9d0/2*mw**2*rmow*rhw-27*mw**2/rwz
     & **2+123d0/2*mw**2/rwz+3d0/2*mw**2*rhw-36*mw**2)
     & +sdet3imomoqs**2*b0fqscc*(-9*mw**2*rmow-3*mw**2*rmow**2-6*mw**2)
     & +sdet3imomoqs*c0momoqswcw*(17d0/2/qs*mw**4-25d0/8*mw**2*rmow+mw**
     & 2*rmow**2+7d0/2*mw**2)
     & +sdet3imomoqs*c0momoqszmoh*(6*mw**2*rmow/rwz-8*mw**2*rmow-3d0/2*m
     & w**2/rwz**2-3d0/2*mw**2/rwz*rhw+2*mw**2/rwz+2*mw**2*rhw)
     & +sdet3imomoqs*c0momoqsmozmo*(-45d0/2/qs*mw**4/rwz**2+48/qs*mw**4/
     & rwz-32/qs*mw**4-3d0/2*mw**2*rmow/rwz-24*mw**2/rwz**2+89d0/2*mw**2
     & /rwz-24*mw**2)
     & +sdet3imomoqs*c0momoqsmohmo*(3d0/2/qs*mw**4*rhw**2-9d0/2*mw**2*rm
     & ow*rhw+3d0/2*mw**2*rhw)
     & +sdet3imomoqs*c0momoqscwc*(-8*mw**2*rmow-mw**2*rmow**2-8*mw**2)
     & +sdet3imomoqs*a0fw*(1-8/qs**2*mw**4-3/qs*mw**2)
     & +sdet3imomoqs*a0fz*(-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/rwz-32/
     & qs**2*mw**4-18/qs*mw**2/rwz**2+41/qs*mw**2/rwz-24/qs*mw**2+3d0/4/
     & rwz)
     & +sdet3imomoqs*a0fh*(1d0/qs*mw**2*rhw+3d0/4*rhw)
     & +sdet3imomoqs*a0fmo*(21d0/2-5/qs*mw**2/rwz-8/qs*mw**2*rwz+12/qs*m
     & w**2-3d0/2*rmow-9d0/2/rwz-6*rwz)
     & +sdet3imomoqs*b0fmowc*(-47d0/8-8/qs**2*mw**4-21d0/2/qs*mw**2)
     & +sdet3imomoqs*b0fmozmo*(22-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/r
     & wz-32/qs**2*mw**4-18/qs*mw**2/rwz**2+57d0/2/qs*mw**2/rwz-16/qs*mw
     & **2*rwz-51d0/4/rwz-12*rwz)
     & +sdet3imomoqs*b0fmohmo*(-1+5d0/2/qs*mw**2*rhw-3*rmow+3d0/2/rwz+3d
     & 0/4*rhw)
     & +sdet3imomoqs*b0fqsww*(15d0/8+15d0/2/qs*mw**2-1d0/2*rmow)
     & +sdet3imomoqs*b0fqszh*(4-3/rwz)
     & +sdet3imomoqs*b0fqsmomo*(-29d0/2+15d0/2/qs*mw**2/rwz+8/qs*mw**2*r
     & wz-3d0/2/qs*mw**2*rhw-12/qs*mw**2+3d0/2*rmow+21d0/2/rwz+6*rwz)
     & +sdet3imomoqs*b0fqscc*(5+1d0/2*rmow)
     & +sdet3imomoqs*(-37d0/4+5/qs*mw**2/rwz+8/qs*mw**2*rwz-14/qs*mw**2+
     & 3d0/2*rmow+9d0/2/rwz+6*rwz)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(-
     & 1d0/2/ctw**2*vmaup*vmamo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & maup*vmamo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/ctw**2*vm
     & aup*vmamo**2*ts)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vma
     & mo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(1
     & d0/2/ctw**2*vmaup*vpamo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & aup*vpamo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & maup*vpamo**2*us)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpam
     & o**2)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc**2*(-
     & 1d0/2*sdet3cmots/ctw**2*vmaup*vmamo**2*ts)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc**2*(1
     & d0/2*sdet3cmous/ctw**2*vmaup*vpamo**2*us)
     & +sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(-1d0/2*sd
     & et3cmots/ctw**2*vmaup*vmamo**2*ts+1d0/2*sdet3cmots/ctw**2*vmaup*v
     & mamo**2*mmo**2+1d0/2*sdet3cmous/ctw**2*vmaup*vpamo**2*us-1d0/2*sd
     & et3cmous/ctw**2*vmaup*vpamo**2*mmo**2)
     & +sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*pxx2zqsc*(sdet3cmots
     & /ctw**2*vmaup*vmamo**2*ts)
     & +sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*pxx2zqsc*(-sdet3cmou
     & s/ctw**2*vmaup*vpamo**2*us)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/2/ctw**
     & 2*vmaup*vpamo**2*qs*us+1d0/2/ctw**2*vmaup*vmamo**2*qs*ts)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*pxx2zqsc*(1d0/2/c
     & tw**2*vmaup*vpamo*vmamo*ts+1d0/2/ctw**2*vmaup*vmamo**2*mmo**2-5d0
     & /4*sdet3cmots/ctw**2*vmaup*vmamo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/4*sdet3cmots
     & /ctw**2*vmaup*vmamo**2*qs)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*pxx2zqsc*(-1d0/2/
     & ctw**2*vmaup*vpamo*vmamo*us-1d0/2/ctw**2*vmaup*vpamo**2*mmo**2+5d
     & 0/4*sdet3cmous/ctw**2*vmaup*vpamo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/4*sdet3cmou
     & s/ctw**2*vmaup*vpamo**2*qs)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**
     & 2*vmaup*vpamo**2+1d0/4/ctw**2*vmaup*vmamo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vp
     & amo*vmamo*ts-1d0/2/ctw**2*vmaup*vpamo*vmamo*us+1d0/4/ctw**2*vmaup
     & *vpamo**2*qs+1d0/ctw**2*vmaup*vpamo**2*us-1d0/4/ctw**2*vmaup*vmam
     & o**2*qs-1d0/ctw**2*vmaup*vmamo**2*ts)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/ctw**2*vmaup*vpam
     & o*vmamo*ts+3d0/2/ctw**2*vmaup*vmamo**2*ts+1d0/2/ctw**2*vmaup*vmam
     & o**2*mmo**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/ctw**2*vmaup*vpamo
     & *vmamo*us-3d0/2/ctw**2*vmaup*vpamo**2*us-1d0/2/ctw**2*vmaup*vpamo
     & **2*mmo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*pxx2zqsc*(-1d0/4/ctw**2*v
     & maup*vpamo**2+1d0/4/ctw**2*vmaup*vmamo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpamo
     & *vmamo*ts-1d0/2/ctw**2*vmaup*vpamo*vmamo*us-1d0/4/ctw**2*vmaup*vp
     & amo**2*qs+1d0/4/ctw**2*vmaup*vmamo**2*qs-1d0/2*sdet3cmots/ctw**2*
     & vmaup*vmamo**2+1d0/2*sdet3cmous/ctw**2*vmaup*vpamo**2)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmaup*vpamo*vmam
     & o-1d0/2/ctw**2*vmaup*vmamo**2)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmaup*vpamo*vma
     & mo+1d0/2/ctw**2*vmaup*vpamo**2)
     & +c0momoqswcw*(1d0/8/qs*mw**2*rmow-3d0/2/qs*mw**2)
     & +c0momoqszmoh*(3d0/2/qs*mw**2/rwz**2-3d0/2/qs*mw**2/rwz*rhw-2/qs*
     & mw**2/rwz+2/qs*mw**2*rhw)
     & +c0momoqsmozmo*(-2+3d0/2/qs*mw**2/rwz+3/rwz)
     & +c0momoqsmohmo*(-3d0/2/qs*mw**2*rhw)
     & +c0momoqscwc*(2)
     & +a0fmo*(-1d0/2/qs)
     & +b0fmowc*(-1d0/8/qs)
     & +b0fmozmo*(3d0/2/qs/rwz-2/qs)
     & +b0fmohmo*(-3d0/2/qs/rwz+1d0/qs)
     & +b0fqsww*(1d0/8/qs)
     & +b0fqsmomo*(1d0/2/qs)
     & +b0dwmocw*(2/qs**2*mw**2+1d0/qs)
     & +b0d1momoz*(5/qs**2*mw**2/rwz+8/qs**2*mw**2*rwz-12/qs**2*mw**2+9d
     & 0/2/qs/rwz+6/qs*rwz-10/qs)
     & +1d0/4/qs

      ffarray(1,1) = ff_qed_ll
      ffarray(1,2) = ff_ew_ll
      ffarray(1,3) = ff_qed_lq
      ffarray(1,4) = ff_ew_lq
      ffarray(1,5) = ff_qed_ql
      ffarray(1,6) = ff_ew_ql
      ffarray(1,7) = ff_qed_qq
      ffarray(1,8) = ff_ew_qq
      ffarray(1,9) = ff_qed_ld
      ffarray(1,10) = ff_ew_ld
      ffarray(1,11) = ff_qed_qd
      ffarray(1,12) = ff_ew_qd
      ffarray(1,13) = ff_qed_gg

      return
      end
